namespace OpenTK.Graphics
{
    #pragma warning disable 1591

    public enum DrawElementsType
    {
        UnsignedByte = ((int)0X1401),
        UnsignedInt = ((int)0X1405),
        UnsignedShort = ((int)0X1403),
    }

    public enum AttribMask
    {
        ListBit = ((int)0X00020000),
        LightingBit = ((int)0X00000040),
        PointBit = ((int)0X00000002),
        AccumBufferBit = ((int)0X00000200),
        TransformBit = ((int)0X00001000),
        TextureBit = ((int)0X00040000),
        PixelModeBit = ((int)0X00000020),
        MultisampleBit = ((int)0X20000000),
        FogBit = ((int)0X00000080),
        EnableBit = ((int)0X00002000),
        LineBit = ((int)0X00000004),
        AllAttribBits = unchecked((int)0Xffffffff),
        ViewportBit = ((int)0X00000800),
        HintBit = ((int)0X00008000),
        StencilBufferBit = ((int)0X00000400),
        CurrentBit = ((int)0X00000001),
        ScissorBit = ((int)0X00080000),
        PolygonBit = ((int)0X00000008),
        PolygonStippleBit = ((int)0X00000010),
        ColorBufferBit = ((int)0X00004000),
        EvalBit = ((int)0X00010000),
        DepthBufferBit = ((int)0X00000100),
    }

    public enum ClearBufferMask
    {
        StencilBufferBit = ((int)0X00000400),
        AccumBufferBit = ((int)0X00000200),
        ColorBufferBit = ((int)0X00004000),
        DepthBufferBit = ((int)0X00000100),
    }

    public enum ClientAttribMask
    {
        ClientPixelStoreBit = ((int)0X00000001),
        ClientAllAttribBits = unchecked((int)0Xffffffff),
        ClientVertexArrayBit = ((int)0X00000002),
    }

    public enum Boolean
    {
        True = ((int)1),
        False = ((int)0),
    }

    public enum BeginMode
    {
        Quads = ((int)0X0007),
        QuadStrip = ((int)0X0008),
        Polygon = ((int)0X0009),
        Triangles = ((int)0X0004),
        Points = ((int)0X0000),
        LineLoop = ((int)0X0002),
        LineStrip = ((int)0X0003),
        TriangleFan = ((int)0X0006),
        TriangleStrip = ((int)0X0005),
        Lines = ((int)0X0001),
    }

    public enum AccumOp
    {
        Load = ((int)0X0101),
        Mult = ((int)0X0103),
        Return = ((int)0X0102),
        Accum = ((int)0X0100),
        Add = ((int)0X0104),
    }

    public enum AlphaFunction
    {
        Never = ((int)0X0200),
        Equal = ((int)0X0202),
        Always = ((int)0X0207),
        Less = ((int)0X0201),
        Gequal = ((int)0X0206),
        Lequal = ((int)0X0203),
        Notequal = ((int)0X0205),
        Greater = ((int)0X0204),
    }

    public enum BlendingFactorDest
    {
        ConstantColorExt = ((int)0X8001),
        OneMinusSrcAlpha = ((int)0X0303),
        One = ((int)1),
        OneMinusDstAlpha = ((int)0X0305),
        OneMinusConstantColorExt = ((int)0X8002),
        SrcColor = ((int)0X0300),
        OneMinusSrcColor = ((int)0X0301),
        ConstantAlphaExt = ((int)0X8003),
        SrcAlpha = ((int)0X0302),
        DstAlpha = ((int)0X0304),
        Zero = ((int)0),
        OneMinusConstantAlphaExt = ((int)0X8004),
    }

    public enum BlendingFactorSrc
    {
        ConstantColorExt = ((int)0X8001),
        OneMinusSrcAlpha = ((int)0X0303),
        One = ((int)1),
        SrcAlphaSaturate = ((int)0X0308),
        OneMinusConstantColorExt = ((int)0X8002),
        OneMinusDstAlpha = ((int)0X0305),
        OneMinusDstColor = ((int)0X0307),
        ConstantAlphaExt = ((int)0X8003),
        SrcAlpha = ((int)0X0302),
        DstColor = ((int)0X0306),
        Zero = ((int)0),
        DstAlpha = ((int)0X0304),
        OneMinusConstantAlphaExt = ((int)0X8004),
    }

    public enum BlendEquationModeExt
    {
        FuncSubtractExt = ((int)0X800a),
        FuncAddExt = ((int)0X8006),
        MaxExt = ((int)0X8008),
        AlphaMinSgix = ((int)0X8320),
        FuncReverseSubtractExt = ((int)0X800b),
        AlphaMaxSgix = ((int)0X8321),
        MinExt = ((int)0X8007),
        LogicOp = ((int)0X0bf1),
    }

    public enum ColorMaterialFace
    {
        Front = ((int)0X0404),
        FrontAndBack = ((int)0X0408),
        Back = ((int)0X0405),
    }

    public enum ColorMaterialParameter
    {
        Emission = ((int)0X1600),
        Specular = ((int)0X1202),
        AmbientAndDiffuse = ((int)0X1602),
        Diffuse = ((int)0X1201),
        Ambient = ((int)0X1200),
    }

    public enum ColorPointerType
    {
        UnsignedByte = ((int)0X1401),
        Byte = ((int)0X1400),
        UnsignedInt = ((int)0X1405),
        Short = ((int)0X1402),
        Int = ((int)0X1404),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        UnsignedShort = ((int)0X1403),
    }

    public enum ColorTableParameterPNameSgi
    {
        ColorTableScaleSgi = ((int)0X80D6),
        ColorTableBiasSgi = ((int)0X80D7),
    }

    public enum ColorTableTargetSgi
    {
        ProxyTextureColorTableSgi = ((int)0X80bd),
        PostColorMatrixColorTableSgi = ((int)0X80D2),
        ProxyPostConvolutionColorTableSgi = ((int)0X80D4),
        TextureColorTableSgi = ((int)0X80bc),
        PostConvolutionColorTableSgi = ((int)0X80D1),
        ProxyPostColorMatrixColorTableSgi = ((int)0X80D5),
        ProxyColorTableSgi = ((int)0X80D3),
        ColorTableSgi = ((int)0X80D0),
    }

    public enum ConvolutionBorderModeExt
    {
        ReduceExt = ((int)0X8016),
    }

    public enum ConvolutionParameterExt
    {
        ConvolutionFilterBiasExt = ((int)0X8015),
        ConvolutionFilterScaleExt = ((int)0X8014),
        ConvolutionBorderModeExt = ((int)0X8013),
    }

    public enum ConvolutionTargetExt
    {
        Convolution2DExt = ((int)0X8011),
        Convolution1DExt = ((int)0X8010),
    }

    public enum CullFaceMode
    {
        Front = ((int)0X0404),
        FrontAndBack = ((int)0X0408),
        Back = ((int)0X0405),
    }

    public enum DepthFunction
    {
        Never = ((int)0X0200),
        Equal = ((int)0X0202),
        Always = ((int)0X0207),
        Less = ((int)0X0201),
        Gequal = ((int)0X0206),
        Lequal = ((int)0X0203),
        Notequal = ((int)0X0205),
        Greater = ((int)0X0204),
    }

    public enum DrawBufferMode
    {
        FrontRight = ((int)0X0401),
        Right = ((int)0X0407),
        BackLeft = ((int)0X0402),
        BackRight = ((int)0X0403),
        Left = ((int)0X0406),
        Aux0 = ((int)0X0409),
        FrontAndBack = ((int)0X0408),
        Back = ((int)0X0405),
        Aux3 = ((int)0X040c),
        Aux1 = ((int)0X040a),
        FrontLeft = ((int)0X0400),
        None = ((int)0),
        Aux2 = ((int)0X040b),
        Front = ((int)0X0404),
    }

    public enum EnableCap
    {
        Light1 = ((int)0X4001),
        SampleAlphaToOneSgis = ((int)0X809f),
        FragmentLight6Sgix = ((int)0X8412),
        ColorMaterial = ((int)0X0b57),
        RescaleNormal = ((int)0X803a),
        PolygonOffsetFill = ((int)0X8037),
        Texture3DExt = ((int)0X806f),
        FragmentLight7Sgix = ((int)0X8413),
        Lighting = ((int)0X0b50),
        FragmentLight3Sgix = ((int)0X840f),
        FragmentLightingSgix = ((int)0X8400),
        PolygonStipple = ((int)0X0b42),
        CullFace = ((int)0X0b44),
        PostConvolutionColorTableSgi = ((int)0X80D1),
        Map1Normal = ((int)0X0D92),
        Multisample = ((int)0X809d),
        SampleMaskSgis = ((int)0X80a0),
        FragmentLight0Sgix = ((int)0X840c),
        FogOffsetSgix = ((int)0X8198),
        SampleAlphaToCoverage = ((int)0X809e),
        FogCoordArray = ((int)0X8457),
        Map2Normal = ((int)0X0Db2),
        Fog = ((int)0X0b60),
        PolygonOffsetPoint = ((int)0X2a01),
        TextureGenT = ((int)0X0c61),
        NormalArray = ((int)0X8075),
        Convolution2DExt = ((int)0X8011),
        ClipPlane3 = ((int)0X3003),
        AsyncHistogramSgix = ((int)0X832c),
        Light5 = ((int)0X4005),
        Light0 = ((int)0X4000),
        StencilTest = ((int)0X0b90),
        ClipPlane0 = ((int)0X3000),
        SampleAlphaToOne = ((int)0X809f),
        SampleAlphaToMaskSgis = ((int)0X809e),
        Map1TextureCoord4 = ((int)0X0D96),
        Map1TextureCoord2 = ((int)0X0D94),
        Map1TextureCoord3 = ((int)0X0D95),
        Map1TextureCoord1 = ((int)0X0D93),
        Map2TextureCoord4 = ((int)0X0Db6),
        Map2TextureCoord2 = ((int)0X0Db4),
        Map2TextureCoord3 = ((int)0X0Db5),
        ScissorTest = ((int)0X0c11),
        Map2TextureCoord1 = ((int)0X0Db3),
        RescaleNormalExt = ((int)0X803a),
        ColorTableSgi = ((int)0X80D0),
        FragmentColorMaterialSgix = ((int)0X8401),
        Map2Vertex4 = ((int)0X0Db8),
        HistogramExt = ((int)0X8024),
        Map2Vertex3 = ((int)0X0Db7),
        TextureCoordArray = ((int)0X8078),
        DepthTest = ((int)0X0b71),
        VertexProgramTwoSide = ((int)0X8643),
        IndexArray = ((int)0X8077),
        ReferencePlaneSgix = ((int)0X817D),
        PixelTexGenSgix = ((int)0X8139),
        PixelTextureSgis = ((int)0X8353),
        IrInstrument1Sgix = ((int)0X817f),
        IndexLogicOp = ((int)0X0bf1),
        Map1Vertex4 = ((int)0X0D98),
        PointSprite = ((int)0X8861),
        Map1Vertex3 = ((int)0X0D97),
        AutoNormal = ((int)0X0D80),
        Dither = ((int)0X0bd0),
        SpriteSgix = ((int)0X8148),
        Light3 = ((int)0X4003),
        AsyncReadPixelsSgix = ((int)0X835e),
        ClipPlane1 = ((int)0X3001),
        ColorSum = ((int)0X8458),
        TextureCubeMap = ((int)0X8513),
        EdgeFlagArray = ((int)0X8079),
        SharedTexturePaletteExt = ((int)0X81fb),
        LineStipple = ((int)0X0b24),
        PolygonSmooth = ((int)0X0b41),
        Map2Color4 = ((int)0X0Db0),
        ColorLogicOp = ((int)0X0bf2),
        Map2Index = ((int)0X0Db1),
        Convolution1DExt = ((int)0X8010),
        LineSmooth = ((int)0X0b20),
        Texture1D = ((int)0X0De0),
        FragmentLight4Sgix = ((int)0X8410),
        AsyncDrawPixelsSgix = ((int)0X835D),
        VertexProgramPointSize = ((int)0X8642),
        PointSmooth = ((int)0X0b10),
        VertexArray = ((int)0X8074),
        Light4 = ((int)0X4004),
        TextureGenR = ((int)0X0c62),
        TextureGenQ = ((int)0X0c63),
        Map1Index = ((int)0X0D91),
        Light7 = ((int)0X4007),
        FragmentLight5Sgix = ((int)0X8411),
        Light2 = ((int)0X4002),
        ClipPlane2 = ((int)0X3002),
        TextureColorTableSgi = ((int)0X80bc),
        ClipPlane5 = ((int)0X3005),
        ClipPlane4 = ((int)0X3004),
        FragmentLight2Sgix = ((int)0X840e),
        Separable2DExt = ((int)0X8012),
        Map1Color4 = ((int)0X0D90),
        Texture2D = ((int)0X0De1),
        InterlaceSgix = ((int)0X8094),
        SampleCoverage = ((int)0X80a0),
        Normalize = ((int)0X0ba1),
        AlphaTest = ((int)0X0bc0),
        MinmaxExt = ((int)0X802e),
        Blend = ((int)0X0be2),
        ColorArray = ((int)0X8076),
        TextureGenS = ((int)0X0c60),
        FragmentLight1Sgix = ((int)0X840D),
        PostColorMatrixColorTableSgi = ((int)0X80D2),
        CalligraphicFragmentSgix = ((int)0X8183),
        Light6 = ((int)0X4006),
        SecondaryColorArray = ((int)0X845e),
        PolygonOffsetLine = ((int)0X2a02),
        AsyncTexImageSgix = ((int)0X835c),
        FramezoomSgix = ((int)0X818b),
        Texture4DSgis = ((int)0X8134),
    }

    public enum ErrorCode
    {
        InvalidEnum = ((int)0X0500),
        NoError = ((int)0),
        InvalidOperation = ((int)0X0502),
        InvalidFramebufferOperationExt = ((int)0X0506),
        TableTooLargeExt = ((int)0X8031),
        StackOverflow = ((int)0X0503),
        OutOfMemory = ((int)0X0505),
        StackUnderflow = ((int)0X0504),
        TextureTooLargeExt = ((int)0X8065),
        InvalidValue = ((int)0X0501),
    }

    public enum FeedbackType
    {
        Gl3DColorTexture = ((int)0X0603),
        Gl3D = ((int)0X0601),
        Gl2D = ((int)0X0600),
        Gl3DColor = ((int)0X0602),
        Gl4DColorTexture = ((int)0X0604),
    }

    public enum FeedBackToken
    {
        DrawPixelToken = ((int)0X0705),
        BitmapToken = ((int)0X0704),
        CopyPixelToken = ((int)0X0706),
        PointToken = ((int)0X0701),
        LineToken = ((int)0X0702),
        LineResetToken = ((int)0X0707),
        PolygonToken = ((int)0X0703),
        PassThroughToken = ((int)0X0700),
    }

    public enum FfdMaskSgix
    {
        GeometryDeformationBitSgix = ((int)0X00000002),
        TextureDeformationBitSgix = ((int)0X00000001),
    }

    public enum FfdTargetSgix
    {
        TextureDeformationSgix = ((int)0X8195),
        GeometryDeformationSgix = ((int)0X8194),
    }

    public enum FogMode
    {
        Exp2 = ((int)0X0801),
        FogFuncSgis = ((int)0X812a),
        Exp = ((int)0X0800),
        FogCoord = ((int)0X8451),
        FragmentDepth = ((int)0X8452),
        Linear = ((int)0X2601),
    }

    public enum FogParameter
    {
        FogColor = ((int)0X0b66),
        FogEnd = ((int)0X0b64),
        FogStart = ((int)0X0b63),
        FogDensity = ((int)0X0b62),
        FogIndex = ((int)0X0b61),
        FogOffsetValueSgix = ((int)0X8199),
        FogMode = ((int)0X0b65),
        FogCoordSrc = ((int)0X8450),
    }

    public enum FragmentLightModelParameterSgix
    {
        FragmentLightModelAmbientSgix = ((int)0X840a),
        FragmentLightModelLocalViewerSgix = ((int)0X8408),
        FragmentLightModelTwoSideSgix = ((int)0X8409),
        FragmentLightModelNormalInterpolationSgix = ((int)0X840b),
    }

    public enum FrontFaceDirection
    {
        Ccw = ((int)0X0901),
        Cw = ((int)0X0900),
    }

    public enum GetColorTableParameterPNameSgi
    {
        ColorTableBiasSgi = ((int)0X80D7),
        ColorTableIntensitySizeSgi = ((int)0X80Df),
        ColorTableLuminanceSizeSgi = ((int)0X80De),
        ColorTableAlphaSizeSgi = ((int)0X80Dd),
        ColorTableBlueSizeSgi = ((int)0X80Dc),
        ColorTableScaleSgi = ((int)0X80D6),
        ColorTableWidthSgi = ((int)0X80D9),
        ColorTableFormatSgi = ((int)0X80D8),
        ColorTableRedSizeSgi = ((int)0X80Da),
        ColorTableGreenSizeSgi = ((int)0X80Db),
    }

    public enum GetConvolutionParameter
    {
        MaxConvolutionWidthExt = ((int)0X801a),
        ConvolutionHeightExt = ((int)0X8019),
        ConvolutionFormatExt = ((int)0X8017),
        MaxConvolutionHeightExt = ((int)0X801b),
        ConvolutionBorderModeExt = ((int)0X8013),
        ConvolutionWidthExt = ((int)0X8018),
        ConvolutionFilterScaleExt = ((int)0X8014),
        ConvolutionFilterBiasExt = ((int)0X8015),
    }

    public enum GetHistogramParameterPNameExt
    {
        HistogramAlphaSizeExt = ((int)0X802b),
        HistogramLuminanceSizeExt = ((int)0X802c),
        HistogramFormatExt = ((int)0X8027),
        HistogramGreenSizeExt = ((int)0X8029),
        HistogramSinkExt = ((int)0X802D),
        HistogramWidthExt = ((int)0X8026),
        HistogramBlueSizeExt = ((int)0X802a),
        HistogramRedSizeExt = ((int)0X8028),
    }

    public enum GetMapQuery
    {
        Coeff = ((int)0X0a00),
        Domain = ((int)0X0a02),
        Order = ((int)0X0a01),
    }

    public enum GetMinmaxParameterPNameExt
    {
        MinmaxSinkExt = ((int)0X8030),
        MinmaxFormatExt = ((int)0X802f),
    }

    public enum GetPixelMap
    {
        PixelMapIToI = ((int)0X0c70),
        PixelMapIToA = ((int)0X0c75),
        PixelMapIToB = ((int)0X0c74),
        PixelMapIToR = ((int)0X0c72),
        PixelMapBToB = ((int)0X0c78),
        PixelMapRToR = ((int)0X0c76),
        PixelMapIToG = ((int)0X0c73),
        PixelMapGToG = ((int)0X0c77),
        PixelMapAToA = ((int)0X0c79),
        PixelMapSToS = ((int)0X0c71),
    }

    public enum GetPointervPName
    {
        SecondaryColorArrayPointer = ((int)0X845d),
        EdgeFlagArrayPointer = ((int)0X8093),
        InstrumentBufferPointerSgix = ((int)0X8180),
        FogCoordArrayPointer = ((int)0X8456),
        FeedbackBufferPointer = ((int)0X0df0),
        VertexArrayPointer = ((int)0X808e),
        SelectionBufferPointer = ((int)0X0df3),
        ColorArrayPointer = ((int)0X8090),
        NormalArrayPointer = ((int)0X808f),
        TextureCoordArrayPointer = ((int)0X8092),
        IndexArrayPointer = ((int)0X8091),
    }

    public enum GetPName
    {
        AliasedLineWidthRange = ((int)0X846e),
        Map1TextureCoord4 = ((int)0X0d96),
        StencilBackPassDepthFail = ((int)0X8802),
        PolygonSmoothHint = ((int)0X0c53),
        DepthWritemask = ((int)0X0b72),
        PostConvolutionBlueScaleExt = ((int)0X801e),
        MaxFragmentUniformComponents = ((int)0X8b49),
        PixelMapSToSSize = ((int)0X0cb1),
        ColorArray = ((int)0X8076),
        MaxLights = ((int)0X0d31),
        DrawBuffer10 = ((int)0X882f),
        StencilValueMask = ((int)0X0b93),
        LightModelLocalViewer = ((int)0X0b51),
        IndexArrayType = ((int)0X8085),
        ClipPlane3 = ((int)0X3003),
        PixelTileGridHeightSgix = ((int)0X8143),
        MaxDrawBuffers = ((int)0X8824),
        PerspectiveCorrectionHint = ((int)0X0c50),
        SampleAlphaToCoverage = ((int)0X809e),
        PixelPackBufferBinding = ((int)0X88ed),
        Map2GridSegments = ((int)0X0dd3),
        ColorMaterialParameter = ((int)0X0b56),
        SpriteTranslationSgix = ((int)0X814b),
        Map2Normal = ((int)0X0db2),
        UnpackImageDepthSgis = ((int)0X8133),
        AsyncReadPixelsSgix = ((int)0X835e),
        PackResampleSgix = ((int)0X842c),
        DrawBuffer13 = ((int)0X8832),
        PackSkipRows = ((int)0X0d03),
        MaxTextureStackDepth = ((int)0X0d39),
        SampleMaskValueSgis = ((int)0X80aa),
        InstrumentMeasurementsSgix = ((int)0X8181),
        PointSizeMin = ((int)0X8126),
        PixelTextureSgis = ((int)0X8353),
        PointSmooth = ((int)0X0b10),
        TextureStackDepth = ((int)0X0ba5),
        MaxVaryingFloats = ((int)0X8b4b),
        Texture3DExt = ((int)0X806f),
        ModelviewStackDepth = ((int)0X0ba3),
        IndexArrayStride = ((int)0X8086),
        PostConvolutionGreenScaleExt = ((int)0X801D),
        MaxAsyncTexImageSgix = ((int)0X835f),
        UnpackSwapBytes = ((int)0X0cf0),
        PixelMapAToASize = ((int)0X0cb9),
        PostColorMatrixRedBiasSgi = ((int)0X80b8),
        MaxTextureLodBias = ((int)0X84fd),
        PackSkipVolumesSgis = ((int)0X8130),
        LineSmooth = ((int)0X0b20),
        AsyncHistogramSgix = ((int)0X832c),
        DepthBits = ((int)0X0d56),
        FragmentLightModelNormalInterpolationSgix = ((int)0X840b),
        LineSmoothHint = ((int)0X0c52),
        ShadeModel = ((int)0X0b54),
        PixelTileBestAlignmentSgix = ((int)0X813e),
        MaxClipmapVirtualDepthSgix = ((int)0X8178),
        PixelTileHeightSgix = ((int)0X8141),
        CurrentSecondaryColor = ((int)0X8459),
        MaxAsyncReadPixelsSgix = ((int)0X8361),
        Texture1D = ((int)0X0de0),
        ColorClearValue = ((int)0X0c22),
        MaxProjectionStackDepth = ((int)0X0d38),
        AlphaTestRef = ((int)0X0bc2),
        ListIndex = ((int)0X0b33),
        Light1 = ((int)0X4001),
        PackSkipImagesExt = ((int)0X806b),
        PostConvolutionColorTableSgi = ((int)0X80D1),
        DepthBias = ((int)0X0d1f),
        VertexAttribArrayBufferBinding = ((int)0X889f),
        PackSkipPixels = ((int)0X0d04),
        MaxModelviewStackDepth = ((int)0X0d36),
        Max3DTextureSize = ((int)0X8073),
        PixelMapIToISize = ((int)0X0cb0),
        NormalArrayStride = ((int)0X807f),
        MaxElementsVertices = ((int)0X80e8),
        MaxColorAttachmentsExt = ((int)0X8cdf),
        FragmentLightModelTwoSideSgix = ((int)0X8409),
        EdgeFlagArrayCountExt = ((int)0X808D),
        CullFace = ((int)0X0b44),
        LightModelTwoSide = ((int)0X0b52),
        UnpackImageHeightExt = ((int)0X806e),
        SampleBuffers = ((int)0X80a8),
        FogIndex = ((int)0X0b61),
        FragmentColorMaterialParameterSgix = ((int)0X8403),
        ZoomY = ((int)0X0d17),
        Samples = ((int)0X80a9),
        DepthTest = ((int)0X0b71),
        LogicOpMode = ((int)0X0bf0),
        AsyncTexImageSgix = ((int)0X835c),
        SmoothPointSizeRange = ((int)0X0b12),
        Light4 = ((int)0X4004),
        RedScale = ((int)0X0d14),
        StencilBits = ((int)0X0d57),
        UnpackCmykHintExt = ((int)0X800f),
        SampleCoverageValue = ((int)0X80aa),
        DrawBuffer8 = ((int)0X882d),
        DrawBuffer9 = ((int)0X882e),
        ElementArrayBufferBinding = ((int)0X8895),
        DrawBuffer5 = ((int)0X882a),
        PostConvolutionRedBiasExt = ((int)0X8020),
        DrawBuffer1 = ((int)0X8826),
        BlueScale = ((int)0X0d1a),
        MaxVertexUniformComponents = ((int)0X8b4a),
        FramebufferBindingExt = ((int)0X8ca6),
        BlueBias = ((int)0X0d1b),
        SampleMaskSgis = ((int)0X80a0),
        Texture4DBindingSgis = ((int)0X814f),
        MaxPixelMapTable = ((int)0X0d34),
        SpriteSgix = ((int)0X8148),
        SmoothLineWidthGranularity = ((int)0X0b23),
        UnpackSkipVolumesSgis = ((int)0X8132),
        MaxTextureCoords = ((int)0X8871),
        AccumAlphaBits = ((int)0X0d5b),
        Separable2DExt = ((int)0X8012),
        DrawBuffer6 = ((int)0X882b),
        DrawBuffer7 = ((int)0X882c),
        DrawBuffer4 = ((int)0X8829),
        ClientAttribStackDepth = ((int)0X0bb1),
        DrawBuffer2 = ((int)0X8827),
        DrawBuffer3 = ((int)0X8828),
        DrawBuffer0 = ((int)0X8825),
        PixelMapIToASize = ((int)0X0cb5),
        PixelTileCacheSizeSgix = ((int)0X8145),
        IndexWritemask = ((int)0X0c21),
        Blend = ((int)0X0be2),
        ListBase = ((int)0X0b32),
        MaxAttribStackDepth = ((int)0X0d35),
        ColorArrayStride = ((int)0X8083),
        DepthScale = ((int)0X0d1e),
        PointSprite = ((int)0X8861),
        PixelTileCacheIncrementSgix = ((int)0X813f),
        ConvolutionHintSgix = ((int)0X8316),
        DepthClearValue = ((int)0X0b73),
        NormalArrayBufferBinding = ((int)0X8897),
        AccumRedBits = ((int)0X0d58),
        PostColorMatrixRedScaleSgi = ((int)0X80b4),
        ClipPlane1 = ((int)0X3001),
        PolygonOffsetBiasExt = ((int)0X8039),
        ArrayBufferBinding = ((int)0X8894),
        PackCmykHintExt = ((int)0X800e),
        TextureMatrix = ((int)0X0ba8),
        ActiveTexture = ((int)0X84e0),
        UnpackAlignment = ((int)0X0cf5),
        Texture2D = ((int)0X0de1),
        ColorMaterial = ((int)0X0b57),
        PointSizeMax = ((int)0X8127),
        AsyncDrawPixelsSgix = ((int)0X835D),
        UnpackLsbFirst = ((int)0X0cf1),
        MaxClipPlanes = ((int)0X0d32),
        Light6 = ((int)0X4006),
        GenerateMipmapHintSgis = ((int)0X8192),
        Map1GridDomain = ((int)0X0dd0),
        ProjectionStackDepth = ((int)0X0ba4),
        PixelMapGToGSize = ((int)0X0cb7),
        CurrentRasterTextureCoords = ((int)0X0b06),
        TextureCoordArray = ((int)0X8078),
        TextureColorTableSgi = ((int)0X80bc),
        IndexBits = ((int)0X0d51),
        Max4DTextureSizeSgis = ((int)0X8138),
        BlendColorExt = ((int)0X8005),
        SpriteAxisSgix = ((int)0X814a),
        RgbaMode = ((int)0X0c31),
        FogDensity = ((int)0X0b62),
        PostConvolutionRedScaleExt = ((int)0X801c),
        StencilBackFunc = ((int)0X8800),
        Map2Vertex4 = ((int)0X0db8),
        ColorWritemask = ((int)0X0c23),
        Map2Vertex3 = ((int)0X0db7),
        MultisampleSgis = ((int)0X809D),
        PostConvolutionAlphaScaleExt = ((int)0X801f),
        MatrixMode = ((int)0X0ba0),
        BlendSrcRgb = ((int)0X80c9),
        SharedTexturePaletteExt = ((int)0X81fb),
        IndexLogicOp = ((int)0X0bf1),
        Convolution2DExt = ((int)0X8011),
        Max3DTextureSizeExt = ((int)0X8073),
        PackAlignment = ((int)0X0d05),
        LineStippleRepeat = ((int)0X0b26),
        RenderbufferBindingExt = ((int)0X8ca7),
        MaxVertexTextureImageUnits = ((int)0X8b4c),
        ClipPlane4 = ((int)0X3004),
        PolygonSmooth = ((int)0X0b41),
        IndexShift = ((int)0X0d12),
        FogColor = ((int)0X0b66),
        FragmentLight0Sgix = ((int)0X840c),
        PostConvolutionAlphaBiasExt = ((int)0X8023),
        LineWidth = ((int)0X0b21),
        DrawBuffer12 = ((int)0X8831),
        ReferencePlaneSgix = ((int)0X817D),
        SampleAlphaToOneSgis = ((int)0X809f),
        MaxElementsIndices = ((int)0X80e9),
        LineStipple = ((int)0X0b24),
        CalligraphicFragmentSgix = ((int)0X8183),
        PackRowLength = ((int)0X0d02),
        Light3 = ((int)0X4003),
        SpriteModeSgix = ((int)0X8149),
        PixelTileGridWidthSgix = ((int)0X8142),
        PolygonOffsetFactor = ((int)0X8038),
        PixelTileGridDepthSgix = ((int)0X8144),
        PixelTexGenModeSgix = ((int)0X832b),
        BlueBits = ((int)0X0d54),
        DrawBuffer14 = ((int)0X8833),
        BlendDstRgb = ((int)0X80c8),
        SelectionBufferSize = ((int)0X0df4),
        TextureCoordArrayBufferBinding = ((int)0X889a),
        Convolution1DExt = ((int)0X8010),
        VertexArraySize = ((int)0X807a),
        BlendEquationExt = ((int)0X8009),
        Map2GridDomain = ((int)0X0dd2),
        CurrentRasterSecondaryColor = ((int)0X845f),
        MapStencil = ((int)0X0d11),
        PostColorMatrixBlueBiasSgi = ((int)0X80ba),
        LightEnvModeSgix = ((int)0X8407),
        PixelMapIToBSize = ((int)0X0cb4),
        Map1Color4 = ((int)0X0d90),
        UnpackResampleSgix = ((int)0X842D),
        DistanceAttenuationSgis = ((int)0X8129),
        ProjectionMatrix = ((int)0X0ba7),
        Normalize = ((int)0X0ba1),
        IrInstrument1Sgix = ((int)0X817f),
        VertexArray = ((int)0X8074),
        StencilClearValue = ((int)0X0b91),
        IndexArrayBufferBinding = ((int)0X8899),
        MaxAsyncDrawPixelsSgix = ((int)0X8360),
        CurrentIndex = ((int)0X0b01),
        SampleBuffersSgis = ((int)0X80a8),
        RedBits = ((int)0X0d52),
        SecondaryColorArrayType = ((int)0X845b),
        SamplePatternSgis = ((int)0X80ac),
        StencilTest = ((int)0X0b90),
        StencilBackWritemask = ((int)0X8ca5),
        PointSizeRange = ((int)0X0b12),
        AccumBlueBits = ((int)0X0d5a),
        Stereo = ((int)0X0c33),
        UnpackSubsampleRateSgix = ((int)0X85a1),
        TextureCompressionHint = ((int)0X84ef),
        PointSize = ((int)0X0b11),
        ColorArrayType = ((int)0X8082),
        MapColor = ((int)0X0d10),
        Map1Index = ((int)0X0d91),
        UnpackSkipImagesExt = ((int)0X806D),
        AlphaTest = ((int)0X0bc0),
        PointFadeThresholdSize = ((int)0X8128),
        AlphaBias = ((int)0X0d1d),
        CurrentRasterPosition = ((int)0X0b07),
        SampleMaskInvertSgis = ((int)0X80ab),
        VertexPreclipHintSgix = ((int)0X83ef),
        AlphaScale = ((int)0X0d1c),
        VertexArrayStride = ((int)0X807c),
        PackLsbFirst = ((int)0X0d01),
        SampleCoverageInvert = ((int)0X80ab),
        FragmentColorMaterialFaceSgix = ((int)0X8402),
        BlendEquationRgb = ((int)0X8009),
        Map1GridSegments = ((int)0X0dd1),
        MaxFragmentLightsSgix = ((int)0X8404),
        FogOffsetSgix = ((int)0X8198),
        Map2Index = ((int)0X0db1),
        MaxAsyncHistogramSgix = ((int)0X832D),
        Light5 = ((int)0X4005),
        PolygonOffsetPoint = ((int)0X2a01),
        Light0 = ((int)0X4000),
        CompressedTextureFormats = ((int)0X86a3),
        AttribStackDepth = ((int)0X0bb0),
        AlphaBits = ((int)0X0d55),
        BlendEquationAlpha = ((int)0X883d),
        BlendDstAlpha = ((int)0X80ca),
        FramezoomSgix = ((int)0X818b),
        MaxFogFuncPointsSgis = ((int)0X812c),
        MaxTextureImageUnits = ((int)0X8872),
        MaxColorMatrixStackDepthSgi = ((int)0X80b3),
        PointSizeGranularity = ((int)0X0b13),
        PostConvolutionGreenBiasExt = ((int)0X8021),
        StencilBackRef = ((int)0X8ca3),
        FogFuncPointsSgis = ((int)0X812b),
        MaxViewportDims = ((int)0X0d3a),
        StencilBackPassDepthPass = ((int)0X8803),
        FogCoordArrayStride = ((int)0X8455),
        PointSizeMaxSgis = ((int)0X8127),
        EdgeFlagArray = ((int)0X8079),
        BlendDst = ((int)0X0be0),
        FragmentLightModelLocalViewerSgix = ((int)0X8408),
        PackSubsampleRateSgix = ((int)0X85a0),
        ModelviewMatrix = ((int)0X0ba6),
        MaxCombinedTextureImageUnits = ((int)0X8b4d),
        PackImageDepthSgis = ((int)0X8131),
        FogMode = ((int)0X0b65),
        IndexMode = ((int)0X0c30),
        AccumClearValue = ((int)0X0b80),
        DrawBuffer = ((int)0X0c01),
        Map1Normal = ((int)0X0d92),
        PointDistanceAttenuation = ((int)0X8129),
        FogHint = ((int)0X0c54),
        RescaleNormalExt = ((int)0X803a),
        LightModelColorControl = ((int)0X81f8),
        SubpixelBits = ((int)0X0d50),
        NormalArray = ((int)0X8075),
        PostTextureFilterBiasRangeSgix = ((int)0X817b),
        MaxEvalOrder = ((int)0X0d30),
        PixelTexGenSgix = ((int)0X8139),
        MaxClientAttribStackDepth = ((int)0X0d3b),
        BlendSrc = ((int)0X0be1),
        CullFaceMode = ((int)0X0b45),
        FragmentColorMaterialSgix = ((int)0X8401),
        PostColorMatrixBlueScaleSgi = ((int)0X80b6),
        Map1Vertex4 = ((int)0X0d98),
        FragmentShaderDerivativeHint = ((int)0X8b8b),
        Map1Vertex3 = ((int)0X0d97),
        ZoomX = ((int)0X0d16),
        CurrentRasterDistance = ((int)0X0b09),
        GenerateMipmapHint = ((int)0X8192),
        ClipPlane2 = ((int)0X3002),
        LogicOp = ((int)0X0bf1),
        MaxCubeMapTextureSize = ((int)0X851c),
        SecondaryColorArrayBufferBinding = ((int)0X889c),
        RedBias = ((int)0X0d15),
        WeightArrayBufferBinding = ((int)0X889e),
        SamplesSgis = ((int)0X80a9),
        FeedbackBufferType = ((int)0X0df2),
        ColorArrayCountExt = ((int)0X8084),
        ScissorTest = ((int)0X0c11),
        PointFadeThresholdSizeSgis = ((int)0X8128),
        StencilPassDepthPass = ((int)0X0b96),
        BlendSrcAlpha = ((int)0X80cb),
        Viewport = ((int)0X0ba2),
        AsyncMarkerSgix = ((int)0X8329),
        TextureCoordArrayStride = ((int)0X808a),
        StencilFunc = ((int)0X0b92),
        PixelMapIToGSize = ((int)0X0cb3),
        CurrentColor = ((int)0X0b00),
        StencilBackValueMask = ((int)0X8ca4),
        UnpackSkipPixels = ((int)0X0cf4),
        ColorMatrixStackDepthSgi = ((int)0X80b2),
        NormalArrayType = ((int)0X807e),
        AlphaTestFunc = ((int)0X0bc1),
        UnpackRowLength = ((int)0X0cf2),
        MaxClipmapDepthSgix = ((int)0X8177),
        ColorSum = ((int)0X8458),
        EdgeFlag = ((int)0X0b43),
        Texture4DSgis = ((int)0X8134),
        LineWidthRange = ((int)0X0b22),
        PackSwapBytes = ((int)0X0d00),
        ColorLogicOp = ((int)0X0bf2),
        SmoothLineWidthRange = ((int)0X0b22),
        TransposeModelviewMatrix = ((int)0X84e3),
        TextureBinding1D = ((int)0X8068),
        EdgeFlagArrayStride = ((int)0X808c),
        TextureBinding3D = ((int)0X806a),
        TextureBinding2D = ((int)0X8069),
        VertexPreclipSgix = ((int)0X83ee),
        PolygonOffsetFill = ((int)0X8037),
        DrawBuffer15 = ((int)0X8834),
        PixelMapBToBSize = ((int)0X0cb8),
        StencilWritemask = ((int)0X0b98),
        TransposeTextureMatrix = ((int)0X84e5),
        PostColorMatrixAlphaBiasSgi = ((int)0X80bb),
        CurrentNormal = ((int)0X0b02),
        LightModelAmbient = ((int)0X0b53),
        MaxNameStackDepth = ((int)0X0d37),
        SmoothPointSizeGranularity = ((int)0X0b13),
        SampleAlphaToMaskSgis = ((int)0X809e),
        AliasedPointSizeRange = ((int)0X846d),
        ListMode = ((int)0X0b30),
        ColorTableSgi = ((int)0X80D0),
        ColorArrayBufferBinding = ((int)0X8898),
        ClipPlane5 = ((int)0X3005),
        IndexArrayCountExt = ((int)0X8087),
        FrontFace = ((int)0X0b46),
        PackImageHeightExt = ((int)0X806c),
        TextureCoordArraySize = ((int)0X8088),
        FogStart = ((int)0X0b63),
        FragmentLightingSgix = ((int)0X8400),
        NameStackDepth = ((int)0X0d70),
        Light2 = ((int)0X4002),
        FogCoordArrayType = ((int)0X8454),
        MaxRenderbufferSizeExt = ((int)0X84e8),
        PixelTileWidthSgix = ((int)0X8140),
        FogOffsetValueSgix = ((int)0X8199),
        InterlaceSgix = ((int)0X8094),
        GreenScale = ((int)0X0d18),
        IndexOffset = ((int)0X0d13),
        PixelUnpackBufferBinding = ((int)0X88ef),
        AccumGreenBits = ((int)0X0d59),
        HistogramExt = ((int)0X8024),
        PixelMapIToRSize = ((int)0X0cb2),
        CurrentTextureCoords = ((int)0X0b03),
        ReadBuffer = ((int)0X0c02),
        MaxListNesting = ((int)0X0b31),
        TextureCoordArrayType = ((int)0X8089),
        DrawBuffer11 = ((int)0X8830),
        MaxVertexAttribs = ((int)0X8869),
        ColorMaterialFace = ((int)0X0b55),
        PostColorMatrixColorTableSgi = ((int)0X80D2),
        SampleCoverage = ((int)0X80a0),
        DetailTexture2DBindingSgis = ((int)0X8096),
        AutoNormal = ((int)0X0d80),
        CurrentRasterIndex = ((int)0X0b05),
        Multisample = ((int)0X809d),
        AuxBuffers = ((int)0X0c00),
        StencilRef = ((int)0X0b97),
        FramezoomFactorSgix = ((int)0X818c),
        DepthRange = ((int)0X0b70),
        DeformationsMaskSgix = ((int)0X8196),
        PostConvolutionBlueBiasExt = ((int)0X8022),
        MaxFramezoomFactorSgix = ((int)0X818D),
        Map2Color4 = ((int)0X0db0),
        CurrentProgram = ((int)0X8b8d),
        MinmaxExt = ((int)0X802e),
        ColorMatrixSgi = ((int)0X80b1),
        CurrentFogCoord = ((int)0X8453),
        EdgeFlagArrayBufferBinding = ((int)0X889b),
        TextureBindingCubeMap = ((int)0X8514),
        TextureCubeMap = ((int)0X8513),
        LineWidthGranularity = ((int)0X0b23),
        LineStipplePattern = ((int)0X0b25),
        FogCoordArrayBufferBinding = ((int)0X889d),
        FeedbackBufferSize = ((int)0X0df1),
        FogEnd = ((int)0X0b64),
        TransposeColorMatrix = ((int)0X84e6),
        CurrentRasterPositionValid = ((int)0X0b08),
        Fog = ((int)0X0b60),
        UnpackSkipRows = ((int)0X0cf3),
        DepthFunc = ((int)0X0b74),
        IndexClearValue = ((int)0X0c20),
        Doublebuffer = ((int)0X0c32),
        CurrentRasterColor = ((int)0X0b04),
        NormalArrayCountExt = ((int)0X8080),
        TextureGenS = ((int)0X0c60),
        TextureGenR = ((int)0X0c62),
        TextureGenQ = ((int)0X0c63),
        ColorArraySize = ((int)0X8081),
        GreenBits = ((int)0X0d53),
        TextureGenT = ((int)0X0c61),
        SecondaryColorArraySize = ((int)0X845a),
        NumCompressedTextureFormats = ((int)0X86a2),
        Light7 = ((int)0X4007),
        VertexArrayCountExt = ((int)0X807D),
        Map2TextureCoord1 = ((int)0X0db3),
        MaxTextureUnits = ((int)0X84e2),
        MaxActiveLightsSgix = ((int)0X8405),
        VertexArrayType = ((int)0X807b),
        MaxTextureSize = ((int)0X0d33),
        Dither = ((int)0X0bd0),
        FragmentLightModelAmbientSgix = ((int)0X840a),
        Map1TextureCoord2 = ((int)0X0d94),
        Map1TextureCoord3 = ((int)0X0d95),
        SampleAlphaToOne = ((int)0X809f),
        Map1TextureCoord1 = ((int)0X0d93),
        PostColorMatrixAlphaScaleSgi = ((int)0X80b7),
        IndexArray = ((int)0X8077),
        PostColorMatrixGreenScaleSgi = ((int)0X80b5),
        ClipPlane0 = ((int)0X3000),
        PixelMapRToRSize = ((int)0X0cb6),
        ClientActiveTexture = ((int)0X84e1),
        Map2TextureCoord4 = ((int)0X0db6),
        TransposeProjectionMatrix = ((int)0X84e4),
        PolygonOffsetLine = ((int)0X2a02),
        Lighting = ((int)0X0b50),
        PointSmoothHint = ((int)0X0c51),
        PostTextureFilterScaleRangeSgix = ((int)0X817c),
        ScissorBox = ((int)0X0c10),
        RenderMode = ((int)0X0c40),
        StencilBackFail = ((int)0X8801),
        PolygonStipple = ((int)0X0b42),
        PostColorMatrixGreenBiasSgi = ((int)0X80b9),
        GreenBias = ((int)0X0d19),
        TextureCoordArrayCountExt = ((int)0X808b),
        PointSizeMinSgis = ((int)0X8126),
        Map2TextureCoord2 = ((int)0X0db4),
        Map2TextureCoord3 = ((int)0X0db5),
        PolygonMode = ((int)0X0b40),
        Texture3DBindingExt = ((int)0X806a),
        SecondaryColorArrayStride = ((int)0X845c),
        PolygonOffsetUnits = ((int)0X2a00),
        StencilFail = ((int)0X0b94),
        VertexArrayBufferBinding = ((int)0X8896),
        ReferencePlaneEquationSgix = ((int)0X817e),
        StencilPassDepthFail = ((int)0X0b95),
    }

    public enum GetTextureParameter
    {
        TextureCompareMode = ((int)0X884c),
        TextureHeight = ((int)0X1001),
        QuadTextureSelectSgis = ((int)0X8125),
        DetailTextureLevelSgis = ((int)0X809a),
        TextureGreenSize = ((int)0X805d),
        TextureCompressedImageSize = ((int)0X86a0),
        TextureCompressed = ((int)0X86a1),
        TextureMaxClampRSgix = ((int)0X836b),
        TexturePriority = ((int)0X8066),
        TextureLequalRSgix = ((int)0X819c),
        TextureMinLod = ((int)0X813a),
        TextureLodBiasTSgix = ((int)0X818f),
        TextureBaseLevelSgis = ((int)0X813c),
        TextureClipmapCenterSgix = ((int)0X8171),
        TextureRedSize = ((int)0X805c),
        TextureComponents = ((int)0X1003),
        TextureDepthSize = ((int)0X884a),
        TextureMaxClampTSgix = ((int)0X836a),
        TextureMaxLevelSgis = ((int)0X813D),
        TextureLodBiasRSgix = ((int)0X8190),
        TextureBaseLevel = ((int)0X813c),
        TextureLodBiasSSgix = ((int)0X818e),
        TextureLuminanceSize = ((int)0X8060),
        DepthTextureMode = ((int)0X884b),
        TextureClipmapOffsetSgix = ((int)0X8173),
        TextureWrapQSgis = ((int)0X8137),
        TextureMinLodSgis = ((int)0X813a),
        TextureClipmapFrameSgix = ((int)0X8172),
        TextureGequalRSgix = ((int)0X819D),
        SharpenTextureFuncPointsSgis = ((int)0X80b0),
        TextureWrapS = ((int)0X2802),
        TextureMinFilter = ((int)0X2801),
        TextureClipmapDepthSgix = ((int)0X8176),
        TextureFilter4SizeSgis = ((int)0X8147),
        TextureWrapRExt = ((int)0X8072),
        TextureWrapR = ((int)0X8072),
        TextureCompareSgix = ((int)0X819a),
        TextureMaxClampSSgix = ((int)0X8369),
        DetailTextureModeSgis = ((int)0X809b),
        DetailTextureFuncPointsSgis = ((int)0X809c),
        DualTextureSelectSgis = ((int)0X8124),
        TextureClipmapLodOffsetSgix = ((int)0X8175),
        TextureDepthExt = ((int)0X8071),
        Texture4DsizeSgis = ((int)0X8136),
        TextureInternalFormat = ((int)0X1003),
        PostTextureFilterBiasSgix = ((int)0X8179),
        TextureIntensitySize = ((int)0X8061),
        TextureCompareOperatorSgix = ((int)0X819b),
        TextureMaxLodSgis = ((int)0X813b),
        TextureMaxLod = ((int)0X813b),
        TextureBlueSize = ((int)0X805e),
        GenerateMipmapSgis = ((int)0X8191),
        TextureDepth = ((int)0X8071),
        TextureWidth = ((int)0X1000),
        GenerateMipmap = ((int)0X8191),
        TextureAlphaSize = ((int)0X805f),
        ShadowAmbientSgix = ((int)0X80bf),
        PostTextureFilterScaleSgix = ((int)0X817a),
        TextureBorderColor = ((int)0X1004),
        TextureResident = ((int)0X8067),
        TextureCompareFunc = ((int)0X884d),
        TextureBorder = ((int)0X1005),
        TextureClipmapVirtualDepthSgix = ((int)0X8174),
        TextureMagFilter = ((int)0X2800),
        TextureWrapT = ((int)0X2803),
        TextureMaxLevel = ((int)0X813d),
    }

    public enum HintMode
    {
        Nicest = ((int)0X1102),
        Fastest = ((int)0X1101),
        DontCare = ((int)0X1100),
    }

    public enum HintTarget
    {
        PerspectiveCorrectionHint = ((int)0X0c50),
        VertexPreclipHintSgix = ((int)0X83ef),
        LineSmoothHint = ((int)0X0c52),
        UnpackCmykHintExt = ((int)0X800f),
        PolygonSmoothHint = ((int)0X0c53),
        ConvolutionHintSgix = ((int)0X8316),
        PackCmykHintExt = ((int)0X800e),
        TextureCompressionHint = ((int)0X84ef),
        PointSmoothHint = ((int)0X0c51),
        GenerateMipmapHint = ((int)0X8192),
        FogHint = ((int)0X0c54),
        GenerateMipmapHintSgis = ((int)0X8192),
        TextureMultiBufferHintSgix = ((int)0X812e),
    }

    public enum HistogramTargetExt
    {
        ProxyHistogramExt = ((int)0X8025),
        HistogramExt = ((int)0X8024),
    }

    public enum IndexPointerType
    {
        Short = ((int)0X1402),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        Int = ((int)0X1404),
    }

    public enum LightEnvModeSgix
    {
        Replace = ((int)0X1e01),
        Add = ((int)0X0104),
        Modulate = ((int)0X2100),
    }

    public enum LightEnvParameterSgix
    {
        LightEnvModeSgix = ((int)0X8407),
    }

    public enum LightModelColorControl
    {
        SingleColor = ((int)0X81f9),
        SeparateSpecularColor = ((int)0X81fa),
    }

    public enum LightModelParameter
    {
        LightModelColorControl = ((int)0X81f8),
        LightModelTwoSide = ((int)0X0b52),
        LightModelAmbient = ((int)0X0b53),
        LightModelLocalViewer = ((int)0X0b51),
    }

    public enum LightParameter
    {
        Specular = ((int)0X1202),
        ConstantAttenuation = ((int)0X1207),
        SpotExponent = ((int)0X1205),
        LinearAttenuation = ((int)0X1208),
        Position = ((int)0X1203),
        Ambient = ((int)0X1200),
        Diffuse = ((int)0X1201),
        SpotCutoff = ((int)0X1206),
        SpotDirection = ((int)0X1204),
        QuadraticAttenuation = ((int)0X1209),
    }

    public enum ListMode
    {
        CompileAndExecute = ((int)0X1301),
        Compile = ((int)0X1300),
    }

    public enum DataType
    {
        UnsignedByte = ((int)0X1401),
        Byte = ((int)0X1400),
        Double = ((int)0X140a),
        UnsignedInt = ((int)0X1405),
        DoubleExt = ((int)0X140a),
        Short = ((int)0X1402),
        Int = ((int)0X1404),
        Float = ((int)0X1406),
        Gl4Bytes = ((int)0X1409),
        Gl3Bytes = ((int)0X1408),
        Gl2Bytes = ((int)0X1407),
        UnsignedShort = ((int)0X1403),
    }

    public enum ListNameType
    {
        UnsignedByte = ((int)0X1401),
        Byte = ((int)0X1400),
        UnsignedInt = ((int)0X1405),
        Short = ((int)0X1402),
        Int = ((int)0X1404),
        Float = ((int)0X1406),
        Gl4Bytes = ((int)0X1409),
        Gl3Bytes = ((int)0X1408),
        Gl2Bytes = ((int)0X1407),
        UnsignedShort = ((int)0X1403),
    }

    public enum ListParameterName
    {
        ListPrioritySgix = ((int)0X8182),
    }

    public enum LogicOp
    {
        Nor = ((int)0X1508),
        AndInverted = ((int)0X1504),
        CopyInverted = ((int)0X150c),
        Noop = ((int)0X1505),
        OrReverse = ((int)0X150b),
        AndReverse = ((int)0X1502),
        Nand = ((int)0X150e),
        Set = ((int)0X150f),
        Equiv = ((int)0X1509),
        Copy = ((int)0X1503),
        Or = ((int)0X1507),
        And = ((int)0X1501),
        Xor = ((int)0X1506),
        Clear = ((int)0X1500),
        OrInverted = ((int)0X150d),
        Invert = ((int)0X150a),
    }

    public enum MapTarget
    {
        GeometryDeformationSgix = ((int)0X8194),
        Map1Color4 = ((int)0X0D90),
        Map1Index = ((int)0X0D91),
        Map2Index = ((int)0X0Db1),
        Map1Vertex4 = ((int)0X0D98),
        TextureDeformationSgix = ((int)0X8195),
        Map1Vertex3 = ((int)0X0D97),
        Map1Normal = ((int)0X0D92),
        Map2Vertex4 = ((int)0X0Db8),
        Map2Color4 = ((int)0X0Db0),
        Map2Vertex3 = ((int)0X0Db7),
        Map2Normal = ((int)0X0Db2),
        Map1TextureCoord4 = ((int)0X0D96),
        Map1TextureCoord2 = ((int)0X0D94),
        Map1TextureCoord3 = ((int)0X0D95),
        Map2TextureCoord2 = ((int)0X0Db4),
        Map2TextureCoord3 = ((int)0X0Db5),
        Map2TextureCoord1 = ((int)0X0Db3),
        Map1TextureCoord1 = ((int)0X0D93),
        Map2TextureCoord4 = ((int)0X0Db6),
    }

    public enum MaterialFace
    {
        Front = ((int)0X0404),
        FrontAndBack = ((int)0X0408),
        Back = ((int)0X0405),
    }

    public enum MaterialParameter
    {
        Emission = ((int)0X1600),
        ColorIndexes = ((int)0X1603),
        AmbientAndDiffuse = ((int)0X1602),
        Diffuse = ((int)0X1201),
        Ambient = ((int)0X1200),
        Specular = ((int)0X1202),
        Shininess = ((int)0X1601),
    }

    public enum MatrixMode
    {
        Color = ((int)0X1800),
        Modelview = ((int)0X1700),
        Projection = ((int)0X1701),
        Texture = ((int)0X1702),
    }

    public enum MeshMode1
    {
        Line = ((int)0X1b01),
        Point = ((int)0X1b00),
    }

    public enum MeshMode2
    {
        Line = ((int)0X1b01),
        Point = ((int)0X1b00),
        Fill = ((int)0X1b02),
    }

    public enum MinmaxTargetExt
    {
        MinmaxExt = ((int)0X802e),
    }

    public enum NormalPointerType
    {
        Short = ((int)0X1402),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        Byte = ((int)0X1400),
        Int = ((int)0X1404),
    }

    public enum PixelCopyType
    {
        Color = ((int)0X1800),
        Stencil = ((int)0X1802),
        Depth = ((int)0X1801),
    }

    public enum PixelFormat
    {
        CmykExt = ((int)0X800c),
        Rgb = ((int)0X1907),
        R5G6B5IccSgix = ((int)0X8466),
        R5G6B5A8IccSgix = ((int)0X8467),
        Green = ((int)0X1904),
        Blue = ((int)0X1905),
        Alpha16IccSgix = ((int)0X8468),
        Ycrcb444Sgix = ((int)0X81bc),
        Ycrcb422Sgix = ((int)0X81bb),
        Luminance = ((int)0X1909),
        Rgba = ((int)0X1908),
        StencilIndex = ((int)0X1901),
        Red = ((int)0X1903),
        DepthComponent = ((int)0X1902),
        Luminance16IccSgix = ((int)0X8469),
        Luminance16Alpha8IccSgix = ((int)0X846b),
        Bgra = ((int)0X80e1),
        Alpha = ((int)0X1906),
        ColorIndex = ((int)0X1900),
        CmykaExt = ((int)0X800D),
        Bgr = ((int)0X80e0),
        LuminanceAlpha = ((int)0X190a),
        AbgrExt = ((int)0X8000),
    }

    public enum PixelMap
    {
        PixelMapIToI = ((int)0X0c70),
        PixelMapIToA = ((int)0X0c75),
        PixelMapIToB = ((int)0X0c74),
        PixelMapIToR = ((int)0X0c72),
        PixelMapBToB = ((int)0X0c78),
        PixelMapRToR = ((int)0X0c76),
        PixelMapIToG = ((int)0X0c73),
        PixelMapGToG = ((int)0X0c77),
        PixelMapAToA = ((int)0X0c79),
        PixelMapSToS = ((int)0X0c71),
    }

    public enum PixelStoreParameter
    {
        UnpackSkipImagesExt = ((int)0X806D),
        PackImageHeight = ((int)0X806c),
        PackSkipImages = ((int)0X806b),
        PackSkipVolumesSgis = ((int)0X8130),
        PixelTileGridHeightSgix = ((int)0X8143),
        PackSkipPixels = ((int)0X0D04),
        UnpackImageHeight = ((int)0X806e),
        UnpackSkipVolumesSgis = ((int)0X8132),
        PackImageDepthSgis = ((int)0X8131),
        UnpackImageHeightExt = ((int)0X806e),
        PackImageHeightExt = ((int)0X806c),
        PackSkipImagesExt = ((int)0X806b),
        PixelTileCacheSizeSgix = ((int)0X8145),
        PixelTileGridDepthSgix = ((int)0X8144),
        PackSwapBytes = ((int)0X0D00),
        UnpackSkipPixels = ((int)0X0cf4),
        UnpackLsbFirst = ((int)0X0cf1),
        PixelTileHeightSgix = ((int)0X8141),
        PixelTileGridWidthSgix = ((int)0X8142),
        PackAlignment = ((int)0X0D05),
        UnpackResampleSgix = ((int)0X842D),
        UnpackAlignment = ((int)0X0cf5),
        UnpackRowLength = ((int)0X0cf2),
        UnpackSwapBytes = ((int)0X0cf0),
        PackSubsampleRateSgix = ((int)0X85a0),
        PackResampleSgix = ((int)0X842c),
        UnpackSkipRows = ((int)0X0cf3),
        UnpackImageDepthSgis = ((int)0X8133),
        PackLsbFirst = ((int)0X0D01),
        UnpackSubsampleRateSgix = ((int)0X85a1),
        UnpackSkipImages = ((int)0X806d),
        PackRowLength = ((int)0X0D02),
        PackSkipRows = ((int)0X0D03),
        PixelTileWidthSgix = ((int)0X8140),
    }

    public enum PixelStoreResampleMode
    {
        ResampleZeroFillSgix = ((int)0X842f),
        ResampleDecimateSgix = ((int)0X8430),
        ResampleReplicateSgix = ((int)0X842e),
    }

    public enum PixelStoreSubsampleRate
    {
        PixelSubsample2424Sgix = ((int)0X85a3),
        PixelSubsample4444Sgix = ((int)0X85a2),
        PixelSubsample4242Sgix = ((int)0X85a4),
    }

    public enum PixelTexGenMode
    {
        LuminanceAlpha = ((int)0X190a),
        PixelTexGenAlphaMsSgix = ((int)0X818a),
        Rgba = ((int)0X1908),
        PixelTexGenAlphaReplaceSgix = ((int)0X8187),
        PixelTexGenAlphaNoReplaceSgix = ((int)0X8188),
        PixelTexGenAlphaLsSgix = ((int)0X8189),
        None = ((int)0),
        Luminance = ((int)0X1909),
        Rgb = ((int)0X1907),
    }

    public enum PixelTexGenParameterNameSgis
    {
        PixelFragmentRgbSourceSgis = ((int)0X8354),
        PixelFragmentAlphaSourceSgis = ((int)0X8355),
    }

    public enum PixelTransferParameter
    {
        PostConvolutionAlphaBiasExt = ((int)0X8023),
        PostColorMatrixGreenBiasSgi = ((int)0X80b9),
        PostColorMatrixAlphaScaleSgi = ((int)0X80b7),
        PostColorMatrixBlueBiasSgi = ((int)0X80ba),
        PostConvolutionGreenScaleExt = ((int)0X801D),
        PostConvolutionGreenBiasExt = ((int)0X8021),
        BlueBias = ((int)0X0D1b),
        BlueScale = ((int)0X0D1a),
        PostColorMatrixRedScaleSgi = ((int)0X80b4),
        PostConvolutionRedBiasExt = ((int)0X8020),
        AlphaBias = ((int)0X0D1D),
        AlphaScale = ((int)0X0D1c),
        GreenScale = ((int)0X0D18),
        RedBias = ((int)0X0D15),
        PostColorMatrixRedBiasSgi = ((int)0X80b8),
        IndexShift = ((int)0X0D12),
        RedScale = ((int)0X0D14),
        PostColorMatrixAlphaBiasSgi = ((int)0X80bb),
        MapColor = ((int)0X0D10),
        PostConvolutionBlueBiasExt = ((int)0X8022),
        PostConvolutionBlueScaleExt = ((int)0X801e),
        PostConvolutionRedScaleExt = ((int)0X801c),
        PostColorMatrixGreenScaleSgi = ((int)0X80b5),
        MapStencil = ((int)0X0D11),
        DepthBias = ((int)0X0D1f),
        IndexOffset = ((int)0X0D13),
        PostConvolutionAlphaScaleExt = ((int)0X801f),
        PostColorMatrixBlueScaleSgi = ((int)0X80b6),
        DepthScale = ((int)0X0D1e),
        GreenBias = ((int)0X0D19),
    }

    public enum PixelType
    {
        Bitmap = ((int)0X1a00),
        UnsignedByte332Ext = ((int)0X8032),
        UnsignedShort4444 = ((int)0X8033),
        UnsignedInt8888 = ((int)0X8035),
        Short = ((int)0X1402),
        UnsignedInt2101010Reversed = ((int)0X8368),
        UnsignedInt1010102Ext = ((int)0X8036),
        HalfFloat = ((int)0X140b),
        UnsignedShort5551 = ((int)0X8034),
        UnsignedInt8888Reversed = ((int)0X8367),
        UnsignedShort5551Ext = ((int)0X8034),
        UnsignedInt1010102 = ((int)0X8036),
        UnsignedShort565 = ((int)0X8363),
        Byte = ((int)0X1400),
        UnsignedShort565Reversed = ((int)0X8364),
        UnsignedInt = ((int)0X1405),
        UnsignedByte = ((int)0X1401),
        UnsignedByte233Reversed = ((int)0X8362),
        Int = ((int)0X1404),
        UnsignedShort4444Ext = ((int)0X8033),
        UnsignedByte332 = ((int)0X8032),
        UnsignedShort1555Reversed = ((int)0X8366),
        Float = ((int)0X1406),
        UnsignedShort4444Reversed = ((int)0X8365),
        UnsignedInt8888Ext = ((int)0X8035),
        UnsignedShort = ((int)0X1403),
    }

    public enum PointParameterNameSgis
    {
        DistanceAttenuationSgis = ((int)0X8129),
        PointSizeMaxSgis = ((int)0X8127),
        PointSizeMinSgis = ((int)0X8126),
        PointFadeThresholdSizeSgis = ((int)0X8128),
    }

    public enum PolygonMode
    {
        Line = ((int)0X1b01),
        Point = ((int)0X1b00),
        Fill = ((int)0X1b02),
    }

    public enum ReadBufferMode
    {
        FrontRight = ((int)0X0401),
        Right = ((int)0X0407),
        BackLeft = ((int)0X0402),
        BackRight = ((int)0X0403),
        Left = ((int)0X0406),
        Aux0 = ((int)0X0409),
        Back = ((int)0X0405),
        Aux3 = ((int)0X040c),
        Aux1 = ((int)0X040a),
        FrontLeft = ((int)0X0400),
        Aux2 = ((int)0X040b),
        Front = ((int)0X0404),
    }

    public enum RenderingMode
    {
        Render = ((int)0X1c00),
        Feedback = ((int)0X1c01),
        Select = ((int)0X1c02),
    }

    public enum SamplePatternSgis
    {
        Gl4Pass0Sgis = ((int)0X80a4),
        Gl4Pass1Sgis = ((int)0X80a5),
        Gl4Pass3Sgis = ((int)0X80a7),
        Gl4Pass2Sgis = ((int)0X80a6),
        Gl2Pass1Sgis = ((int)0X80a3),
        Gl1PassSgis = ((int)0X80a1),
        Gl2Pass0Sgis = ((int)0X80a2),
    }

    public enum SeparableTargetExt
    {
        Separable2DExt = ((int)0X8012),
    }

    public enum ShadingModel
    {
        Flat = ((int)0X1d00),
        Smooth = ((int)0X1d01),
    }

    public enum StencilFunction
    {
        Never = ((int)0X0200),
        Equal = ((int)0X0202),
        Always = ((int)0X0207),
        Less = ((int)0X0201),
        Gequal = ((int)0X0206),
        Lequal = ((int)0X0203),
        Notequal = ((int)0X0205),
        Greater = ((int)0X0204),
    }

    public enum StencilOp
    {
        DecrWrap = ((int)0X8508),
        Replace = ((int)0X1e01),
        IncrWrap = ((int)0X8507),
        Incr = ((int)0X1e02),
        Zero = ((int)0),
        Decr = ((int)0X1e03),
        Keep = ((int)0X1e00),
        Invert = ((int)0X150a),
    }

    public enum StringName
    {
        ShadingLanguageVersion = ((int)0X8b8c),
        Renderer = ((int)0X1f01),
        Extensions = ((int)0X1f03),
        Version = ((int)0X1f02),
        Vendor = ((int)0X1f00),
    }

    public enum TexCoordPointerType
    {
        Short = ((int)0X1402),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        Int = ((int)0X1404),
    }

    public enum TextureCoordName
    {
        R = ((int)0X2002),
        S = ((int)0X2000),
        Q = ((int)0X2003),
        T = ((int)0X2001),
    }

    public enum TextureEnvMode
    {
        TextureEnvBiasSgix = ((int)0X80be),
        Blend = ((int)0X0be2),
        Decal = ((int)0X2101),
        Add = ((int)0X0104),
        Modulate = ((int)0X2100),
        Replace = ((int)0X1e01),
        Combine = ((int)0X8570),
        ReplaceExt = ((int)0X8062),
    }

    public enum TextureEnvParameter
    {
        Operand0Alpha = ((int)0X8598),
        TextureEnvMode = ((int)0X2200),
        Src0Alpha = ((int)0X8588),
        Src1Alpha = ((int)0X8589),
        Operand2Rgb = ((int)0X8592),
        Operand2Alpha = ((int)0X859a),
        Operand0Rgb = ((int)0X8590),
        AlphaScale = ((int)0X0D1c),
        Operand1Alpha = ((int)0X8599),
        RgbScale = ((int)0X8573),
        Src1Rgb = ((int)0X8581),
        Src2Rgb = ((int)0X8582),
        TextureEnvColor = ((int)0X2201),
        Src2Alpha = ((int)0X858a),
        Source0Rgb = ((int)0X8580),
        CombineAlpha = ((int)0X8572),
        Operand1Rgb = ((int)0X8591),
        CoordReplace = ((int)0X8862),
        CombineRgb = ((int)0X8571),
        TextureLodBias = ((int)0X8501),
    }

    public enum TextureEnvTarget
    {
        PointSprite = ((int)0X8861),
        TextureFilterControl = ((int)0X8500),
        TextureEnv = ((int)0X2300),
    }

    public enum TextureFilterFuncSgis
    {
        Filter4Sgis = ((int)0X8146),
    }

    public enum TextureGenMode
    {
        NormalMap = ((int)0X8511),
        SphereMap = ((int)0X2402),
        ObjectLinear = ((int)0X2401),
        EyeDistanceToLineSgis = ((int)0X81f2),
        EyeDistanceToPointSgis = ((int)0X81f0),
        ObjectDistanceToLineSgis = ((int)0X81f3),
        ReflectionMap = ((int)0X8512),
        EyeLinear = ((int)0X2400),
        ObjectDistanceToPointSgis = ((int)0X81f1),
    }

    public enum TextureGenParameter
    {
        ObjectPlane = ((int)0X2501),
        EyePlane = ((int)0X2502),
        EyePointSgis = ((int)0X81f4),
        ObjectPointSgis = ((int)0X81f5),
        TextureGenMode = ((int)0X2500),
        ObjectLineSgis = ((int)0X81f7),
        EyeLineSgis = ((int)0X81f6),
    }

    public enum TextureMagFilter
    {
        PixelTexGenQCeilingSgix = ((int)0X8184),
        Filter4Sgis = ((int)0X8146),
        LinearDetailSgis = ((int)0X8097),
        LinearSharpenSgis = ((int)0X80ad),
        Linear = ((int)0X2601),
        LinearSharpenColorSgis = ((int)0X80af),
        PixelTexGenQRoundSgix = ((int)0X8185),
        Nearest = ((int)0X2600),
        LinearSharpenAlphaSgis = ((int)0X80ae),
        LinearDetailColorSgis = ((int)0X8099),
        PixelTexGenQFloorSgix = ((int)0X8186),
        LinearDetailAlphaSgis = ((int)0X8098),
    }

    public enum TextureMinFilter
    {
        LinearClipmapNearestSgix = ((int)0X844f),
        Filter4Sgis = ((int)0X8146),
        LinearClipmapLinearSgix = ((int)0X8170),
        NearestMipmapLinear = ((int)0X2702),
        NearestClipmapNearestSgix = ((int)0X844D),
        Linear = ((int)0X2601),
        LinearMipmapNearest = ((int)0X2701),
        Nearest = ((int)0X2600),
        PixelTexGenQCeilingSgix = ((int)0X8184),
        PixelTexGenQRoundSgix = ((int)0X8185),
        PixelTexGenQFloorSgix = ((int)0X8186),
        NearestMipmapNearest = ((int)0X2700),
        NearestClipmapLinearSgix = ((int)0X844e),
        LinearMipmapLinear = ((int)0X2703),
    }

    public enum TextureParameterName
    {
        ShadowAmbientSgix = ((int)0X80bf),
        QuadTextureSelectSgis = ((int)0X8125),
        DetailTextureLevelSgis = ((int)0X809a),
        TextureMaxClampTSgix = ((int)0X836a),
        TextureCompareFailValue = ((int)0X80bf),
        TextureCompareMode = ((int)0X884c),
        TexturePriority = ((int)0X8066),
        TextureLodBiasTSgix = ((int)0X818f),
        TextureClipmapCenterSgix = ((int)0X8171),
        TextureLodBiasRSgix = ((int)0X8190),
        TextureBaseLevel = ((int)0X813c),
        TextureLodBiasSSgix = ((int)0X818e),
        TextureClipmapDepthSgix = ((int)0X8176),
        DepthTextureMode = ((int)0X884b),
        TextureClipmapOffsetSgix = ((int)0X8173),
        TextureWrapQSgis = ((int)0X8137),
        TextureClipmapFrameSgix = ((int)0X8172),
        TextureWrapS = ((int)0X2802),
        TextureMinFilter = ((int)0X2801),
        TextureWrapRExt = ((int)0X8072),
        TextureWrapR = ((int)0X8072),
        TextureCompareSgix = ((int)0X819a),
        TextureMaxClampSSgix = ((int)0X8369),
        DetailTextureModeSgis = ((int)0X809b),
        TextureMaxLevel = ((int)0X813D),
        DualTextureSelectSgis = ((int)0X8124),
        TextureClipmapLodOffsetSgix = ((int)0X8175),
        TextureMaxLod = ((int)0X813b),
        PostTextureFilterBiasSgix = ((int)0X8179),
        TextureCompareOperatorSgix = ((int)0X819b),
        TextureMaxClampRSgix = ((int)0X836b),
        ClampToEdge = ((int)0X812f),
        TextureMinLod = ((int)0X813a),
        GenerateMipmapSgis = ((int)0X8191),
        TextureDepth = ((int)0X8071),
        GenerateMipmap = ((int)0X8191),
        PostTextureFilterScaleSgix = ((int)0X817a),
        TextureBorderColor = ((int)0X1004),
        TextureCompareFunc = ((int)0X884d),
        TextureClipmapVirtualDepthSgix = ((int)0X8174),
        TextureMagFilter = ((int)0X2800),
        TextureWrapT = ((int)0X2803),
        ClampToBorder = ((int)0X812d),
    }

    public enum TextureTarget
    {
        TextureCubeMapNegativeX = ((int)0X8516),
        TextureBaseLevelSgis = ((int)0X813c),
        TextureCubeMapNegativeZ = ((int)0X851a),
        TextureBindingCubeMap = ((int)0X8514),
        TextureMaxLevelSgis = ((int)0X813D),
        ProxyTexture4DSgis = ((int)0X8135),
        DetailTexture2DSgis = ((int)0X8095),
        TextureRectangleArb = ((int)0X84f5),
        ProxyTextureCubeMap = ((int)0X851b),
        TextureCubeMap = ((int)0X8513),
        ProxyTexture3DExt = ((int)0X8070),
        Texture2D = ((int)0X0De1),
        Texture4DSgis = ((int)0X8134),
        TextureMinLodSgis = ((int)0X813a),
        Texture1D = ((int)0X0De0),
        ProxyTexture3D = ((int)0X8070),
        ProxyTexture2D = ((int)0X8064),
        ProxyTexture1D = ((int)0X8063),
        Texture3DExt = ((int)0X806f),
        Texture3D = ((int)0X806f),
        TextureRectangleNv = ((int)0X84f5),
        TextureMaxLodSgis = ((int)0X813b),
        TextureCubeMapNegativeY = ((int)0X8518),
        TextureCubeMapPositiveZ = ((int)0X8519),
        TextureCubeMapPositiveX = ((int)0X8515),
        TextureCubeMapPositiveY = ((int)0X8517),
    }

    public enum TextureWrapMode
    {
        ClampToBorder = ((int)0X812d),
        ClampToEdge = ((int)0X812f),
        Clamp = ((int)0X2900),
        Repeat = ((int)0X2901),
        MirroredRepeat = ((int)0X8370),
    }

    public enum PixelInternalFormat
    {
        LuminanceAlphaIccSgix = ((int)0X8465),
        Rgb4 = ((int)0X804f),
        Intensity16IccSgix = ((int)0X846a),
        DepthComponent = ((int)0X1902),
        Alpha8 = ((int)0X803c),
        LuminanceAlpha = ((int)0X190a),
        DualIntensity4Sgis = ((int)0X8118),
        QuadLuminance4Sgis = ((int)0X8120),
        Rgb2Ext = ((int)0X804e),
        RgbaIccSgix = ((int)0X8461),
        Alpha16IccSgix = ((int)0X8468),
        CompressedAlpha = ((int)0X84e9),
        Luminance12Alpha12 = ((int)0X8047),
        Luminance6Alpha2 = ((int)0X8044),
        Alpha12 = ((int)0X803d),
        QuadLuminance8Sgis = ((int)0X8121),
        CompressedSrgbAlphaS3tcDxt5Ext = ((int)0X8c4f),
        Alpha16 = ((int)0X803e),
        Rgba2 = ((int)0X8055),
        Srgb = ((int)0X8c40),
        CompressedLuminance = ((int)0X84ea),
        Luminance8Alpha8 = ((int)0X8045),
        Sluminance8 = ((int)0X8c47),
        R5G6B5IccSgix = ((int)0X8466),
        Sluminance8Alpha8 = ((int)0X8c45),
        R3G3B2 = ((int)0X2a10),
        R5G6B5A8IccSgix = ((int)0X8467),
        Luminance4Alpha4 = ((int)0X8043),
        Alpha4 = ((int)0X803b),
        DepthComponent32Sgix = ((int)0X81a7),
        Luminance16Alpha8IccSgix = ((int)0X846b),
        DualIntensity8Sgis = ((int)0X8119),
        Rgba8 = ((int)0X8058),
        Alpha = ((int)0X1906),
        Rgb12 = ((int)0X8053),
        CompressedLuminanceAlpha = ((int)0X84eb),
        Rgba4 = ((int)0X8056),
        Luminance4 = ((int)0X803f),
        Sluminance = ((int)0X8c46),
        Two = ((int)2),
        Intensity8 = ((int)0X804b),
        Luminance16 = ((int)0X8042),
        DepthComponent16Sgix = ((int)0X81a5),
        DualAlpha16Sgis = ((int)0X8113),
        Luminance12 = ((int)0X8041),
        Luminance16Alpha16 = ((int)0X8048),
        SluminanceAlpha = ((int)0X8c44),
        Intensity4 = ((int)0X804a),
        LuminanceIccSgix = ((int)0X8463),
        CompressedSrgbAlphaS3tcDxt3Ext = ((int)0X8c4e),
        DualLuminance4Sgis = ((int)0X8114),
        CompressedSrgbAlpha = ((int)0X8c49),
        CompressedIntensity = ((int)0X84ec),
        Srgb8 = ((int)0X8c41),
        DualLuminanceAlpha8Sgis = ((int)0X811D),
        DualAlpha12Sgis = ((int)0X8112),
        Four = ((int)4),
        QuadIntensity4Sgis = ((int)0X8122),
        CompressedSluminanceAlpha = ((int)0X8c4b),
        Rgb5A1 = ((int)0X8057),
        DepthComponent24 = ((int)0X81a6),
        Luminance16IccSgix = ((int)0X8469),
        DualLuminance8Sgis = ((int)0X8115),
        SrgbAlpha = ((int)0X8c42),
        CompressedSluminance = ((int)0X8c4a),
        Rgba16 = ((int)0X805b),
        RgbIccSgix = ((int)0X8460),
        Srgb8Alpha8 = ((int)0X8c43),
        DepthComponent32 = ((int)0X81a7),
        CompressedRgba = ((int)0X84ee),
        Intensity = ((int)0X8049),
        CompressedSrgb = ((int)0X8c48),
        CompressedSrgbAlphaS3tcDxt1Ext = ((int)0X8c4d),
        DepthComponent16 = ((int)0X81a5),
        DualLuminance12Sgis = ((int)0X8116),
        Rgb10A2 = ((int)0X8059),
        DualAlpha4Sgis = ((int)0X8110),
        Rgb5 = ((int)0X8050),
        Luminance = ((int)0X1909),
        CompressedRgb = ((int)0X84ed),
        One = ((int)1),
        AlphaIccSgix = ((int)0X8462),
        Rgb8 = ((int)0X8051),
        Rgb10 = ((int)0X8052),
        Three = ((int)3),
        Rgb16 = ((int)0X8054),
        Rgba12 = ((int)0X805a),
        DualLuminanceAlpha4Sgis = ((int)0X811c),
        IntensityIccSgix = ((int)0X8464),
        DualAlpha8Sgis = ((int)0X8111),
        QuadIntensity8Sgis = ((int)0X8123),
        DualLuminance16Sgis = ((int)0X8117),
        CompressedSrgbS3tcDxt1Ext = ((int)0X8c4c),
        Luminance12Alpha4 = ((int)0X8046),
        QuadAlpha8Sgis = ((int)0X811f),
        DepthComponent24Sgix = ((int)0X81a6),
        DualIntensity12Sgis = ((int)0X811a),
        Rgb = ((int)0X1907),
        Luminance8 = ((int)0X8040),
        DualIntensity16Sgis = ((int)0X811b),
        Intensity12 = ((int)0X804c),
        QuadAlpha4Sgis = ((int)0X811e),
        Intensity16 = ((int)0X804d),
        Rgba = ((int)0X1908),
    }

    public enum InterleavedArrayFormat
    {
        V2f = ((int)0X2a20),
        T2fC3fV3f = ((int)0X2a2a),
        C4ubV3f = ((int)0X2a23),
        C4ubV2f = ((int)0X2a22),
        T4fV4f = ((int)0X2a28),
        C4fN3fV3f = ((int)0X2a26),
        T2fC4fN3fV3f = ((int)0X2a2c),
        N3fV3f = ((int)0X2a25),
        C3fV3f = ((int)0X2a24),
        T2fV3f = ((int)0X2a27),
        T2fN3fV3f = ((int)0X2a2b),
        T2fC4ubV3f = ((int)0X2a29),
        T4fC4fN3fV4f = ((int)0X2a2d),
        V3f = ((int)0X2a21),
    }

    public enum VertexPointerType
    {
        Short = ((int)0X1402),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        Int = ((int)0X1404),
    }

    public enum ClipPlaneName
    {
        ClipPlane4 = ((int)0X3004),
        ClipPlane1 = ((int)0X3001),
        ClipPlane5 = ((int)0X3005),
        ClipPlane2 = ((int)0X3002),
        ClipPlane3 = ((int)0X3003),
        ClipPlane0 = ((int)0X3000),
    }

    public enum LightName
    {
        FragmentLight3Sgix = ((int)0X840f),
        FragmentLight0Sgix = ((int)0X840c),
        Light2 = ((int)0X4002),
        FragmentLight7Sgix = ((int)0X8413),
        Light3 = ((int)0X4003),
        FragmentLight6Sgix = ((int)0X8412),
        FragmentLight4Sgix = ((int)0X8410),
        FragmentLight5Sgix = ((int)0X8411),
        FragmentLight1Sgix = ((int)0X840D),
        Light0 = ((int)0X4000),
        FragmentLight2Sgix = ((int)0X840e),
        Light4 = ((int)0X4004),
        Light5 = ((int)0X4005),
        Light6 = ((int)0X4006),
        Light7 = ((int)0X4007),
        Light1 = ((int)0X4001),
    }

    public enum ExtAbgr
    {
        AbgrExt = ((int)0X8000),
    }

    public enum ExtBlendColor
    {
        BlendColorExt = ((int)0X8005),
        ConstantColorExt = ((int)0X8001),
        BlendColor = ((int)0X8005),
        OneMinusConstantAlpha = ((int)0X8004),
        OneMinusConstantColorExt = ((int)0X8002),
        ConstantColor = ((int)0X8001),
        ConstantAlphaExt = ((int)0X8003),
        OneMinusConstantColor = ((int)0X8002),
        ConstantAlpha = ((int)0X8003),
        OneMinusConstantAlphaExt = ((int)0X8004),
    }

    public enum ExtBlendMinmax
    {
        FuncAdd = ((int)0X8006),
        Min = ((int)0X8007),
        Max = ((int)0X8008),
        BlendEquationExt = ((int)0X8009),
        FuncAddExt = ((int)0X8006),
        MaxExt = ((int)0X8008),
        BlendEquation = ((int)0X8009),
        MinExt = ((int)0X8007),
    }

    public enum ExtBlendSubtract
    {
        FuncReverseSubtract = ((int)0X800b),
        FuncReverseSubtractExt = ((int)0X800b),
        FuncSubtractExt = ((int)0X800a),
        FuncSubtract = ((int)0X800a),
    }

    public enum ExtCmyka
    {
        CmykExt = ((int)0X800c),
        CmykaExt = ((int)0X800d),
        UnpackCmykHintExt = ((int)0X800f),
        PackCmykHintExt = ((int)0X800e),
    }

    public enum ExtConvolution
    {
        PostConvolutionGreenScaleExt = ((int)0X801d),
        PostConvolutionAlphaScale = ((int)0X801f),
        Separable2D = ((int)0X8012),
        PostConvolutionRedScaleExt = ((int)0X801c),
        MaxConvolutionWidthExt = ((int)0X801a),
        ConvolutionBorderMode = ((int)0X8013),
        MaxConvolutionHeightExt = ((int)0X801b),
        ReduceExt = ((int)0X8016),
        PostConvolutionGreenScale = ((int)0X801d),
        PostConvolutionAlphaBiasExt = ((int)0X8023),
        PostConvolutionBlueScale = ((int)0X801e),
        ConvolutionHeight = ((int)0X8019),
        ConvolutionWidthExt = ((int)0X8018),
        ConvolutionBorderModeExt = ((int)0X8013),
        Convolution2D = ((int)0X8011),
        Convolution2DExt = ((int)0X8011),
        ConvolutionFormat = ((int)0X8017),
        PostConvolutionGreenBias = ((int)0X8021),
        PostConvolutionAlphaScaleExt = ((int)0X801f),
        ConvolutionFilterBiasExt = ((int)0X8015),
        ConvolutionHeightExt = ((int)0X8019),
        PostConvolutionBlueBiasExt = ((int)0X8022),
        ConvolutionFormatExt = ((int)0X8017),
        ConvolutionFilterScaleExt = ((int)0X8014),
        Reduce = ((int)0X8016),
        ConvolutionWidth = ((int)0X8018),
        PostConvolutionRedScale = ((int)0X801c),
        PostConvolutionAlphaBias = ((int)0X8023),
        PostConvolutionBlueScaleExt = ((int)0X801e),
        ConvolutionFilterScale = ((int)0X8014),
        PostConvolutionBlueBias = ((int)0X8022),
        MaxConvolutionHeight = ((int)0X801b),
        PostConvolutionRedBiasExt = ((int)0X8020),
        PostConvolutionGreenBiasExt = ((int)0X8021),
        Convolution1DExt = ((int)0X8010),
        PostConvolutionRedBias = ((int)0X8020),
        Convolution1D = ((int)0X8010),
        MaxConvolutionWidth = ((int)0X801a),
        ConvolutionFilterBias = ((int)0X8015),
        Separable2DExt = ((int)0X8012),
    }

    public enum ExtHistogram
    {
        HistogramSink = ((int)0X802d),
        TableTooLarge = ((int)0X8031),
        HistogramLuminanceSizeExt = ((int)0X802c),
        Histogram = ((int)0X8024),
        HistogramBlueSize = ((int)0X802a),
        MinmaxFormat = ((int)0X802f),
        HistogramFormatExt = ((int)0X8027),
        HistogramRedSizeExt = ((int)0X8028),
        HistogramFormat = ((int)0X8027),
        HistogramExt = ((int)0X8024),
        HistogramWidth = ((int)0X8026),
        TableTooLargeExt = ((int)0X8031),
        HistogramAlphaSizeExt = ((int)0X802b),
        HistogramGreenSizeExt = ((int)0X8029),
        HistogramBlueSizeExt = ((int)0X802a),
        HistogramGreenSize = ((int)0X8029),
        MinmaxSink = ((int)0X8030),
        HistogramSinkExt = ((int)0X802d),
        MinmaxExt = ((int)0X802e),
        Minmax = ((int)0X802e),
        HistogramAlphaSize = ((int)0X802b),
        HistogramRedSize = ((int)0X8028),
        MinmaxFormatExt = ((int)0X802f),
        HistogramWidthExt = ((int)0X8026),
        ProxyHistogramExt = ((int)0X8025),
        MinmaxSinkExt = ((int)0X8030),
        HistogramLuminanceSize = ((int)0X802c),
        ProxyHistogram = ((int)0X8025),
    }

    public enum ExtPackedPixels
    {
        UnsignedShort4444Ext = ((int)0X8033),
        UnsignedByte332Ext = ((int)0X8032),
        UnsignedInt1010102 = ((int)0X8036),
        UnsignedInt8888 = ((int)0X8035),
        UnsignedInt1010102Ext = ((int)0X8036),
        UnsignedShort5551 = ((int)0X8034),
        UnsignedShort5551Ext = ((int)0X8034),
        UnsignedInt2101010RevExt = ((int)0X8368),
        UnsignedShort565Rev = ((int)0X8364),
        UnsignedShort4444RevExt = ((int)0X8365),
        UnsignedShort565 = ((int)0X8363),
        UnsignedShort4444Rev = ((int)0X8365),
        UnsignedShort1555RevExt = ((int)0X8366),
        UnsignedInt8888Rev = ((int)0X8367),
        UnsignedShort565Ext = ((int)0X8363),
        UnsignedByte233RevExt = ((int)0X8362),
        UnsignedShort565RevExt = ((int)0X8364),
        UnsignedInt2101010Rev = ((int)0X8368),
        UnsignedByte233Rev = ((int)0X8362),
        UnsignedByte332 = ((int)0X8032),
        UnsignedShort4444 = ((int)0X8033),
        UnsignedInt8888Ext = ((int)0X8035),
        UnsignedShort1555Rev = ((int)0X8366),
        UnsignedInt8888RevExt = ((int)0X8367),
    }

    public enum ExtPolygonOffset
    {
        PolygonOffsetExt = ((int)0X8037),
        PolygonOffsetBiasExt = ((int)0X8039),
        PolygonOffsetFactorExt = ((int)0X8038),
    }

    public enum ExtRescaleNormal
    {
        RescaleNormal = ((int)0X803a),
        RescaleNormalExt = ((int)0X803a),
    }

    public enum ExtTexture
    {
        Luminance4Alpha4Ext = ((int)0X8043),
        Luminance12Alpha4Ext = ((int)0X8046),
        Rgb10A2Ext = ((int)0X8059),
        Alpha8Ext = ((int)0X803c),
        Luminance12Ext = ((int)0X8041),
        Luminance8Alpha8Ext = ((int)0X8045),
        TextureIntensitySizeExt = ((int)0X8061),
        Rgba8Ext = ((int)0X8058),
        ProxyTexture1DExt = ((int)0X8063),
        Luminance6Alpha2Ext = ((int)0X8044),
        Rgb4Ext = ((int)0X804f),
        Alpha12Ext = ((int)0X803d),
        Luminance8Ext = ((int)0X8040),
        Rgb12Ext = ((int)0X8053),
        Rgba12Ext = ((int)0X805a),
        TextureLuminanceSizeExt = ((int)0X8060),
        Intensity12Ext = ((int)0X804c),
        TextureBlueSizeExt = ((int)0X805e),
        Alpha4Ext = ((int)0X803b),
        Alpha16Ext = ((int)0X803e),
        IntensityExt = ((int)0X8049),
        Intensity8Ext = ((int)0X804b),
        Luminance12Alpha12Ext = ((int)0X8047),
        Rgb16Ext = ((int)0X8054),
        Luminance16Alpha16Ext = ((int)0X8048),
        ReplaceExt = ((int)0X8062),
        Intensity16Ext = ((int)0X804d),
        TextureRedSizeExt = ((int)0X805c),
        Rgba4Ext = ((int)0X8056),
        TextureAlphaSizeExt = ((int)0X805f),
        Rgb10Ext = ((int)0X8052),
        ProxyTexture2DExt = ((int)0X8064),
        Rgb2Ext = ((int)0X804e),
        Rgb5Ext = ((int)0X8050),
        Luminance16Ext = ((int)0X8042),
        TextureTooLargeExt = ((int)0X8065),
        Rgba16Ext = ((int)0X805b),
        Rgba2Ext = ((int)0X8055),
        Rgb5A1Ext = ((int)0X8057),
        TextureGreenSizeExt = ((int)0X805d),
        Luminance4Ext = ((int)0X803f),
        Intensity4Ext = ((int)0X804a),
        Rgb8Ext = ((int)0X8051),
    }

    public enum ExtTextureObject
    {
        TextureResidentExt = ((int)0X8067),
        TexturePriorityExt = ((int)0X8066),
        Texture1DBindingExt = ((int)0X8068),
        Texture2DBindingExt = ((int)0X8069),
        Texture3DBindingExt = ((int)0X806a),
    }

    public enum ExtTexture3D
    {
        UnpackSkipImages = ((int)0X806d),
        TextureDepth = ((int)0X8071),
        Max3DTextureSize = ((int)0X8073),
        UnpackImageHeight = ((int)0X806e),
        PackImageHeight = ((int)0X806c),
        TextureWrapR = ((int)0X8072),
        TextureWrapRExt = ((int)0X8072),
        PackSkipImagesExt = ((int)0X806b),
        UnpackImageHeightExt = ((int)0X806e),
        UnpackSkipImagesExt = ((int)0X806d),
        PackSkipImages = ((int)0X806b),
        ProxyTexture3DExt = ((int)0X8070),
        Texture3D = ((int)0X806f),
        TextureDepthExt = ((int)0X8071),
        ProxyTexture3D = ((int)0X8070),
        Texture3DExt = ((int)0X806f),
        PackImageHeightExt = ((int)0X806c),
        Max3DTextureSizeExt = ((int)0X8073),
    }

    public enum ExtVertexArray
    {
        NormalArrayStrideExt = ((int)0X807f),
        ColorArrayExt = ((int)0X8076),
        TextureCoordArrayPointerExt = ((int)0X8092),
        IndexArrayStrideExt = ((int)0X8086),
        VertexArrayTypeExt = ((int)0X807b),
        IndexArrayPointerExt = ((int)0X8091),
        TextureCoordArrayStrideExt = ((int)0X808a),
        VertexArrayStrideExt = ((int)0X807c),
        TextureCoordArrayCountExt = ((int)0X808b),
        NormalArrayExt = ((int)0X8075),
        TextureCoordArraySizeExt = ((int)0X8088),
        NormalArrayTypeExt = ((int)0X807e),
        ColorArraySizeExt = ((int)0X8081),
        TextureCoordArrayExt = ((int)0X8078),
        ColorArrayTypeExt = ((int)0X8082),
        ColorArrayStrideExt = ((int)0X8083),
        ColorArrayCountExt = ((int)0X8084),
        EdgeFlagArrayPointerExt = ((int)0X8093),
        ColorArrayPointerExt = ((int)0X8090),
        IndexArrayCountExt = ((int)0X8087),
        NormalArrayCountExt = ((int)0X8080),
        EdgeFlagArrayCountExt = ((int)0X808d),
        VertexArrayPointerExt = ((int)0X808e),
        EdgeFlagArrayExt = ((int)0X8079),
        VertexArrayExt = ((int)0X8074),
        VertexArraySizeExt = ((int)0X807a),
        NormalArrayPointerExt = ((int)0X808f),
        IndexArrayExt = ((int)0X8077),
        VertexArrayCountExt = ((int)0X807d),
        IndexArrayTypeExt = ((int)0X8085),
        TextureCoordArrayTypeExt = ((int)0X8089),
        EdgeFlagArrayStrideExt = ((int)0X808c),
    }

    public enum SgixInterlace
    {
        InterlaceSgix = ((int)0X8094),
    }

    public enum SgisDetailTexture
    {
        LinearDetailSgis = ((int)0X8097),
        DetailTexture2DSgis = ((int)0X8095),
        DetailTextureFuncPointsSgis = ((int)0X809c),
        DetailTextureLevelSgis = ((int)0X809a),
        DetailTexture2DBindingSgis = ((int)0X8096),
        LinearDetailColorSgis = ((int)0X8099),
        DetailTextureModeSgis = ((int)0X809b),
        LinearDetailAlphaSgis = ((int)0X8098),
    }

    public enum ArbMultisample
    {
        Samples = ((int)0X80a9),
        MultisampleBitArb = ((int)0X20000000),
        SampleCoverageInvertArb = ((int)0X80ab),
        SampleCoverage = ((int)0X80a0),
        SampleCoverageInvert = ((int)0X80ab),
        SampleAlphaToOne = ((int)0X809f),
        SampleAlphaToOneArb = ((int)0X809f),
        SampleCoverageValue = ((int)0X80aa),
        SampleAlphaToCoverage = ((int)0X809e),
        SampleBuffersArb = ((int)0X80a8),
        MultisampleArb = ((int)0X809d),
        SampleAlphaToCoverageArb = ((int)0X809e),
        SampleCoverageArb = ((int)0X80a0),
        SamplesArb = ((int)0X80a9),
        Multisample = ((int)0X809d),
        SampleBuffers = ((int)0X80a8),
        SampleCoverageValueArb = ((int)0X80aa),
    }

    public enum SgisMultisample
    {
        Gl2Pass1Sgis = ((int)0X80a3),
        Gl1PassSgis = ((int)0X80a1),
        SampleAlphaToOneSgis = ((int)0X809f),
        Gl4Pass2Sgis = ((int)0X80a6),
        SampleMaskInvertSgis = ((int)0X80ab),
        SampleAlphaToMaskSgis = ((int)0X809e),
        SampleBuffersSgis = ((int)0X80a8),
        Gl4Pass3Sgis = ((int)0X80a7),
        Gl4Pass0Sgis = ((int)0X80a4),
        SamplesSgis = ((int)0X80a9),
        MultisampleSgis = ((int)0X809d),
        Gl2Pass0Sgis = ((int)0X80a2),
        SamplePatternSgis = ((int)0X80ac),
        SampleMaskValueSgis = ((int)0X80aa),
        Gl4Pass1Sgis = ((int)0X80a5),
        SampleMaskSgis = ((int)0X80a0),
    }

    public enum SgisSharpenTexture
    {
        LinearSharpenSgis = ((int)0X80ad),
        SharpenTextureFuncPointsSgis = ((int)0X80b0),
        LinearSharpenColorSgis = ((int)0X80af),
        LinearSharpenAlphaSgis = ((int)0X80ae),
    }

    public enum SgiColorMatrix
    {
        MaxColorMatrixStackDepth = ((int)0X80b3),
        PostColorMatrixRedScale = ((int)0X80b4),
        ColorMatrixSgi = ((int)0X80b1),
        PostColorMatrixGreenBiasSgi = ((int)0X80b9),
        PostColorMatrixAlphaScaleSgi = ((int)0X80b7),
        PostColorMatrixAlphaScale = ((int)0X80b7),
        PostColorMatrixBlueBiasSgi = ((int)0X80ba),
        PostColorMatrixRedBias = ((int)0X80b8),
        PostColorMatrixRedScaleSgi = ((int)0X80b4),
        ColorMatrix = ((int)0X80b1),
        PostColorMatrixGreenScale = ((int)0X80b5),
        PostColorMatrixBlueBias = ((int)0X80ba),
        PostColorMatrixRedBiasSgi = ((int)0X80b8),
        PostColorMatrixAlphaBiasSgi = ((int)0X80bb),
        PostColorMatrixBlueScale = ((int)0X80b6),
        ColorMatrixStackDepth = ((int)0X80b2),
        MaxColorMatrixStackDepthSgi = ((int)0X80b3),
        PostColorMatrixGreenBias = ((int)0X80b9),
        PostColorMatrixGreenScaleSgi = ((int)0X80b5),
        PostColorMatrixAlphaBias = ((int)0X80bb),
        PostColorMatrixBlueScaleSgi = ((int)0X80b6),
        ColorMatrixStackDepthSgi = ((int)0X80b2),
    }

    public enum SgiTextureColorTable
    {
        TextureColorTableSgi = ((int)0X80bc),
        ProxyTextureColorTableSgi = ((int)0X80bd),
    }

    public enum SgixTextureAddEnv
    {
        TextureEnvBiasSgix = ((int)0X80be),
    }

    public enum SgixShadowAmbient
    {
        ShadowAmbientSgix = ((int)0X80bf),
    }

    public enum SgiColorTable
    {
        ColorTableScaleSgi = ((int)0X80d6),
        ProxyColorTable = ((int)0X80d3),
        ColorTableBiasSgi = ((int)0X80d7),
        ColorTableBlueSize = ((int)0X80dc),
        ColorTableFormatSgi = ((int)0X80d8),
        ColorTableIntensitySizeSgi = ((int)0X80df),
        ColorTableRedSize = ((int)0X80da),
        ProxyPostColorMatrixColorTableSgi = ((int)0X80d5),
        ColorTableWidth = ((int)0X80d9),
        ColorTableWidthSgi = ((int)0X80d9),
        ColorTableAlphaSizeSgi = ((int)0X80dd),
        PostConvolutionColorTableSgi = ((int)0X80d1),
        ColorTable = ((int)0X80d0),
        ProxyPostConvolutionColorTable = ((int)0X80d4),
        ColorTableLuminanceSizeSgi = ((int)0X80de),
        PostColorMatrixColorTable = ((int)0X80d2),
        PostConvolutionColorTable = ((int)0X80d1),
        ColorTableLuminanceSize = ((int)0X80de),
        ColorTableGreenSize = ((int)0X80db),
        ColorTableSgi = ((int)0X80d0),
        ColorTableIntensitySize = ((int)0X80df),
        ColorTableBlueSizeSgi = ((int)0X80dc),
        ProxyPostConvolutionColorTableSgi = ((int)0X80d4),
        ProxyColorTableSgi = ((int)0X80d3),
        PostColorMatrixColorTableSgi = ((int)0X80d2),
        ColorTableGreenSizeSgi = ((int)0X80db),
        ColorTableRedSizeSgi = ((int)0X80da),
        ProxyPostColorMatrixColorTable = ((int)0X80d5),
        ColorTableFormat = ((int)0X80d8),
        ColorTableScale = ((int)0X80d6),
        ColorTableAlphaSize = ((int)0X80dd),
        ColorTableBias = ((int)0X80d7),
    }

    public enum ExtBgra
    {
        BgrExt = ((int)0X80e0),
        Bgra = ((int)0X80e1),
        Bgr = ((int)0X80e0),
        BgraExt = ((int)0X80e1),
    }

    public enum Version12
    {
        MaxElementsVertices = ((int)0X80e8),
        MaxElementsIndices = ((int)0X80e9),
    }

    public enum SgisTextureSelect
    {
        DualIntensity4Sgis = ((int)0X8118),
        QuadAlpha4Sgis = ((int)0X811e),
        DualAlpha8Sgis = ((int)0X8111),
        QuadTextureSelectSgis = ((int)0X8125),
        DualLuminance12Sgis = ((int)0X8116),
        QuadLuminance4Sgis = ((int)0X8120),
        DualLuminance16Sgis = ((int)0X8117),
        DualIntensity16Sgis = ((int)0X811b),
        QuadLuminance8Sgis = ((int)0X8121),
        DualIntensity12Sgis = ((int)0X811a),
        DualIntensity8Sgis = ((int)0X8119),
        QuadAlpha8Sgis = ((int)0X811f),
        DualAlpha16Sgis = ((int)0X8113),
        DualLuminanceAlpha4Sgis = ((int)0X811c),
        DualAlpha12Sgis = ((int)0X8112),
        DualAlpha4Sgis = ((int)0X8110),
        DualTextureSelectSgis = ((int)0X8124),
        QuadIntensity8Sgis = ((int)0X8123),
        QuadIntensity4Sgis = ((int)0X8122),
        DualLuminance8Sgis = ((int)0X8115),
        DualLuminance4Sgis = ((int)0X8114),
        DualLuminanceAlpha8Sgis = ((int)0X811d),
    }

    public enum SgisPointParameters
    {
        PointSizeMinSgis = ((int)0X8126),
        DistanceAttenuationSgis = ((int)0X8129),
        PointSizeMinArb = ((int)0X8126),
        PointSizeMaxSgis = ((int)0X8127),
        PointSizeMaxExt = ((int)0X8127),
        PointFadeThresholdSizeExt = ((int)0X8128),
        PointDistanceAttenuationArb = ((int)0X8129),
        DistanceAttenuationExt = ((int)0X8129),
        PointDistanceAttenuation = ((int)0X8129),
        PointFadeThresholdSizeArb = ((int)0X8128),
        PointSizeMax = ((int)0X8127),
        PointFadeThresholdSizeSgis = ((int)0X8128),
        PointSizeMaxArb = ((int)0X8127),
        PointSizeMinExt = ((int)0X8126),
        PointFadeThresholdSize = ((int)0X8128),
        PointSizeMin = ((int)0X8126),
    }

    public enum SgisFogFunction
    {
        MaxFogFuncPointsSgis = ((int)0X812c),
        FogFuncSgis = ((int)0X812a),
        FogFuncPointsSgis = ((int)0X812b),
    }

    public enum SgisTextureBorderClamp
    {
        ClampToBorder = ((int)0X812d),
        ClampToBorderSgis = ((int)0X812d),
        ClampToBorderArb = ((int)0X812d),
    }

    public enum SgixTextureMultiBuffer
    {
        TextureMultiBufferHintSgix = ((int)0X812e),
    }

    public enum SgisTextureEdgeClamp
    {
        ClampToEdgeSgis = ((int)0X812f),
        ClampToEdge = ((int)0X812f),
    }

    public enum SgisTexture4D
    {
        Texture4DBindingSgis = ((int)0X814f),
        PackImageDepthSgis = ((int)0X8131),
        Texture4DsizeSgis = ((int)0X8136),
        PackSkipVolumesSgis = ((int)0X8130),
        ProxyTexture4DSgis = ((int)0X8135),
        Max4DTextureSizeSgis = ((int)0X8138),
        UnpackImageDepthSgis = ((int)0X8133),
        Texture4DSgis = ((int)0X8134),
        UnpackSkipVolumesSgis = ((int)0X8132),
        TextureWrapQSgis = ((int)0X8137),
    }

    public enum SgixPixelTexture
    {
        PixelTexGenModeSgix = ((int)0X832b),
        PixelTexGenSgix = ((int)0X8139),
    }

    public enum SgisTextureLod
    {
        TextureMaxLevelSgis = ((int)0X813d),
        TextureBaseLevel = ((int)0X813c),
        TextureMaxLodSgis = ((int)0X813b),
        TextureMaxLod = ((int)0X813b),
        TextureMinLod = ((int)0X813a),
        TextureMinLodSgis = ((int)0X813a),
        TextureBaseLevelSgis = ((int)0X813c),
        TextureMaxLevel = ((int)0X813d),
    }

    public enum SgixPixelTiles
    {
        PixelTileWidthSgix = ((int)0X8140),
        PixelTileGridWidthSgix = ((int)0X8142),
        PixelTileCacheIncrementSgix = ((int)0X813f),
        PixelTileCacheSizeSgix = ((int)0X8145),
        PixelTileHeightSgix = ((int)0X8141),
        PixelTileGridDepthSgix = ((int)0X8144),
        PixelTileBestAlignmentSgix = ((int)0X813e),
        PixelTileGridHeightSgix = ((int)0X8143),
    }

    public enum SgisTextureFilter4
    {
        Filter4Sgis = ((int)0X8146),
        TextureFilter4SizeSgis = ((int)0X8147),
    }

    public enum SgixSprite
    {
        SpriteAxialSgix = ((int)0X814c),
        SpriteObjectAlignedSgix = ((int)0X814d),
        SpriteModeSgix = ((int)0X8149),
        SpriteSgix = ((int)0X8148),
        SpriteEyeAlignedSgix = ((int)0X814e),
        SpriteAxisSgix = ((int)0X814a),
        SpriteTranslationSgix = ((int)0X814b),
    }

    public enum HpConvolutionBorderModes
    {
        IgnoreBorderHp = ((int)0X8150),
        ReplicateBorderHp = ((int)0X8153),
        ConvolutionBorderColorHp = ((int)0X8154),
        ConvolutionBorderColor = ((int)0X8154),
        ConstantBorder = ((int)0X8151),
        ConstantBorderHp = ((int)0X8151),
        ReplicateBorder = ((int)0X8153),
    }

    public enum SgixClipmap
    {
        TextureClipmapVirtualDepthSgix = ((int)0X8174),
        TextureClipmapCenterSgix = ((int)0X8171),
        TextureClipmapFrameSgix = ((int)0X8172),
        NearestClipmapNearestSgix = ((int)0X844d),
        LinearClipmapNearestSgix = ((int)0X844f),
        TextureClipmapOffsetSgix = ((int)0X8173),
        TextureClipmapDepthSgix = ((int)0X8176),
        MaxClipmapDepthSgix = ((int)0X8177),
        TextureClipmapLodOffsetSgix = ((int)0X8175),
        NearestClipmapLinearSgix = ((int)0X844e),
        MaxClipmapVirtualDepthSgix = ((int)0X8178),
        LinearClipmapLinearSgix = ((int)0X8170),
    }

    public enum SgixTextureScaleBias
    {
        PostTextureFilterBiasSgix = ((int)0X8179),
        PostTextureFilterScaleRangeSgix = ((int)0X817c),
        PostTextureFilterScaleSgix = ((int)0X817a),
        PostTextureFilterBiasRangeSgix = ((int)0X817b),
    }

    public enum SgixReferencePlane
    {
        ReferencePlaneSgix = ((int)0X817d),
        ReferencePlaneEquationSgix = ((int)0X817e),
    }

    public enum SgixIrInstrument1
    {
        IrInstrument1Sgix = ((int)0X817f),
    }

    public enum SgixInstruments
    {
        InstrumentBufferPointerSgix = ((int)0X8180),
        InstrumentMeasurementsSgix = ((int)0X8181),
    }

    public enum SgixListPriority
    {
        ListPrioritySgix = ((int)0X8182),
    }

    public enum SgixCalligraphicFragment
    {
        CalligraphicFragmentSgix = ((int)0X8183),
    }

    public enum SgixImpactPixelTexture
    {
        PixelTexGenAlphaLsSgix = ((int)0X8189),
        PixelTexGenAlphaMsSgix = ((int)0X818a),
        PixelTexGenQFloorSgix = ((int)0X8186),
        PixelTexGenAlphaNoReplaceSgix = ((int)0X8188),
        PixelTexGenQRoundSgix = ((int)0X8185),
        PixelTexGenAlphaReplaceSgix = ((int)0X8187),
        PixelTexGenQCeilingSgix = ((int)0X8184),
    }

    public enum SgixFramezoom
    {
        MaxFramezoomFactorSgix = ((int)0X818d),
        FramezoomFactorSgix = ((int)0X818c),
        FramezoomSgix = ((int)0X818b),
    }

    public enum SgixTextureLodBias
    {
        TextureLodBiasSSgix = ((int)0X818e),
        TextureLodBiasRSgix = ((int)0X8190),
        TextureLodBiasTSgix = ((int)0X818f),
    }

    public enum SgisGenerateMipmap
    {
        GenerateMipmapSgis = ((int)0X8191),
        GenerateMipmap = ((int)0X8191),
        MaxDeformationOrderSgix = ((int)0X8197),
        GeometryDeformationSgix = ((int)0X8194),
        DeformationsMaskSgix = ((int)0X8196),
        GenerateMipmapHint = ((int)0X8192),
        TextureDeformationSgix = ((int)0X8195),
        GenerateMipmapHintSgis = ((int)0X8192),
    }

    public enum SgixFogOffset
    {
        FogOffsetValueSgix = ((int)0X8199),
        FogOffsetSgix = ((int)0X8198),
    }

    public enum SgixShadow
    {
        TextureLequalRSgix = ((int)0X819c),
        TextureCompareOperatorSgix = ((int)0X819b),
        TextureCompareSgix = ((int)0X819a),
        TextureGequalRSgix = ((int)0X819d),
    }

    public enum SgixDepthTexture
    {
        DepthComponent32 = ((int)0X81a7),
        DepthComponent32Sgix = ((int)0X81a7),
        DepthComponent24Sgix = ((int)0X81a6),
        DepthComponent24 = ((int)0X81a6),
        DepthComponent16 = ((int)0X81a5),
        DepthComponent16Sgix = ((int)0X81a5),
    }

    public enum SgixYcrcb
    {
        Ycrcb422Sgix = ((int)0X81bb),
        Ycrcb444Sgix = ((int)0X81bc),
    }

    public enum SgisTextureColorMask
    {
        TextureColorWritemaskSgis = ((int)0X81ef),
    }

    public enum SgisPointLineTexgen
    {
        EyeDistanceToPointSgis = ((int)0X81f0),
        EyeLineSgis = ((int)0X81f6),
        EyeDistanceToLineSgis = ((int)0X81f2),
        ObjectDistanceToLineSgis = ((int)0X81f3),
        EyePointSgis = ((int)0X81f4),
        ObjectPointSgis = ((int)0X81f5),
        ObjectLineSgis = ((int)0X81f7),
        ObjectDistanceToPointSgis = ((int)0X81f1),
    }

    public enum ExtSeparateSpecularColor
    {
        LightModelColorControl = ((int)0X81f8),
        SeparateSpecularColorExt = ((int)0X81fa),
        SingleColorExt = ((int)0X81f9),
        LightModelColorControlExt = ((int)0X81f8),
        SingleColor = ((int)0X81f9),
        SeparateSpecularColor = ((int)0X81fa),
    }

    public enum ExtSharedTexturePalette
    {
        SharedTexturePaletteExt = ((int)0X81fb),
    }

    public enum SgixConvolutionAccuracy
    {
        ConvolutionHintSgix = ((int)0X8316),
    }

    public enum SgixBlendAlphaMinmax
    {
        AlphaMaxSgix = ((int)0X8321),
        AsyncMarkerSgix = ((int)0X8329),
        AlphaMinSgix = ((int)0X8320),
    }

    public enum SgixAsyncHistogram
    {
        AsyncHistogramSgix = ((int)0X832c),
        MaxAsyncHistogramSgix = ((int)0X832d),
    }

    public enum ExtPixelTransform
    {
        PixelTransform2DExt = ((int)0X8330),
        PixelCubicWeightExt = ((int)0X8333),
        CubicExt = ((int)0X8334),
        MaxPixelTransform2DStackDepthExt = ((int)0X8337),
        PixelTransform2DMatrixExt = ((int)0X8338),
        PixelMagFilterExt = ((int)0X8331),
        AverageExt = ((int)0X8335),
        PixelTransform2DStackDepthExt = ((int)0X8336),
        PixelMinFilterExt = ((int)0X8332),
    }

    public enum SgisPixelTexture
    {
        PixelGroupColorSgis = ((int)0X8356),
        PixelTextureSgis = ((int)0X8353),
        PixelFragmentAlphaSourceSgis = ((int)0X8355),
        PixelFragmentRgbSourceSgis = ((int)0X8354),
    }

    public enum SgixAsyncPixel
    {
        MaxAsyncReadPixelsSgix = ((int)0X8361),
        AsyncDrawPixelsSgix = ((int)0X835d),
        MaxAsyncTexImageSgix = ((int)0X835f),
        AsyncTexImageSgix = ((int)0X835c),
        AsyncReadPixelsSgix = ((int)0X835e),
        MaxAsyncDrawPixelsSgix = ((int)0X8360),
    }

    public enum SgixTextureCoordinateClamp
    {
        TextureMaxClampRSgix = ((int)0X836b),
        TextureMaxClampTSgix = ((int)0X836a),
        TextureMaxClampSSgix = ((int)0X8369),
        FogFactorToAlphaSgix = ((int)0X836f),
    }

    public enum SgixVertexPreclip
    {
        VertexPreclipHintSgix = ((int)0X83ef),
        VertexPreclipSgix = ((int)0X83ee),
    }

    public enum ExtTextureCompressionS3tc
    {
        CompressedRgbS3tcDxt1Ext = ((int)0X83f0),
        CompressedRgbaS3tcDxt5Ext = ((int)0X83f3),
        CompressedRgbaS3tcDxt3Ext = ((int)0X83f2),
        CompressedRgbaS3tcDxt1Ext = ((int)0X83f1),
    }

    public enum IntelParallelArrays
    {
        VertexArrayParallelPointersIntel = ((int)0X83f5),
        TextureCoordArrayParallelPointersIntel = ((int)0X83f8),
        ColorArrayParallelPointersIntel = ((int)0X83f7),
        ParallelArraysIntel = ((int)0X83f4),
        NormalArrayParallelPointersIntel = ((int)0X83f6),
    }

    public enum SgixFragmentLighting
    {
        FragmentLightModelAmbientSgix = ((int)0X840a),
        FragmentLight5Sgix = ((int)0X8411),
        FragmentLight6Sgix = ((int)0X8412),
        MaxActiveLightsSgix = ((int)0X8405),
        FragmentLightingSgix = ((int)0X8400),
        FragmentLight2Sgix = ((int)0X840e),
        MaxFragmentLightsSgix = ((int)0X8404),
        FragmentLight4Sgix = ((int)0X8410),
        LightEnvModeSgix = ((int)0X8407),
        FragmentLightModelNormalInterpolationSgix = ((int)0X840b),
        FragmentColorMaterialFaceSgix = ((int)0X8402),
        FragmentLightModelTwoSideSgix = ((int)0X8409),
        FragmentLight1Sgix = ((int)0X840d),
        FragmentLightModelLocalViewerSgix = ((int)0X8408),
        CurrentRasterNormalSgix = ((int)0X8406),
        FragmentLight3Sgix = ((int)0X840f),
        FragmentLight7Sgix = ((int)0X8413),
        FragmentLight0Sgix = ((int)0X840c),
        FragmentColorMaterialParameterSgix = ((int)0X8403),
        FragmentColorMaterialSgix = ((int)0X8401),
    }

    public enum SgixResample
    {
        PackResampleSgix = ((int)0X842c),
        ResampleZeroFillSgix = ((int)0X842f),
        ResampleDecimateSgix = ((int)0X8430),
        UnpackResampleSgix = ((int)0X842d),
        ResampleReplicateSgix = ((int)0X842e),
    }

    public enum SgixIccTexture
    {
        R5G6B5IccSgix = ((int)0X8466),
        RgbIccSgix = ((int)0X8460),
        LuminanceIccSgix = ((int)0X8463),
        IntensityIccSgix = ((int)0X8464),
        RgbaIccSgix = ((int)0X8461),
        Luminance16IccSgix = ((int)0X8469),
        LuminanceAlphaIccSgix = ((int)0X8465),
        AlphaIccSgix = ((int)0X8462),
        Luminance16Alpha8IccSgix = ((int)0X846b),
        Alpha16IccSgix = ((int)0X8468),
        Intensity16IccSgix = ((int)0X846a),
        R5G6B5A8IccSgix = ((int)0X8467),
    }

    public enum SgixSubsample
    {
        PixelSubsample2424Sgix = ((int)0X85a3),
        UnpackSubsampleRateSgix = ((int)0X85a1),
        PackSubsampleRateSgix = ((int)0X85a0),
        PixelSubsample4242Sgix = ((int)0X85a4),
        PixelSubsample4444Sgix = ((int)0X85a2),
    }

    public enum All
    {
        VertexStream2Ati = ((int)0X876e),
        ArrayElementLockFirstExt = ((int)0X81a8),
        Two = ((int)2),
        ShadowAmbientSgix = ((int)0X80bf),
        TextureRedSizeExt = ((int)0X805c),
        VertexArrayListStrideIbm = ((int)103080),
        ColorLogicOp = ((int)0X0bf2),
        TextureCompareFailValue = ((int)0X80bf),
        Gl2D = ((int)0X0600),
        TextureWidth = ((int)0X1000),
        MapAttribUOrderNv = ((int)0X86c3),
        Combiner0Nv = ((int)0X8550),
        MaxGeometryBindableUniformsExt = ((int)0X8de4),
        TableTooLargeExt = ((int)0X8031),
        CurrentSecondaryColor = ((int)0X8459),
        CompressedSluminanceExt = ((int)0X8c4a),
        ShaderConsistentNv = ((int)0X86dd),
        Texture13Arb = ((int)0X84cd),
        Sampler2DArrayShadowExt = ((int)0X8dc4),
        IndexTestExt = ((int)0X81b5),
        Stencil = ((int)0X1802),
        Intensity = ((int)0X8049),
        Rgb8Ext = ((int)0X8051),
        C4ubV2f = ((int)0X2a22),
        UnsignedByte233Reversed = ((int)0X8362),
        TextureCoordArraySizeExt = ((int)0X8088),
        BumpRotMatrixSizeAti = ((int)0X8776),
        DrawBuffer11Arb = ((int)0X8830),
        MaxProgramNativeParameters = ((int)0X88ab),
        Aux3 = ((int)0X040c),
        StencilPassDepthFail = ((int)0X0b95),
        MaxProgramIfDepthNv = ((int)0X88f6),
        LocalConstantValueExt = ((int)0X87ec),
        LocalConstantExt = ((int)0X87c3),
        Map2TangentExt = ((int)0X8445),
        Luminance16Alpha8IccSgix = ((int)0X846b),
        WideLineHintPgi = ((int)0X1a222),
        Modelview15Arb = ((int)0X872f),
        MaxCubeMapTextureSize = ((int)0X851c),
        DepthStencilToRgbaNv = ((int)0X886e),
        Source2AlphaExt = ((int)0X858a),
        CurrentVertexExt = ((int)0X87e2),
        PixelMapAToASize = ((int)0X0cb9),
        PostColorMatrixBlueScale = ((int)0X80b6),
        PostColorMatrixGreenScale = ((int)0X80b5),
        Light6 = ((int)0X4006),
        Combiner6Nv = ((int)0X8556),
        MaxFragmentUniformComponents = ((int)0X8b49),
        VertexWeightArrayPointerExt = ((int)0X8510),
        OneMinusConstantColorExt = ((int)0X8002),
        Modelview12Arb = ((int)0X872c),
        MaxRectangleTextureSizeNv = ((int)0X84f8),
        Bgra = ((int)0X80e1),
        OpDot4Ext = ((int)0X8785),
        Map2VertexAttrib104Nv = ((int)0X867a),
        Operand1Alpha = ((int)0X8599),
        Rgb10Ext = ((int)0X8052),
        IndexArrayCountExt = ((int)0X8087),
        R1uiC4fN3fV3fSun = ((int)0X85c8),
        Map2VertexAttrib154Nv = ((int)0X867f),
        ColorAttachment14Ext = ((int)0X8cee),
        PointBit = ((int)0X00000002),
        FragmentLight6Sgix = ((int)0X8412),
        IntensityFloat16Ati = ((int)0X881d),
        MaxNameStackDepth = ((int)0X0d37),
        FragmentLightModelAmbientSgix = ((int)0X840a),
        LineSmoothHint = ((int)0X0c52),
        Modelview13Arb = ((int)0X872d),
        UnpackSkipImages = ((int)0X806d),
        Stereo = ((int)0X0c33),
        Modelview2Arb = ((int)0X8722),
        PostColorMatrixAlphaScaleSgi = ((int)0X80b7),
        Rgba2Ext = ((int)0X8055),
        PixelUnpackBufferArb = ((int)0X88ec),
        Con8Ati = ((int)0X8949),
        TextureCubeMapPositiveYArb = ((int)0X8517),
        Alpha = ((int)0X1906),
        WeightArrayBufferBindingArb = ((int)0X889e),
        OutputTextureCoord13Ext = ((int)0X87aa),
        MaxProgramNativeAttribs = ((int)0X88af),
        Combiner4Nv = ((int)0X8554),
        Src2Rgb = ((int)0X8582),
        OpPowerExt = ((int)0X8793),
        ColorArrayCountExt = ((int)0X8084),
        TextureIntensitySizeExt = ((int)0X8061),
        SpriteModeSgix = ((int)0X8149),
        SignedLuminance8Alpha8Nv = ((int)0X8704),
        RgbaFloat16Ati = ((int)0X881a),
        Rgb12Ext = ((int)0X8053),
        MaxColorAttachmentsExt = ((int)0X8cdf),
        VertexShaderLocalsExt = ((int)0X87d3),
        IndexMaterialParameterExt = ((int)0X81b9),
        Filter4Sgis = ((int)0X8146),
        MaxDrawBuffersArb = ((int)0X8824),
        TextureIntensityTypeArb = ((int)0X8c15),
        Alpha8iExt = ((int)0X8d90),
        IndexArrayType = ((int)0X8085),
        StencilBackValueMask = ((int)0X8ca4),
        MultisampleArb = ((int)0X809d),
        VariableBNv = ((int)0X8524),
        Combiner3Nv = ((int)0X8553),
        VertexProgramNv = ((int)0X8620),
        ReferencePlaneSgix = ((int)0X817d),
        Triangles = ((int)0X0004),
        WeightArrayTypeArb = ((int)0X86a9),
        Modelview19Arb = ((int)0X8733),
        DrawBuffer8 = ((int)0X882d),
        DrawBuffer9 = ((int)0X882e),
        AccumRedBits = ((int)0X0d58),
        DrawBuffer7 = ((int)0X882c),
        DrawBuffer4 = ((int)0X8829),
        DrawBuffer5 = ((int)0X882a),
        DrawBuffer2 = ((int)0X8827),
        DrawBuffer3 = ((int)0X8828),
        SampleBuffersSgis = ((int)0X80a8),
        DrawBuffer1 = ((int)0X8826),
        DynamicRead = ((int)0X88e9),
        TextureCubeMapArb = ((int)0X8513),
        InterlaceReadOml = ((int)0X8981),
        RedBitAti = ((int)0X00000001),
        PixelMapSToS = ((int)0X0c71),
        AlphaScale = ((int)0X0d1c),
        ClientActiveTexture = ((int)0X84e1),
        TextureCoordArraySize = ((int)0X8088),
        MagnitudeBiasNv = ((int)0X8718),
        Modelview16Arb = ((int)0X8730),
        Texture6 = ((int)0X84c6),
        LineStrip = ((int)0X0003),
        StreamDraw = ((int)0X88e0),
        InterpolateArb = ((int)0X8575),
        TextureCompareFunc = ((int)0X884d),
        VertexConsistentHintPgi = ((int)0X1a22b),
        AlphaMaxClampIngr = ((int)0X8567),
        Texture9Arb = ((int)0X84c9),
        ConvolutionBorderColor = ((int)0X8154),
        ColorTableWidthSgi = ((int)0X80d9),
        Reg19Ati = ((int)0X8934),
        LineStripAdjacencyExt = ((int)0X000b),
        Convolution1DExt = ((int)0X8010),
        C4ubV3f = ((int)0X2a23),
        VariableDNv = ((int)0X8526),
        MaxLights = ((int)0X0d31),
        NormalArrayListIbm = ((int)103071),
        Aux2 = ((int)0X040b),
        NormalArrayStrideExt = ((int)0X807f),
        ForceBlueToOneNv = ((int)0X8860),
        Alpha16fArb = ((int)0X881c),
        PixelMapIToB = ((int)0X0c74),
        ConvolutionBorderColorHp = ((int)0X8154),
        Texture1D = ((int)0X0de0),
        ColorIndex16Ext = ((int)0X80e7),
        PnTrianglesPointModeAti = ((int)0X87f2),
        Projection = ((int)0X1701),
        DstColor = ((int)0X0306),
        UnsignedInt8888Ext = ((int)0X8035),
        Constant = ((int)0X8576),
        CompressedRgbaS3tcDxt5Ext = ((int)0X83f3),
        WriteOnly = ((int)0X88b9),
        PostConvolutionGreenScale = ((int)0X801d),
        CompressedRgbaArb = ((int)0X84ee),
        ArrayType = ((int)0X8625),
        PackImageHeightExt = ((int)0X806c),
        ProxyHistogramExt = ((int)0X8025),
        FogEnd = ((int)0X0b64),
        UnsignedShort1555Reversed = ((int)0X8366),
        Modelview14Arb = ((int)0X872e),
        DepthBoundsExt = ((int)0X8891),
        StencilBackFunc = ((int)0X8800),
        Rgb16Ext = ((int)0X8054),
        VertexAttribArray8Nv = ((int)0X8658),
        InstrumentBufferPointerSgix = ((int)0X8180),
        Texture1DBindingExt = ((int)0X8068),
        CurrentWeightArb = ((int)0X86a8),
        Reg28Ati = ((int)0X893d),
        ScalebiasHintSgix = ((int)0X8322),
        LuminanceIccSgix = ((int)0X8463),
        OutputColor1Ext = ((int)0X879c),
        ProjectionMatrix = ((int)0X0ba7),
        EdgeFlagArrayStrideExt = ((int)0X808c),
        PackSkipImages = ((int)0X806b),
        Sampler1DArrayShadowExt = ((int)0X8dc3),
        Blue = ((int)0X1905),
        MaxProgramNativeTexIndirectionsArb = ((int)0X8810),
        TextureMaxAnisotropyExt = ((int)0X84fe),
        Rgb12 = ((int)0X8053),
        Rgb10 = ((int)0X8052),
        Rgb16 = ((int)0X8054),
        Ccw = ((int)0X0901),
        InvariantValueExt = ((int)0X87ea),
        MatrixIndexArrayPointerArb = ((int)0X8849),
        T2fIuiV3fExt = ((int)0X81b2),
        SpriteAxisSgix = ((int)0X814a),
        Dot3RgbExt = ((int)0X8740),
        BackNormalsHintPgi = ((int)0X1a223),
        Luminance8uiExt = ((int)0X8d80),
        PhongHintWin = ((int)0X80eb),
        LineWidth = ((int)0X0b21),
        DrawBuffer12 = ((int)0X8831),
        IrInstrument1Sgix = ((int)0X817f),
        TextureMultiBufferHintSgix = ((int)0X812e),
        Reg14Ati = ((int)0X892f),
        IncrWrapExt = ((int)0X8507),
        ShaderObjectArb = ((int)0X8b48),
        FenceStatusNv = ((int)0X84f3),
        ColorMaterial = ((int)0X0b57),
        MaxConvolutionHeight = ((int)0X801b),
        TextureConstantDataSunx = ((int)0X81d6),
        Viewport = ((int)0X0ba2),
        ListBit = ((int)0X00020000),
        TextureBindingCubeMap = ((int)0X8514),
        UnsignedInt248Ext = ((int)0X84fa),
        PostConvolutionAlphaBiasExt = ((int)0X8023),
        Four = ((int)4),
        UnpackSubsampleRateSgix = ((int)0X85a1),
        Texture15 = ((int)0X84cf),
        Texture12 = ((int)0X84cc),
        Texture13 = ((int)0X84cd),
        Reg15Ati = ((int)0X8930),
        Texture11 = ((int)0X84cb),
        EyeDistanceToPointSgis = ((int)0X81f0),
        TextureCompareOperatorSgix = ((int)0X819b),
        UnpackAlignment = ((int)0X0cf5),
        BoolVec4 = ((int)0X8b59),
        UnpackImageHeightExt = ((int)0X806e),
        Texture18 = ((int)0X84d2),
        DualIntensity12Sgis = ((int)0X811a),
        Reg3Ati = ((int)0X8924),
        ColorMaterialParameter = ((int)0X0b56),
        Operand2Alpha = ((int)0X859a),
        MaxVertexTextureImageUnitsArb = ((int)0X8b4c),
        MadAti = ((int)0X8968),
        Map1TangentExt = ((int)0X8444),
        R1uiT2fC4fN3fV3fSun = ((int)0X85cb),
        AmbientAndDiffuse = ((int)0X1602),
        ElementArrayTypeAti = ((int)0X8769),
        GenerateMipmapSgis = ((int)0X8191),
        ProxyHistogram = ((int)0X8025),
        Operand1RgbArb = ((int)0X8591),
        SubAti = ((int)0X8965),
        Reg16Ati = ((int)0X8931),
        CopyPixelToken = ((int)0X0706),
        ColorAttachment0Ext = ((int)0X8ce0),
        TransposeTextureMatrixArb = ((int)0X84e5),
        EdgeFlagArrayStride = ((int)0X808c),
        AttribArrayPointerNv = ((int)0X8645),
        MaxProjectionStackDepth = ((int)0X0d38),
        Modelview18Arb = ((int)0X8732),
        FloatMat4 = ((int)0X8b5c),
        DepthTest = ((int)0X0b71),
        BackSecondaryColorNv = ((int)0X8c78),
        ColorAttachment13Ext = ((int)0X8ced),
        Map2BinormalExt = ((int)0X8447),
        BoolArb = ((int)0X8b56),
        CompressedTextureFormats = ((int)0X86a3),
        Source2AlphaArb = ((int)0X858a),
        CompressedAlphaArb = ((int)0X84e9),
        PostConvolutionRedScaleExt = ((int)0X801c),
        SignedLuminance8Nv = ((int)0X8702),
        Light4 = ((int)0X4004),
        Aux1 = ((int)0X040a),
        StencilClearTagValueExt = ((int)0X88f3),
        IntSampler2DExt = ((int)0X8dca),
        OutputTextureCoord31Ext = ((int)0X87bc),
        PostConvolutionBlueScaleExt = ((int)0X801e),
        TextureLequalRSgix = ((int)0X819c),
        PixelMapIToA = ((int)0X0c75),
        ColorAttachment8Ext = ((int)0X8ce8),
        FramebufferCompleteExt = ((int)0X8cd5),
        ColorTableBiasSgi = ((int)0X80d7),
        FloatMat4x3 = ((int)0X8b6a),
        PnTrianglesPointModeLinearAti = ((int)0X87f5),
        Operand2Rgb = ((int)0X8592),
        OpDot3Ext = ((int)0X8784),
        R5G6B5IccSgix = ((int)0X8466),
        Notequal = ((int)0X0205),
        Polygon = ((int)0X0009),
        PixelPackBuffer = ((int)0X88eb),
        Reg10Ati = ((int)0X892b),
        TexturePriorityExt = ((int)0X8066),
        PixelTexGenSgix = ((int)0X8139),
        ColorMatrixStackDepth = ((int)0X80b2),
        TextureCubeMapNegativeZArb = ((int)0X851a),
        HalfBitAti = ((int)0X00000008),
        Reg25Ati = ((int)0X893a),
        Sluminance8Alpha8Ext = ((int)0X8c45),
        OutputTextureCoord19Ext = ((int)0X87b0),
        SampleBuffers = ((int)0X80a8),
        StaticRead = ((int)0X88e5),
        PackImageHeight = ((int)0X806c),
        HistogramLuminanceSizeExt = ((int)0X802c),
        BlendEquationRgb = ((int)0X8009),
        SampleMaskInvertExt = ((int)0X80ab),
        Gequal = ((int)0X0206),
        ElementArrayBuffer = ((int)0X8893),
        Nearest = ((int)0X2600),
        ProgramLengthNv = ((int)0X8627),
        FramebufferIncompleteDrawBufferExt = ((int)0X8cdb),
        Hilo16Nv = ((int)0X86f8),
        ColorTableLuminanceSizeSgi = ((int)0X80de),
        MatSpecularBitPgi = ((int)0X04000000),
        BlendEquationRgbExt = ((int)0X8009),
        IndexBits = ((int)0X0d51),
        TextureCubeMapNegativeYArb = ((int)0X8518),
        PointDistanceAttenuationArb = ((int)0X8129),
        MaxExt = ((int)0X8008),
        MaxProgramCallDepthNv = ((int)0X88f5),
        MatDiffuseBitPgi = ((int)0X00400000),
        DualTextureSelectSgis = ((int)0X8124),
        TextureCoordArrayStride = ((int)0X808a),
        FloatMat2x4 = ((int)0X8b66),
        MatAmbientAndDiffuseBitPgi = ((int)0X00200000),
        OutputFogExt = ((int)0X87bd),
        LineStipplePattern = ((int)0X0b25),
        DiscardNv = ((int)0X8530),
        FloatMat2x3 = ((int)0X8b65),
        IndexMaterialFaceExt = ((int)0X81ba),
        Source0AlphaExt = ((int)0X8588),
        Luminance12Alpha4Ext = ((int)0X8046),
        Modelview5Arb = ((int)0X8725),
        PixelMapBToB = ((int)0X0c78),
        False = ((int)0),
        Texture2Arb = ((int)0X84c2),
        DrawBuffer13 = ((int)0X8832),
        TextureCubeMapNegativeXArb = ((int)0X8516),
        BlendSrcRgb = ((int)0X80c9),
        MaxVertexTextureImageUnits = ((int)0X8b4c),
        RgbaMode = ((int)0X0c31),
        Rgb32fArb = ((int)0X8815),
        ArrayPointer = ((int)0X8645),
        FloatR32Nv = ((int)0X8885),
        BinormalArrayExt = ((int)0X843a),
        MultisampleBit = ((int)0X20000000),
        AttribArrayStrideNv = ((int)0X8624),
        Reg13Ati = ((int)0X892e),
        DrawBuffer9Ati = ((int)0X882e),
        LerpAti = ((int)0X8969),
        MaxProgramExecInstructionsNv = ((int)0X88f4),
        PointSpriteRModeNv = ((int)0X8863),
        FragmentLightModelTwoSideSgix = ((int)0X8409),
        StencilTestTwoSideExt = ((int)0X8910),
        MaxColorMatrixStackDepth = ((int)0X80b3),
        Map2GridDomain = ((int)0X0dd2),
        VertexShaderInvariantsExt = ((int)0X87d1),
        StreamDrawArb = ((int)0X88e0),
        SpriteTranslationSgix = ((int)0X814b),
        PostConvolutionBlueBias = ((int)0X8022),
        OpAddExt = ((int)0X8787),
        ReflectionMap = ((int)0X8512),
        SecondaryColorArraySizeExt = ((int)0X845a),
        TextureRedTypeArb = ((int)0X8c10),
        DrawBuffer15 = ((int)0X8834),
        LightModelTwoSide = ((int)0X0b52),
        BlueBits = ((int)0X0d54),
        Depth24Stencil8Ext = ((int)0X88f0),
        Reg4Ati = ((int)0X8925),
        UnsignedByte = ((int)0X1401),
        OutputTextureCoord24Ext = ((int)0X87b5),
        DrawBuffer8Ati = ((int)0X882d),
        CurrentMatrixNv = ((int)0X8641),
        OutputTextureCoord20Ext = ((int)0X87b1),
        Exp2 = ((int)0X0801),
        FragmentDepthExt = ((int)0X8452),
        DotProductDepthReplaceNv = ((int)0X86ed),
        FogCoordinateArrayStrideExt = ((int)0X8455),
        Or = ((int)0X1507),
        VertexArrayStride = ((int)0X807c),
        StrictScissorHintPgi = ((int)0X1a218),
        SecondaryColorArrayStrideExt = ((int)0X845c),
        Texture8Arb = ((int)0X84c8),
        PreviousExt = ((int)0X8578),
        CompressedSrgb = ((int)0X8c48),
        FloatMat3x4 = ((int)0X8b68),
        StencilBufferBit = ((int)0X00000400),
        ColorAttachment11Ext = ((int)0X8ceb),
        MaxDrawBuffers = ((int)0X8824),
        OutOfMemory = ((int)0X0505),
        FloatMat3x2 = ((int)0X8b67),
        Luminance12Alpha12 = ((int)0X8047),
        ImageTranslateYHp = ((int)0X8158),
        EvalVertexAttrib13Nv = ((int)0X86d3),
        VertexProgramPointSizeArb = ((int)0X8642),
        Reg22Ati = ((int)0X8937),
        ProgramAluInstructionsArb = ((int)0X8805),
        TransformBit = ((int)0X00001000),
        OpSetLtExt = ((int)0X878d),
        NoError = ((int)0),
        FramebufferSrgbExt = ((int)0X8db9),
        InfoLogLength = ((int)0X8b84),
        LuminanceFloat32Ati = ((int)0X8818),
        ColorMatrixSgi = ((int)0X80b1),
        StencilBackPassDepthFail = ((int)0X8802),
        VertexShaderLocalConstantsExt = ((int)0X87d2),
        ColorAttachment12Ext = ((int)0X8cec),
        SpotCutoff = ((int)0X1206),
        Texture3D = ((int)0X806f),
        WeightSumUnityArb = ((int)0X86a6),
        MaxTextureUnits = ((int)0X84e2),
        StaticCopy = ((int)0X88e6),
        VertexArrayListIbm = ((int)103070),
        DrawBuffer2Ati = ((int)0X8827),
        EdgeFlagArray = ((int)0X8079),
        BufferFlushingUnmapApple = ((int)0X8a13),
        Reg23Ati = ((int)0X8938),
        ShaderType = ((int)0X8b4f),
        InvalidValue = ((int)0X0501),
        VertexAttribArray9Nv = ((int)0X8659),
        Con2Ati = ((int)0X8943),
        TextureFilter4SizeSgis = ((int)0X8147),
        LuminanceFloat16Ati = ((int)0X881e),
        ColorMatrixStackDepthSgi = ((int)0X80b2),
        BlendDstAlpha = ((int)0X80ca),
        PointSpriteNv = ((int)0X8861),
        DualLuminance4Sgis = ((int)0X8114),
        DualLuminanceAlpha4Sgis = ((int)0X811c),
        Gl8XBitAti = ((int)0X00000004),
        TextureIndexSizeExt = ((int)0X80ed),
        DotProductDiffuseCubeMapNv = ((int)0X86f1),
        OffsetProjectiveTexture2DNv = ((int)0X8850),
        Intensity8Ext = ((int)0X804b),
        BufferSerializedModifyApple = ((int)0X8a12),
        NormalMapExt = ((int)0X8511),
        HistogramRedSizeExt = ((int)0X8028),
        Luminance12Alpha12Ext = ((int)0X8047),
        SignedHiloNv = ((int)0X86f9),
        PrimitiveRestartNv = ((int)0X8558),
        AllowDrawMemHintPgi = ((int)0X1a211),
        NegateBitAti = ((int)0X00000004),
        SignedHilo16Nv = ((int)0X86fa),
        SampleCoverageValueArb = ((int)0X80aa),
        IntVec4Arb = ((int)0X8b55),
        RestartSun = ((int)0X0001),
        ProgramFormat = ((int)0X8876),
        UnsignedShort88RevApple = ((int)0X85bb),
        PixelTileHeightSgix = ((int)0X8141),
        FogDensity = ((int)0X0b62),
        NumInstructionsTotalAti = ((int)0X8972),
        SecondaryColorArrayBufferBindingArb = ((int)0X889c),
        DrawBuffer10 = ((int)0X882f),
        Modelview1Ext = ((int)0X850a),
        FloatRgbaModeNv = ((int)0X888e),
        SrgbExt = ((int)0X8c40),
        Ycrcb444Sgix = ((int)0X81bc),
        Nand = ((int)0X150e),
        Dsdt8Mag8Intensity8Nv = ((int)0X870b),
        EyeDistanceToLineSgis = ((int)0X81f2),
        MatrixIndexArrayTypeArb = ((int)0X8847),
        MatAmbientBitPgi = ((int)0X00100000),
        ClientAllAttribBits = unchecked((int)0Xffffffff),
        ColorAttachment15Ext = ((int)0X8cef),
        MaxVertexStreamsAti = ((int)0X876b),
        MaxFragmentProgramLocalParametersNv = ((int)0X8868),
        FogIndex = ((int)0X0b61),
        ConstantAttenuation = ((int)0X1207),
        ZoomY = ((int)0X0d17),
        ZoomX = ((int)0X0d16),
        FramebufferAttachmentTextureCubeMapFaceExt = ((int)0X8cd3),
        ReadWriteArb = ((int)0X88ba),
        AlphaTest = ((int)0X0bc0),
        Equiv = ((int)0X1509),
        DrawBuffer7Ati = ((int)0X882c),
        TextureEnv = ((int)0X2300),
        ListPrioritySgix = ((int)0X8182),
        Texture30 = ((int)0X84de),
        Texture31 = ((int)0X84df),
        ProgramAttribs = ((int)0X88ac),
        RenderbufferWidthExt = ((int)0X8d42),
        Matrix8 = ((int)0X88c8),
        Matrix9 = ((int)0X88c9),
        CurrentVertexAttrib = ((int)0X8626),
        Map2VertexAttrib34Nv = ((int)0X8673),
        TextureBufferDataStoreBindingExt = ((int)0X8c2d),
        GlobalAlphaSun = ((int)0X81d9),
        CompressedSignedRedRgtc1Ext = ((int)0X8dbc),
        TextureResidentExt = ((int)0X8067),
        OutputTextureCoord29Ext = ((int)0X87ba),
        EmbossConstantNv = ((int)0X855e),
        ConvolutionFilterScale = ((int)0X8014),
        HistogramFormatExt = ((int)0X8027),
        Srgb8Alpha8 = ((int)0X8c43),
        PostConvolutionAlphaScaleExt = ((int)0X801f),
        CombinerMuxSumNv = ((int)0X8547),
        FramebufferAttachmentObjectNameExt = ((int)0X8cd1),
        OpLogBase2Ext = ((int)0X8792),
        TextureEnvColor = ((int)0X2201),
        TextureDsSizeNv = ((int)0X871d),
        ModulateSubtractAti = ((int)0X8746),
        Gl4Pass0Ext = ((int)0X80a4),
        ConstantExt = ((int)0X8576),
        ImageMagFilterHp = ((int)0X815c),
        LocalExt = ((int)0X87c4),
        Source0RgbArb = ((int)0X8580),
        FragmentLight3Sgix = ((int)0X840f),
        AddSigned = ((int)0X8574),
        MaxTextureUnitsArb = ((int)0X84e2),
        Reg0Ati = ((int)0X8921),
        SignedRgba8Nv = ((int)0X86fc),
        DualLuminance12Sgis = ((int)0X8116),
        FragmentProgramNv = ((int)0X8870),
        DrawBuffer1Ati = ((int)0X8826),
        Intensity16uiExt = ((int)0X8d79),
        BufferSizeArb = ((int)0X8764),
        OutputTextureCoord21Ext = ((int)0X87b2),
        NameStackDepth = ((int)0X0d70),
        BlendEquationExt = ((int)0X8009),
        VertexWeightArraySizeExt = ((int)0X850d),
        Texture20 = ((int)0X84d4),
        BackLeft = ((int)0X0402),
        OpRecipExt = ((int)0X8794),
        RedMinClampIngr = ((int)0X8560),
        FenceApple = ((int)0X8a0b),
        OpMaxExt = ((int)0X878a),
        TextureMaxClampRSgix = ((int)0X836b),
        DrawBuffer0Ati = ((int)0X8825),
        TextureFloatComponentsNv = ((int)0X888c),
        OutputTextureCoord16Ext = ((int)0X87ad),
        Alpha8 = ((int)0X803c),
        TriangleMeshSun = ((int)0X8615),
        VertexArrayPointer = ((int)0X808e),
        UnsignedByte233RevExt = ((int)0X8362),
        ConvolutionFormatExt = ((int)0X8017),
        EdgeFlagArrayListStrideIbm = ((int)103085),
        ObjectActiveUniformsArb = ((int)0X8b86),
        TextureBindingRectangleArb = ((int)0X84f6),
        SampleCoverage = ((int)0X80a0),
        TextureDepthTypeArb = ((int)0X8c16),
        LoScaleNv = ((int)0X870f),
        DrawBuffer9Arb = ((int)0X882e),
        StencilIndex1Ext = ((int)0X8d46),
        VertexWeightingExt = ((int)0X8509),
        ColorIndex = ((int)0X1900),
        DeformationsMaskSgix = ((int)0X8196),
        Version = ((int)0X1f02),
        AllowDrawWinHintPgi = ((int)0X1a20f),
        Source0AlphaArb = ((int)0X8588),
        Alpha4 = ((int)0X803b),
        Dot3Rgb = ((int)0X86ae),
        CullModesNv = ((int)0X86e0),
        MaterialSideHintPgi = ((int)0X1a22c),
        MirroredRepeatIbm = ((int)0X8370),
        StencilFunc = ((int)0X0b92),
        DepthBufferBit = ((int)0X00000100),
        CombineRgbExt = ((int)0X8571),
        Map2VertexAttrib74Nv = ((int)0X8677),
        TextureLodBiasRSgix = ((int)0X8190),
        StencilPassDepthPass = ((int)0X0b96),
        DynamicCopyArb = ((int)0X88ea),
        VertexProgramPointSize = ((int)0X8642),
        OutputTextureCoord11Ext = ((int)0X87a8),
        Convolution1D = ((int)0X8010),
        VariantArrayTypeExt = ((int)0X87e7),
        DualLuminanceAlpha8Sgis = ((int)0X811d),
        SwizzleStrAti = ((int)0X8976),
        ColorIndexes = ((int)0X1603),
        SignedIntensity8Nv = ((int)0X8708),
        AlphaBias = ((int)0X0d1d),
        VertexAttribArray4Nv = ((int)0X8654),
        UnpackLsbFirst = ((int)0X0cf1),
        CurrentOcclusionQueryIdNv = ((int)0X8865),
        DepthComponent32Arb = ((int)0X81a7),
        GeometryDeformationBitSgix = ((int)0X00000002),
        Map2VertexAttrib44Nv = ((int)0X8674),
        ProgramObjectArb = ((int)0X8b40),
        DecrWrap = ((int)0X8508),
        Texture6Arb = ((int)0X84c6),
        Texture3 = ((int)0X84c3),
        Points = ((int)0X0000),
        UniformBufferBindingExt = ((int)0X8def),
        ProgramErrorPositionArb = ((int)0X864b),
        ConvolutionHintSgix = ((int)0X8316),
        SecondaryColorArrayStride = ((int)0X845c),
        Operand3AlphaNv = ((int)0X859b),
        UnsignedInt8888Reversed = ((int)0X8367),
        PointSizeMaxExt = ((int)0X8127),
        Texture12Arb = ((int)0X84cc),
        IntSampler1DExt = ((int)0X8dc9),
        ETimesFNv = ((int)0X8531),
        VertexArrayTypeExt = ((int)0X807b),
        BufferAccessArb = ((int)0X88bb),
        Rgb4 = ((int)0X804f),
        MaxVertexArrayRangeElementNv = ((int)0X8520),
        ColorArraySizeExt = ((int)0X8081),
        ActiveVaryingsNv = ((int)0X8c81),
        UnpackImageDepthSgis = ((int)0X8133),
        VertexProgramTwoSideNv = ((int)0X8643),
        UnsignedInt8888Rev = ((int)0X8367),
        Dot3RgbaArb = ((int)0X86af),
        EyePlaneAbsoluteNv = ((int)0X855c),
        DepthTextureMode = ((int)0X884b),
        BoolVec2Arb = ((int)0X8b57),
        YExt = ((int)0X87d6),
        Always = ((int)0X0207),
        CurrentRasterPositionValid = ((int)0X0b08),
        Operand1RgbExt = ((int)0X8591),
        RescaleNormalExt = ((int)0X803a),
        OffsetTextureScaleNv = ((int)0X86e2),
        NormalArrayBufferBinding = ((int)0X8897),
        FragmentLight4Sgix = ((int)0X8410),
        PointFadeThresholdSize = ((int)0X8128),
        MaxOptimizedVertexShaderVariantsExt = ((int)0X87cb),
        UnsignedInt10F11F11FRevExt = ((int)0X8c3b),
        VertexArrayRangeApple = ((int)0X851d),
        SluminanceAlpha = ((int)0X8c44),
        SpotDirection = ((int)0X1204),
        ArrayNormalized = ((int)0X886a),
        DecrWrapExt = ((int)0X8508),
        Alpha12 = ((int)0X803d),
        CombinerCdOutputNv = ((int)0X854b),
        RgbIccSgix = ((int)0X8460),
        TextureCompressionHint = ((int)0X84ef),
        Gl2Pass1Sgis = ((int)0X80a3),
        ResampleReplicateOml = ((int)0X8986),
        MaxConvolutionHeightExt = ((int)0X801b),
        ScaleByOneHalfNv = ((int)0X8540),
        PixelMapSToSSize = ((int)0X0cb1),
        ArrayBufferBinding = ((int)0X8894),
        Map2VertexAttrib144Nv = ((int)0X867e),
        OcclusionTestHp = ((int)0X8165),
        StencilIndex4Ext = ((int)0X8d47),
        C4fN3fV3f = ((int)0X2a26),
        InvalidEnum = ((int)0X0500),
        DepthBits = ((int)0X0d56),
        CompressedSrgbAlphaExt = ((int)0X8c49),
        DrawBuffer4Arb = ((int)0X8829),
        TextureCubeMapPositiveYExt = ((int)0X8517),
        ProgramParameters = ((int)0X88a8),
        Gl2Bytes = ((int)0X1407),
        PreviousTextureInputNv = ((int)0X86e4),
        CopyInverted = ((int)0X150c),
        ImageRotateOriginYHp = ((int)0X815b),
        Matrix28 = ((int)0X88dc),
        FogOffsetValueSgix = ((int)0X8199),
        FuncReverseSubtractExt = ((int)0X800b),
        TextureBlueTypeArb = ((int)0X8c12),
        Map2TextureCoord1 = ((int)0X0db3),
        Exp = ((int)0X0800),
        PostColorMatrixRedScale = ((int)0X80b4),
        ColorArrayListIbm = ((int)103072),
        MaxGeometryTextureImageUnitsExt = ((int)0X8c29),
        SignedRgb8Nv = ((int)0X86ff),
        EmbossLightNv = ((int)0X855d),
        LuminanceAlphaFloat32Ati = ((int)0X8819),
        LuminanceAlpha16fArb = ((int)0X881f),
        Map1BinormalExt = ((int)0X8446),
        ColorTable = ((int)0X80d0),
        DrawBuffer7Arb = ((int)0X882c),
        Eval2DNv = ((int)0X86c0),
        FramebufferIncompleteFormatsExt = ((int)0X8cda),
        Operand2AlphaExt = ((int)0X859a),
        ModelviewStackDepth = ((int)0X0ba3),
        Intensity8 = ((int)0X804b),
        FormatSubsample2424Oml = ((int)0X8982),
        Modelview9Arb = ((int)0X8729),
        ShadowAttenuationExt = ((int)0X834e),
        SampleMaskSgis = ((int)0X80a0),
        ColorSumExt = ((int)0X8458),
        ClampToEdge = ((int)0X812f),
        NormalArrayListStrideIbm = ((int)103081),
        ColorArrayPointerExt = ((int)0X8090),
        TextureGreenSize = ((int)0X805d),
        BlendDstRgb = ((int)0X80c8),
        TextureCompressedImageSizeArb = ((int)0X86a0),
        CurrentRasterSecondaryColor = ((int)0X845f),
        Convolution2D = ((int)0X8011),
        Gl1PassExt = ((int)0X80a1),
        CubicExt = ((int)0X8334),
        VertexAttribArray3Nv = ((int)0X8653),
        ProxyTexture3D = ((int)0X8070),
        ProxyTexture2D = ((int)0X8064),
        ProxyTexture1D = ((int)0X8063),
        ArrayBuffer = ((int)0X8892),
        OpClampExt = ((int)0X878e),
        ParallelArraysIntel = ((int)0X83f4),
        ListIndex = ((int)0X0b33),
        OneMinusSrcAlpha = ((int)0X0303),
        SamplesExt = ((int)0X80a9),
        SecondaryColorArrayExt = ((int)0X845e),
        DualIntensity16Sgis = ((int)0X811b),
        ConstantAlpha = ((int)0X8003),
        OutputTextureCoord10Ext = ((int)0X87a7),
        Texture5Arb = ((int)0X84c5),
        ProxyTexture1DStackMesax = ((int)0X875b),
        ObjectPointSgis = ((int)0X81f5),
        ReduceExt = ((int)0X8016),
        Clear = ((int)0X1500),
        CompressedLuminanceAlpha = ((int)0X84eb),
        FragmentShaderDerivativeHint = ((int)0X8b8b),
        MaxProgramLocalParameters = ((int)0X88b4),
        SelectionBufferSize = ((int)0X0df4),
        DepthWritemask = ((int)0X0b72),
        FuncSubtract = ((int)0X800a),
        ColorArrayBufferBinding = ((int)0X8898),
        TextureApplicationModeExt = ((int)0X834f),
        RenderbufferHeightExt = ((int)0X8d43),
        WExt = ((int)0X87d8),
        Modelview0Ext = ((int)0X1700),
        CurrentQuery = ((int)0X8865),
        TextureMaxClampTSgix = ((int)0X836a),
        Gl4Pass3Ext = ((int)0X80a7),
        VertexArrayCountExt = ((int)0X807d),
        Rgb5A1Ext = ((int)0X8057),
        DrawBuffer0Arb = ((int)0X8825),
        TextureBindingCubeMapExt = ((int)0X8514),
        DistanceAttenuationSgis = ((int)0X8129),
        OffsetHiloProjectiveTexture2DNv = ((int)0X8856),
        ColorBufferBit = ((int)0X00004000),
        MaxGeometryOutputVerticesExt = ((int)0X8de0),
        Map1VertexAttrib114Nv = ((int)0X866b),
        InvertedScreenWRend = ((int)0X8491),
        Reg12Ati = ((int)0X892d),
        VertexArrayRangePointerApple = ((int)0X8521),
        MirroredRepeat = ((int)0X8370),
        CoordReplaceNv = ((int)0X8862),
        TextureLodBiasSSgix = ((int)0X818e),
        OpMaddExt = ((int)0X8788),
        Left = ((int)0X0406),
        Intensity4 = ((int)0X804a),
        Color4BitPgi = ((int)0X00020000),
        CompressedSrgbAlphaS3tcDxt5Ext = ((int)0X8c4f),
        EvalVertexAttrib3Nv = ((int)0X86c9),
        FuncAdd = ((int)0X8006),
        Texture3DBindingExt = ((int)0X806a),
        SwizzleStqAti = ((int)0X8977),
        ProgramNativeInstructions = ((int)0X88a2),
        MaxTextureSize = ((int)0X0d33),
        TexturePriority = ((int)0X8066),
        Gl4Pass1Ext = ((int)0X80a5),
        DrawBuffer3Arb = ((int)0X8828),
        ProxyTexture1DArrayExt = ((int)0X8c19),
        Gl2Pass0Sgis = ((int)0X80a2),
        OpMulExt = ((int)0X8786),
        DualAlpha12Sgis = ((int)0X8112),
        CombineAlpha = ((int)0X8572),
        MaxVertexUniformComponentsArb = ((int)0X8b4a),
        OutputTextureCoord17Ext = ((int)0X87ae),
        CombineArb = ((int)0X8570),
        VertexProgramBindingNv = ((int)0X864a),
        CoordReplaceArb = ((int)0X8862),
        Dot3RgbaExt = ((int)0X8741),
        NormalArray = ((int)0X8075),
        MaxVaryingFloatsArb = ((int)0X8b4b),
        ModelviewMatrix = ((int)0X0ba6),
        Luminance32uiExt = ((int)0X8d74),
        PixelTransform2DExt = ((int)0X8330),
        TextureBlueSizeExt = ((int)0X805e),
        RescaleNormal = ((int)0X803a),
        Map2VertexAttrib94Nv = ((int)0X8679),
        VertexBlendArb = ((int)0X86a7),
        NormalMapArb = ((int)0X8511),
        Alpha8uiExt = ((int)0X8d7e),
        PostTextureFilterBiasSgix = ((int)0X8179),
        IuiN3fV2fExt = ((int)0X81af),
        MaxTextureLodBiasExt = ((int)0X84fd),
        FragmentColorExt = ((int)0X834c),
        ColorTableGreenSizeSgi = ((int)0X80db),
        DepthClampNv = ((int)0X864f),
        MaxFogFuncPointsSgis = ((int)0X812c),
        Intensity32uiExt = ((int)0X8d73),
        CompressedSrgbAlphaS3tcDxt3Ext = ((int)0X8c4e),
        Luminance8Alpha8Ext = ((int)0X8045),
        Float = ((int)0X1406),
        ClampFragmentColorArb = ((int)0X891b),
        Modelview10Arb = ((int)0X872a),
        NumLoopbackComponentsAti = ((int)0X8974),
        Texture26 = ((int)0X84da),
        Texture27 = ((int)0X84db),
        Rgba8uiExt = ((int)0X8d7c),
        TextureMinFilter = ((int)0X2801),
        Rgb32iExt = ((int)0X8d83),
        Max3DTextureSize = ((int)0X8073),
        FogCoordArrayStride = ((int)0X8455),
        Texture2 = ((int)0X84c2),
        UnsignedInt1010102Ext = ((int)0X8036),
        StencilAttachmentExt = ((int)0X8d20),
        MaxProgramParameterBufferSizeNv = ((int)0X8da1),
        Doublebuffer = ((int)0X0c32),
        EvalVertexAttrib6Nv = ((int)0X86cc),
        SampleAlphaToMaskExt = ((int)0X809e),
        MaxShininessNv = ((int)0X8504),
        OneExt = ((int)0X87de),
        ObjectDistanceToLineSgis = ((int)0X81f3),
        DetailTexture2DSgis = ((int)0X8095),
        Texture2DStackBindingMesax = ((int)0X875e),
        MaxProgramInstructions = ((int)0X88a1),
        OneMinusConstantAlpha = ((int)0X8004),
        CullFaceMode = ((int)0X0b45),
        PixelMapIToGSize = ((int)0X0cb3),
        AndReverse = ((int)0X1502),
        FogCoordinateArrayListIbm = ((int)103076),
        ProgramNativeAttribs = ((int)0X88ae),
        UnsignedInt2101010Rev = ((int)0X8368),
        BiasByNegativeOneHalfNv = ((int)0X8541),
        InterlaceReadIngr = ((int)0X8568),
        ColorTableBias = ((int)0X80d7),
        FloatRgb16Nv = ((int)0X8888),
        Map1VertexAttrib74Nv = ((int)0X8667),
        GenericAttribNv = ((int)0X8c7d),
        Map2Vertex4 = ((int)0X0db8),
        Matrix24 = ((int)0X88d8),
        StencilBackPassDepthFailAti = ((int)0X8802),
        Map2Vertex3 = ((int)0X0db7),
        TextureCoordNv = ((int)0X8c79),
        AndInverted = ((int)0X1504),
        Map2VertexAttrib84Nv = ((int)0X8678),
        AsyncReadPixelsSgix = ((int)0X835e),
        ColorIndex12Ext = ((int)0X80e6),
        ReplicateBorderHp = ((int)0X8153),
        SampleMaskValueSgis = ((int)0X80aa),
        PostColorMatrixColorTable = ((int)0X80d2),
        IndexArrayStride = ((int)0X8086),
        Bitmap = ((int)0X1a00),
        T2fIuiN3fV2fExt = ((int)0X81b3),
        PostColorMatrixBlueBiasSgi = ((int)0X80ba),
        MinmaxFormat = ((int)0X802f),
        EvalVertexAttrib0Nv = ((int)0X86c6),
        OrReverse = ((int)0X150b),
        Srgb = ((int)0X8c40),
        ArraySize = ((int)0X8623),
        Max3DTextureSizeExt = ((int)0X8073),
        Sampler1DShadowArb = ((int)0X8b61),
        LinearSharpenColorSgis = ((int)0X80af),
        FramebufferAttachmentLayeredExt = ((int)0X8da7),
        Rgb9E5Ext = ((int)0X8c3d),
        AlphaBits = ((int)0X0d55),
        Sluminance8 = ((int)0X8c47),
        Con7Ati = ((int)0X8948),
        Luminance12Alpha4 = ((int)0X8046),
        TextureGenS = ((int)0X0c60),
        Less = ((int)0X0201),
        TextureGenQ = ((int)0X0c63),
        UnsignedShort88Mesa = ((int)0X85ba),
        FloatVec3Arb = ((int)0X8b51),
        TextureGenT = ((int)0X0c61),
        CmykExt = ((int)0X800c),
        EvalVertexAttrib1Nv = ((int)0X86c7),
        Gl3D = ((int)0X0601),
        OpFracExt = ((int)0X8789),
        TextureBit = ((int)0X00040000),
        Map2VertexAttrib24Nv = ((int)0X8672),
        Rgb = ((int)0X1907),
        Con15Ati = ((int)0X8950),
        SampleAlphaToOneExt = ((int)0X809f),
        MultisampleExt = ((int)0X809d),
        DrawBuffer0 = ((int)0X8825),
        Interpolate = ((int)0X8575),
        Rgba32fArb = ((int)0X8814),
        SeparateSpecularColor = ((int)0X81fa),
        Aux0 = ((int)0X0409),
        StackUnderflow = ((int)0X0504),
        ConstantArb = ((int)0X8576),
        MaxFragmentUniformComponentsArb = ((int)0X8b49),
        FloatVec2Arb = ((int)0X8b50),
        OffsetHiloProjectiveTextureRectangleNv = ((int)0X8857),
        OffsetTexture2DNv = ((int)0X86e8),
        PackRowLength = ((int)0X0d02),
        RenderbufferBindingExt = ((int)0X8ca7),
        SmoothPointSizeRange = ((int)0X0b12),
        Con16Ati = ((int)0X8951),
        AddAti = ((int)0X8963),
        Matrix12 = ((int)0X88cc),
        VertexArrayType = ((int)0X807b),
        VertexAttribArrayBufferBinding = ((int)0X889f),
        Texture2DStackMesax = ((int)0X875a),
        CurrentMatrixIndexArb = ((int)0X8845),
        QueryCounterBitsArb = ((int)0X8864),
        TextureBaseLevelSgis = ((int)0X813c),
        GenerateMipmapHintSgis = ((int)0X8192),
        OutputTextureCoord14Ext = ((int)0X87ab),
        MaxTextureImageUnitsNv = ((int)0X8872),
        BlendSrcRgbExt = ((int)0X80c9),
        IndexWritemask = ((int)0X0c21),
        Position = ((int)0X1203),
        ProgramNativeParameters = ((int)0X88aa),
        XExt = ((int)0X87d5),
        Con17Ati = ((int)0X8952),
        DynamicDrawArb = ((int)0X88e8),
        BumpRotMatrixAti = ((int)0X8775),
        RenderbufferAlphaSizeExt = ((int)0X8d53),
        Combiner5Nv = ((int)0X8555),
        OffsetTextureBiasNv = ((int)0X86e3),
        Gl422RevAverageExt = ((int)0X80cf),
        WrapBorderSun = ((int)0X81d4),
        OutputVertexExt = ((int)0X879a),
        LoBiasNv = ((int)0X8715),
        HistogramBlueSize = ((int)0X802a),
        Combine4Nv = ((int)0X8503),
        FloatVec4Arb = ((int)0X8b52),
        UnsignedIntSampler1DExt = ((int)0X8dd1),
        ReplacementCodeArrayTypeSun = ((int)0X85c1),
        SamplesArb = ((int)0X80a9),
        ProgramNativeTexInstructionsArb = ((int)0X8809),
        ColorTableFormatSgi = ((int)0X80d8),
        ProxyTextureColorTableSgi = ((int)0X80bd),
        Map2VertexAttrib14Nv = ((int)0X8671),
        MaxViewportDims = ((int)0X0d3a),
        DepthComponent24Arb = ((int)0X81a6),
        ColorTableScaleSgi = ((int)0X80d6),
        AlphaMaxSgix = ((int)0X8321),
        PixelCubicWeightExt = ((int)0X8333),
        ProxyPostConvolutionColorTableSgi = ((int)0X80d4),
        DrawFramebufferBindingExt = ((int)0X8caa),
        EvalVertexAttrib5Nv = ((int)0X86cb),
        TextureComponents = ((int)0X1003),
        Map2TextureCoord4 = ((int)0X0db6),
        Map2TextureCoord2 = ((int)0X0db4),
        Map2TextureCoord3 = ((int)0X0db5),
        DepthPassInstrumentMaxSgix = ((int)0X8312),
        Matrix18 = ((int)0X88d2),
        Mult = ((int)0X0103),
        ImageScaleYHp = ((int)0X8156),
        ColorIndex8Ext = ((int)0X80e5),
        StencilBackPassDepthPassAti = ((int)0X8803),
        DependentGbTexture2DNv = ((int)0X86ea),
        Modelview0Arb = ((int)0X1700),
        SamplerCubeArb = ((int)0X8b60),
        BlendColor = ((int)0X8005),
        C3fV3f = ((int)0X2a24),
        UnsignedShort4444Ext = ((int)0X8033),
        FloatRgbNv = ((int)0X8882),
        ReplacementCodeArrayPointerSun = ((int)0X85c3),
        DrawPixelToken = ((int)0X0705),
        PointSizeGranularity = ((int)0X0b13),
        TextureGequalRSgix = ((int)0X819d),
        Max = ((int)0X8008),
        TriangleFan = ((int)0X0006),
        ImageScaleXHp = ((int)0X8155),
        QuadIntensity8Sgis = ((int)0X8123),
        UnpackSkipPixels = ((int)0X0cf4),
        LineLoop = ((int)0X0002),
        BlendDstAlphaExt = ((int)0X80ca),
        DualIntensity8Sgis = ((int)0X8119),
        Map1VertexAttrib154Nv = ((int)0X866f),
        Alpha12Ext = ((int)0X803d),
        MaxVertexShaderLocalConstantsExt = ((int)0X87c8),
        SpriteSgix = ((int)0X8148),
        AllowDrawFrgHintPgi = ((int)0X1a210),
        TextureCompressedArb = ((int)0X86a1),
        VertexArrayRangeLengthNv = ((int)0X851e),
        QuadAlpha8Sgis = ((int)0X811f),
        VertexAttribArrayBufferBindingArb = ((int)0X889f),
        Source0RgbExt = ((int)0X8580),
        V2f = ((int)0X2a20),
        FloatRgbaNv = ((int)0X8883),
        IdentityNv = ((int)0X862a),
        InvalidOperation = ((int)0X0502),
        Con13Ati = ((int)0X894e),
        AllowDrawObjHintPgi = ((int)0X1a20e),
        Map2VertexAttrib04Nv = ((int)0X8670),
        LinearDetailColorSgis = ((int)0X8099),
        SampleAlphaToOne = ((int)0X809f),
        VertexProgramTwoSide = ((int)0X8643),
        ActiveAttributes = ((int)0X8b89),
        TangentArrayStrideExt = ((int)0X843f),
        Luminance8Alpha8 = ((int)0X8045),
        DrawPixelsApple = ((int)0X8a0a),
        ValidateStatus = ((int)0X8b83),
        ClampToBorder = ((int)0X812d),
        DotProductTexture2DNv = ((int)0X86ee),
        R11fG11fB10fExt = ((int)0X8c3a),
        PointSizeMin = ((int)0X8126),
        AccumBufferBit = ((int)0X00000200),
        Texture15Arb = ((int)0X84cf),
        Gl3DColorTexture = ((int)0X0603),
        PreserveAti = ((int)0X8762),
        UnsignedIntSamplerBufferExt = ((int)0X8dd8),
        MaxElementsIndices = ((int)0X80e9),
        DotProductConstEyeReflectCubeMapNv = ((int)0X86f3),
        VertexProgramTwoSideArb = ((int)0X8643),
        QuadIntensity4Sgis = ((int)0X8122),
        Texture2D = ((int)0X0de1),
        SampleMaskValueExt = ((int)0X80aa),
        ImageMinFilterHp = ((int)0X815d),
        Con14Ati = ((int)0X894f),
        CompressedIntensityArb = ((int)0X84ec),
        LuminanceAlphaIntegerExt = ((int)0X8d9d),
        PixelTileCacheSizeSgix = ((int)0X8145),
        CurrentVertexWeightExt = ((int)0X850b),
        LuminanceAlpha8uiExt = ((int)0X8d81),
        Rgba16uiExt = ((int)0X8d76),
        BlueMaxClampIngr = ((int)0X8566),
        AutoNormal = ((int)0X0d80),
        Gl422Ext = ((int)0X80cc),
        Sampler2DRectArb = ((int)0X8b63),
        OffsetHiloTextureRectangleNv = ((int)0X8855),
        CompressedLuminanceAlphaArb = ((int)0X84eb),
        EvalVertexAttrib9Nv = ((int)0X86cf),
        RedScale = ((int)0X0d14),
        TextFragmentShaderAti = ((int)0X8200),
        ElementArrayBufferBinding = ((int)0X8895),
        CompressedRgbArb = ((int)0X84ed),
        RedMaxClampIngr = ((int)0X8564),
        Modulate = ((int)0X2100),
        Texcoord4BitPgi = unchecked((int)0X80000000),
        QueryResultAvailableArb = ((int)0X8867),
        ScalarExt = ((int)0X87be),
        TextureCoordArrayType = ((int)0X8089),
        DsdtMagVibNv = ((int)0X86f7),
        Right = ((int)0X0407),
        MaxAsyncDrawPixelsSgix = ((int)0X8360),
        Con1Ati = ((int)0X8942),
        Gl1PassSgis = ((int)0X80a1),
        ObjectLineSgis = ((int)0X81f7),
        ActiveTextureArb = ((int)0X84e0),
        SampleAlphaToOneSgis = ((int)0X809f),
        InvalidFramebufferOperationExt = ((int)0X0506),
        DrawBuffer15Ati = ((int)0X8834),
        MaxCubeMapTextureSizeArb = ((int)0X851c),
        UnsignedInt1010102 = ((int)0X8036),
        UnsignedIntSampler2DExt = ((int)0X8dd2),
        Map2VertexAttrib54Nv = ((int)0X8675),
        UnpackConstantDataSunx = ((int)0X81d5),
        Rgba4Ext = ((int)0X8056),
        UnpackClientStorageApple = ((int)0X85b2),
        FloatMat2Arb = ((int)0X8b5a),
        Alpha16Ext = ((int)0X803e),
        DrawBuffer11 = ((int)0X8830),
        CurrentIndex = ((int)0X0b01),
        Sampler2DShadow = ((int)0X8b62),
        TransposeModelviewMatrix = ((int)0X84e3),
        StencilClearValue = ((int)0X0b91),
        TextureDtSizeNv = ((int)0X871e),
        Separable2D = ((int)0X8012),
        TransformFeedbackRecordNv = ((int)0X8c86),
        BlueBias = ((int)0X0d1b),
        MirroredRepeatArb = ((int)0X8370),
        ColorArray = ((int)0X8076),
        RasterPositionUnclippedIbm = ((int)0X19262),
        ActiveVertexUnitsArb = ((int)0X86a5),
        AliasedPointSizeRange = ((int)0X846d),
        DrawBuffer13Ati = ((int)0X8832),
        Double = ((int)0X140a),
        FogColor = ((int)0X0b66),
        FramezoomFactorSgix = ((int)0X818c),
        Texture24 = ((int)0X84d8),
        Texture25 = ((int)0X84d9),
        Texture22 = ((int)0X84d6),
        PointSizeMinArb = ((int)0X8126),
        TextureWrapS = ((int)0X2802),
        Texture21 = ((int)0X84d5),
        RgbFloat16Ati = ((int)0X881b),
        MaxProgramParameters = ((int)0X88a9),
        T2fIuiN3fV3fExt = ((int)0X81b4),
        T2fC4fN3fV3f = ((int)0X2a2c),
        R1uiT2fN3fV3fSun = ((int)0X85ca),
        Texture28 = ((int)0X84dc),
        Texture29 = ((int)0X84dd),
        TextureBaseLevel = ((int)0X813c),
        PointSizeMaxArb = ((int)0X8127),
        Con10Ati = ((int)0X894b),
        Specular = ((int)0X1202),
        PostConvolutionRedBias = ((int)0X8020),
        Src0Alpha = ((int)0X8588),
        IndexLogicOp = ((int)0X0bf1),
        BinormalArrayStrideExt = ((int)0X8441),
        UnsignedIntSampler1DArrayExt = ((int)0X8dd6),
        NormalArrayPointer = ((int)0X808f),
        CompressedSluminance = ((int)0X8c4a),
        MagnitudeScaleNv = ((int)0X8712),
        AddSignedArb = ((int)0X8574),
        BufferUsageArb = ((int)0X8765),
        MinExt = ((int)0X8007),
        TextureTooLargeExt = ((int)0X8065),
        VertexAttribArray5Nv = ((int)0X8655),
        SignedLuminanceAlphaNv = ((int)0X8703),
        MaxOptimizedVertexShaderInvariantsExt = ((int)0X87cd),
        CurrentQueryArb = ((int)0X8865),
        TransformFeedbackAttribsNv = ((int)0X8c7e),
        PixelMapRToRSize = ((int)0X0cb6),
        HistogramAlphaSizeExt = ((int)0X802b),
        UnsignedShort565 = ((int)0X8363),
        IntSampler2DRectExt = ((int)0X8dcd),
        LogicOpMode = ((int)0X0bf0),
        Extensions = ((int)0X1f03),
        CompressedSrgbExt = ((int)0X8c48),
        StencilBackFuncAti = ((int)0X8800),
        AliasedLineWidthRange = ((int)0X846e),
        DudvAti = ((int)0X8779),
        DepthComponent32 = ((int)0X81a7),
        MaxProgramMatrixStackDepthArb = ((int)0X862e),
        Operand1AlphaExt = ((int)0X8599),
        PixelTexGenAlphaLsSgix = ((int)0X8189),
        MaxSpotExponentNv = ((int)0X8505),
        PixelCountNv = ((int)0X8866),
        TextureBinding1D = ((int)0X8068),
        EvalVertexAttrib10Nv = ((int)0X86d0),
        TextureBinding3D = ((int)0X806a),
        TextureBinding2D = ((int)0X8069),
        HiBiasNv = ((int)0X8714),
        TextureMaxClampSSgix = ((int)0X8369),
        CompressedSignedLuminanceAlphaLatc2Ext = ((int)0X8c73),
        Invert = ((int)0X150a),
        Luminance4Alpha4 = ((int)0X8043),
        Map1VertexAttrib144Nv = ((int)0X866e),
        MatShininessBitPgi = ((int)0X02000000),
        AttachedShaders = ((int)0X8b85),
        T2fIuiV2fExt = ((int)0X81b1),
        Spare0Nv = ((int)0X852e),
        PixelUnpackBufferExt = ((int)0X88ec),
        VertexAttribArray6Nv = ((int)0X8656),
        Map2GridSegments = ((int)0X0dd3),
        Matrix4 = ((int)0X88c4),
        TransformFeedbackBufferStartNv = ((int)0X8c84),
        DepthTextureModeArb = ((int)0X884b),
        Rgba16fArb = ((int)0X881a),
        FogCoordArrayType = ((int)0X8454),
        Decal = ((int)0X2101),
        FramebufferSrgbCapableExt = ((int)0X8dba),
        MirrorClampToEdgeExt = ((int)0X8743),
        WritePixelDataRangeLengthNv = ((int)0X887a),
        IntensityExt = ((int)0X8049),
        HistogramGreenSize = ((int)0X8029),
        DepthBias = ((int)0X0d1f),
        PixelMapIToRSize = ((int)0X0cb2),
        MaxVaryingFloats = ((int)0X8b4b),
        HintBit = ((int)0X00008000),
        TextureLuminanceSizeExt = ((int)0X8060),
        PixelModeBit = ((int)0X00000020),
        CombinerSumOutputNv = ((int)0X854c),
        MinmaxExt = ((int)0X802e),
        TextureFilterControlExt = ((int)0X8500),
        PolygonMode = ((int)0X0b40),
        LinearAttenuation = ((int)0X1208),
        FloatMat4x2 = ((int)0X8b69),
        CompressedSrgbAlpha = ((int)0X8c49),
        ColorClearValue = ((int)0X0c22),
        MvpMatrixExt = ((int)0X87e3),
        MaxProgramGenericAttribsNv = ((int)0X8da5),
        OpSubExt = ((int)0X8796),
        Alpha32iExt = ((int)0X8d84),
        FragmentLightingSgix = ((int)0X8400),
        ProgramParameterNv = ((int)0X8644),
        ConvolutionHeightExt = ((int)0X8019),
        MinProgramTexelOffsetNv = ((int)0X8904),
        MaxTransformFeedbackSeparateComponentsNv = ((int)0X8c80),
        TextureCubeMapPositiveXExt = ((int)0X8515),
        LineStipple = ((int)0X0b24),
        SampleCoverageInvertArb = ((int)0X80ab),
        PolygonStipple = ((int)0X0b42),
        ImplementationColorReadFormatOes = ((int)0X8b9b),
        Bgr = ((int)0X80e0),
        Modelview25Arb = ((int)0X8739),
        CombinerInputNv = ((int)0X8542),
        Modelview21Arb = ((int)0X8735),
        InverseNv = ((int)0X862b),
        OutputTextureCoord25Ext = ((int)0X87b6),
        TextureCoordArrayListStrideIbm = ((int)103084),
        PixelTileWidthSgix = ((int)0X8140),
        Sampler1DArrayExt = ((int)0X8dc0),
        Reg24Ati = ((int)0X8939),
        NumPassesAti = ((int)0X8970),
        FogCoordinateSourceExt = ((int)0X8450),
        InterpolateExt = ((int)0X8575),
        OutputTextureCoord7Ext = ((int)0X87a4),
        Reg5Ati = ((int)0X8926),
        FogCoordArrayPointer = ((int)0X8456),
        Sampler3D = ((int)0X8b5f),
        ColorTableAlphaSize = ((int)0X80dd),
        OffsetTextureRectangleNv = ((int)0X864c),
        QueryResult = ((int)0X8866),
        ColorTableRedSizeSgi = ((int)0X80da),
        EvalVertexAttrib12Nv = ((int)0X86d2),
        ClientPixelStoreBit = ((int)0X00000001),
        YcrcbaSgix = ((int)0X8319),
        PixelGroupColorSgis = ((int)0X8356),
        Diffuse = ((int)0X1201),
        LineResetToken = ((int)0X0707),
        MaxProgramTexIndirectionsArb = ((int)0X880d),
        UnsignedByte332Ext = ((int)0X8032),
        AddSignedExt = ((int)0X8574),
        Dot2AddAti = ((int)0X896c),
        ListMode = ((int)0X0b30),
        ColorClearUnclampedValueAti = ((int)0X8835),
        UnsignedByte233Rev = ((int)0X8362),
        ProgramFormatAsciiArb = ((int)0X8875),
        AsyncHistogramSgix = ((int)0X832c),
        TextureUnsignedRemapModeNv = ((int)0X888f),
        TextureCubeMapPositiveZExt = ((int)0X8519),
        Copy = ((int)0X1503),
        ReplacementCodeArraySun = ((int)0X85c0),
        ProxyTexture3DExt = ((int)0X8070),
        IndexArray = ((int)0X8077),
        DsScaleNv = ((int)0X8710),
        FloatRgba32Nv = ((int)0X888b),
        ElementArrayPointerApple = ((int)0X876a),
        SphereMap = ((int)0X2402),
        Map2Index = ((int)0X0db1),
        UnsignedShort565Ext = ((int)0X8363),
        DualAlpha16Sgis = ((int)0X8113),
        Rgb10A2Ext = ((int)0X8059),
        InterlaceOml = ((int)0X8980),
        EdgeFlag = ((int)0X0b43),
        MaxModelviewStackDepth = ((int)0X0d36),
        FogScaleSgix = ((int)0X81fc),
        DualAlpha8Sgis = ((int)0X8111),
        RgbScaleArb = ((int)0X8573),
        PackSkipImagesExt = ((int)0X806b),
        Rgba = ((int)0X1908),
        PerturbExt = ((int)0X85ae),
        FrontAndBack = ((int)0X0408),
        Modelview20Arb = ((int)0X8734),
        LineWidthGranularity = ((int)0X0b23),
        SamplesSgis = ((int)0X80a9),
        Texture4DSgis = ((int)0X8134),
        Con18Ati = ((int)0X8953),
        MinmaxFormatExt = ((int)0X802f),
        StencilFail = ((int)0X0b94),
        CurrentMatrixArb = ((int)0X8641),
        Reg27Ati = ((int)0X893c),
        ObjectBufferSizeAti = ((int)0X8764),
        OpSetGeExt = ((int)0X878c),
        FragmentLight7Sgix = ((int)0X8413),
        PrimaryColorArb = ((int)0X8577),
        ReadBuffer = ((int)0X0c02),
        CompressedRgbFxt13Dfx = ((int)0X86b0),
        ActiveUniforms = ((int)0X8b86),
        Dsdt8Mag8Nv = ((int)0X870a),
        Reduce = ((int)0X8016),
        AlphaMinSgix = ((int)0X8320),
        SampleBuffersExt = ((int)0X80a8),
        TextureCubeMapNegativeYExt = ((int)0X8518),
        Modelview29Arb = ((int)0X873d),
        OffsetTexture2DScaleNv = ((int)0X86e2),
        Map1VertexAttrib94Nv = ((int)0X8669),
        Reg20Ati = ((int)0X8935),
        Color = ((int)0X1800),
        ColorArrayTypeExt = ((int)0X8082),
        PixelTexGenQCeilingSgix = ((int)0X8184),
        Con0Ati = ((int)0X8941),
        DualAlpha4Sgis = ((int)0X8110),
        TextureRectangleArb = ((int)0X84f5),
        Luminance16IccSgix = ((int)0X8469),
        IncrWrap = ((int)0X8507),
        TextureStackDepth = ((int)0X0ba5),
        LuminanceAlpha16iExt = ((int)0X8d8d),
        MirrorClampToEdgeAti = ((int)0X8743),
        DepthStencilExt = ((int)0X84f9),
        AlphaIccSgix = ((int)0X8462),
        Alpha32fArb = ((int)0X8816),
        DstAlpha = ((int)0X0304),
        Lines = ((int)0X0001),
        LogicOp = ((int)0X0bf1),
        Reg21Ati = ((int)0X8936),
        ConvolutionBorderMode = ((int)0X8013),
        IntVec3Arb = ((int)0X8b54),
        CullFragmentNv = ((int)0X86e7),
        RegisterCombinersNv = ((int)0X8522),
        Texture1 = ((int)0X84c1),
        VertexAttribArray1Nv = ((int)0X8651),
        Matrix14 = ((int)0X88ce),
        ProxyColorTableSgi = ((int)0X80d3),
        FullRangeExt = ((int)0X87e1),
        UnsignedInt8888 = ((int)0X8035),
        ColorAttachment7Ext = ((int)0X8ce7),
        SingleColorExt = ((int)0X81f9),
        DotProductTextureRectangleNv = ((int)0X864e),
        Modelview23Arb = ((int)0X8737),
        Shininess = ((int)0X1601),
        PixelMapGToGSize = ((int)0X0cb7),
        RenderbufferInternalFormatExt = ((int)0X8d44),
        MaxVertexUniformComponents = ((int)0X8b4a),
        ColorTableFormat = ((int)0X80d8),
        ProgramString = ((int)0X8628),
        ObjectTypeArb = ((int)0X8b4e),
        EdgeFlagArrayExt = ((int)0X8079),
        PointSizeMax = ((int)0X8127),
        PostConvolutionBlueScale = ((int)0X801e),
        ElementArrayPointerAti = ((int)0X876a),
        PixelMapIToI = ((int)0X0c70),
        R1uiV3fSun = ((int)0X85c4),
        ColorIndex4Ext = ((int)0X80e4),
        CompressedRedRgtc1Ext = ((int)0X8dbb),
        SampleMaskInvertSgis = ((int)0X80ab),
        BgraExt = ((int)0X80e1),
        CompressedSrgbS3tcDxt1Ext = ((int)0X8c4c),
        CompressedSrgbAlphaS3tcDxt1Ext = ((int)0X8c4d),
        Modelview24Arb = ((int)0X8738),
        RgbIntegerExt = ((int)0X8d98),
        Map1VertexAttrib84Nv = ((int)0X8668),
        Gl4Pass1Sgis = ((int)0X80a5),
        PixelSubsample2424Sgix = ((int)0X85a3),
        PostConvolutionBlueBiasExt = ((int)0X8022),
        Operand1Rgb = ((int)0X8591),
        NormalBitPgi = ((int)0X08000000),
        BlendEquationAlphaExt = ((int)0X883d),
        EnableBit = ((int)0X00002000),
        StrictDepthfuncHintPgi = ((int)0X1a216),
        UnpackResampleSgix = ((int)0X842d),
        MaxFragmentBindableUniformsExt = ((int)0X8de3),
        ConserveMemoryHintPgi = ((int)0X1a1fd),
        ReflectionMapExt = ((int)0X8512),
        FogDistanceModeNv = ((int)0X855a),
        TextureSharedSizeExt = ((int)0X8c3f),
        VertexAttribArrayIntegerNv = ((int)0X88fd),
        StorageSharedApple = ((int)0X85bf),
        PixelMapIToASize = ((int)0X0cb5),
        TextureLoSizeNv = ((int)0X871c),
        PointDistanceAttenuation = ((int)0X8129),
        ProxyTextureRectangleArb = ((int)0X84f7),
        PixelMinFilterExt = ((int)0X8332),
        CompareRefDepthToTextureExt = ((int)0X884e),
        CubicHp = ((int)0X815f),
        Intensity16fArb = ((int)0X881d),
        SrcColor = ((int)0X0300),
        TextureCoordArray = ((int)0X8078),
        TextureCoordArrayCountExt = ((int)0X808b),
        GreenBias = ((int)0X0d19),
        OutputTextureCoord27Ext = ((int)0X87b8),
        UnsignedInt8888RevExt = ((int)0X8367),
        Luminance16uiExt = ((int)0X8d7a),
        Map1VertexAttrib24Nv = ((int)0X8662),
        CurrentRasterColor = ((int)0X0b04),
        IntensityFloat32Ati = ((int)0X8817),
        MatEmissionBitPgi = ((int)0X00800000),
        DrawBuffer6 = ((int)0X882b),
        ImageCubicWeightHp = ((int)0X815e),
        MaxMultisampleCoverageModesNv = ((int)0X8e11),
        WriteOnlyArb = ((int)0X88b9),
        LineStippleRepeat = ((int)0X0b26),
        MaxElementsVertices = ((int)0X80e8),
        RedBits = ((int)0X0d52),
        VertexWeightArrayTypeExt = ((int)0X850e),
        UnpackSkipRows = ((int)0X0cf3),
        SeparateAttribsNv = ((int)0X8c8d),
        BlueScale = ((int)0X0d1a),
        ImageRotateAngleHp = ((int)0X8159),
        MaxDrawBuffersAti = ((int)0X8824),
        ObjectDistanceToPointSgis = ((int)0X81f1),
        IuiV2fExt = ((int)0X81ad),
        TransformFeedbackPrimitivesWrittenNv = ((int)0X8c88),
        Src1Rgb = ((int)0X8581),
        SamplesPassedArb = ((int)0X8914),
        Alpha16 = ((int)0X803e),
        PolygonOffsetBiasExt = ((int)0X8039),
        CompressedSluminanceAlphaExt = ((int)0X8c4b),
        UnsignedShort5551 = ((int)0X8034),
        Modelview27Arb = ((int)0X873b),
        OffsetTextureMatrixNv = ((int)0X86e1),
        IndexArrayBufferBinding = ((int)0X8899),
        EyeLineSgis = ((int)0X81f6),
        IndexMode = ((int)0X0c30),
        Gl3Bytes = ((int)0X1408),
        RenderbufferRedSizeExt = ((int)0X8d50),
        OpNegateExt = ((int)0X8783),
        SecondaryColorArrayPointer = ((int)0X845d),
        Reg30Ati = ((int)0X893f),
        TextureCoordArrayPointerExt = ((int)0X8092),
        FloatRgba16Nv = ((int)0X888a),
        UnsignedInt88S8S8RevNv = ((int)0X86db),
        BlendSrcAlphaExt = ((int)0X80cb),
        UnsignedByte332 = ((int)0X8032),
        CullVertexExt = ((int)0X81aa),
        ProgramAddressRegisters = ((int)0X88b0),
        Gl2XBitAti = ((int)0X00000001),
        IndexClearValue = ((int)0X0c20),
        ProxyTextureCubeMapExt = ((int)0X851b),
        Accum = ((int)0X0100),
        TextureMaterialParameterExt = ((int)0X8352),
        CurrentPaletteMatrixArb = ((int)0X8843),
        LuminanceAlpha8iExt = ((int)0X8d93),
        WeightArraySizeArb = ((int)0X86ab),
        SignedAlphaNv = ((int)0X8705),
        PostColorMatrixAlphaScale = ((int)0X80b7),
        LinearSharpenSgis = ((int)0X80ad),
        Source1RgbExt = ((int)0X8581),
        Texture0 = ((int)0X84c0),
        BufferUsage = ((int)0X8765),
        Map1VertexAttrib14Nv = ((int)0X8661),
        Rgb8uiExt = ((int)0X8d7d),
        EighthBitAti = ((int)0X00000020),
        EvalBit = ((int)0X00010000),
        SampleBuffers3Dfx = ((int)0X86b3),
        Map1Color4 = ((int)0X0d90),
        ColorAlphaPairingAti = ((int)0X8975),
        CombineRgb = ((int)0X8571),
        TransformFeedbackVaryingsNv = ((int)0X8c83),
        Light3 = ((int)0X4003),
        TextureHeight = ((int)0X1001),
        RedBias = ((int)0X0d15),
        ColorAttachment3Ext = ((int)0X8ce3),
        ElementArrayAti = ((int)0X8768),
        Operand2RgbExt = ((int)0X8592),
        FramebufferIncompleteLayerTargetsExt = ((int)0X8da8),
        TextureAlphaTypeArb = ((int)0X8c13),
        Feedback = ((int)0X1c01),
        PolygonOffsetLine = ((int)0X2a02),
        R = ((int)0X2002),
        S = ((int)0X2000),
        Intensity16 = ((int)0X804d),
        Q = ((int)0X2003),
        TextureAlphaSize = ((int)0X805f),
        T = ((int)0X2001),
        PixelTileGridHeightSgix = ((int)0X8143),
        DotProductAffineDepthReplaceNv = ((int)0X885d),
        CurrentSecondaryColorExt = ((int)0X8459),
        NearestClipmapLinearSgix = ((int)0X844e),
        TextureCoordArrayParallelPointersIntel = ((int)0X83f8),
        FragmentProgram = ((int)0X8804),
        Gl4Pass0Sgis = ((int)0X80a4),
        Sampler2DShadowArb = ((int)0X8b62),
        SecondaryColorArrayTypeExt = ((int)0X845b),
        PixelPackBufferExt = ((int)0X88eb),
        FragmentShaderArb = ((int)0X8b30),
        DrawBuffer10Ati = ((int)0X882f),
        Map1VertexAttrib34Nv = ((int)0X8663),
        ColorTableScale = ((int)0X80d6),
        Cw = ((int)0X0900),
        ColorTableBlueSizeSgi = ((int)0X80dc),
        LinearClipmapNearestSgix = ((int)0X844f),
        FrontLeft = ((int)0X0400),
        NumFragmentConstantsAti = ((int)0X896f),
        FragmentLightModelLocalViewerSgix = ((int)0X8408),
        DtScaleNv = ((int)0X8711),
        DotProductReflectCubeMapNv = ((int)0X86f2),
        Ycbcr422Apple = ((int)0X85b9),
        EdgeFlagArrayBufferBindingArb = ((int)0X889b),
        FloatMat3Arb = ((int)0X8b5b),
        ProgramErrorPositionNv = ((int)0X864b),
        ColorTableWidth = ((int)0X80d9),
        RenderbufferColorSamplesNv = ((int)0X8e10),
        Luminance8iExt = ((int)0X8d92),
        MaxAttribStackDepth = ((int)0X0d35),
        MaxProgramGenericResultsNv = ((int)0X8da6),
        Texture27Arb = ((int)0X84db),
        ReadFramebufferBindingExt = ((int)0X8ca6),
        Zero = ((int)0),
        TextureRectangleNv = ((int)0X84f5),
        Rgb16fArb = ((int)0X881b),
        TangentArrayTypeExt = ((int)0X843e),
        BlendEquationAlpha = ((int)0X883d),
        OutputColor0Ext = ((int)0X879b),
        StreamRead = ((int)0X88e1),
        HistogramAlphaSize = ((int)0X802b),
        LuminanceAlpha = ((int)0X190a),
        ColorArrayExt = ((int)0X8076),
        Cnd0Ati = ((int)0X896b),
        Map1VertexAttrib54Nv = ((int)0X8665),
        TrackMatrixNv = ((int)0X8648),
        Texture8 = ((int)0X84c8),
        MaxTextureCoordsArb = ((int)0X8871),
        AlphaFloat32Ati = ((int)0X8816),
        CombinerAbOutputNv = ((int)0X854a),
        Multisample = ((int)0X809d),
        ColorAttachment6Ext = ((int)0X8ce6),
        ClipFarHintPgi = ((int)0X1a221),
        MultisampleBit3Dfx = ((int)0X20000000),
        TextureCoordArrayBufferBinding = ((int)0X889a),
        InverseTransposeNv = ((int)0X862d),
        TextureRedSize = ((int)0X805c),
        PixelTexGenQFloorSgix = ((int)0X8186),
        OutputTextureCoord12Ext = ((int)0X87a9),
        Reg17Ati = ((int)0X8932),
        SecondaryColorArraySize = ((int)0X845a),
        Modelview1MatrixExt = ((int)0X8506),
        YcrcbSgix = ((int)0X8318),
        TextureMaxLevelSgis = ((int)0X813d),
        WeightArrayStrideArb = ((int)0X86aa),
        DrawBuffer14Arb = ((int)0X8833),
        BlendColorExt = ((int)0X8005),
        ColorTableIntensitySizeSgi = ((int)0X80df),
        VertexArrayBufferBinding = ((int)0X8896),
        ColorIndex2Ext = ((int)0X80e3),
        MaxFramezoomFactorSgix = ((int)0X818d),
        AccumGreenBits = ((int)0X0d59),
        MaxClipmapDepthSgix = ((int)0X8177),
        VibranceScaleNv = ((int)0X8713),
        Map1TextureCoord4 = ((int)0X0d96),
        Map1TextureCoord2 = ((int)0X0d94),
        Map1TextureCoord3 = ((int)0X0d95),
        EdgeflagBitPgi = ((int)0X00040000),
        ConvolutionWidth = ((int)0X8018),
        ArrayObjectBufferAti = ((int)0X8766),
        Modelview17Arb = ((int)0X8731),
        MaxVaryingComponentsExt = ((int)0X8b4b),
        TextureEnvBiasSgix = ((int)0X80be),
        TextureCoordArrayPointer = ((int)0X8092),
        CullFace = ((int)0X0b44),
        MaxClipmapVirtualDepthSgix = ((int)0X8178),
        ConstantBorderHp = ((int)0X8151),
        LightingBit = ((int)0X00000040),
        ColorIndex1Ext = ((int)0X80e2),
        StencilWritemask = ((int)0X0b98),
        ClipPlane0 = ((int)0X3000),
        Texture20Arb = ((int)0X84d4),
        LightModelColorControlExt = ((int)0X81f8),
        MaxPnTrianglesTesselationLevelAti = ((int)0X87f1),
        Reg29Ati = ((int)0X893e),
        PostConvolutionAlphaScale = ((int)0X801f),
        Modelview22Arb = ((int)0X8736),
        MaxClientAttribStackDepth = ((int)0X0d3b),
        ElementArrayApple = ((int)0X8768),
        BlendEquation = ((int)0X8009),
        ProgramUnderNativeLimits = ((int)0X88b6),
        MaxVertexShaderInstructionsExt = ((int)0X87c5),
        SignedLuminanceNv = ((int)0X8701),
        Light2 = ((int)0X4002),
        AsyncDrawPixelsSgix = ((int)0X835d),
        MirrorClampAti = ((int)0X8742),
        PostColorMatrixGreenScaleSgi = ((int)0X80b5),
        ClipDistanceNv = ((int)0X8c7a),
        GenerateMipmap = ((int)0X8191),
        MaxProgramMatricesArb = ((int)0X862f),
        OffsetTextureRectangleScaleNv = ((int)0X864d),
        Reg9Ati = ((int)0X892a),
        Vendor = ((int)0X1f00),
        FrontRight = ((int)0X0401),
        MaxColorMatrixStackDepthSgi = ((int)0X80b3),
        ReadOnlyArb = ((int)0X88b8),
        TextureMagSizeNv = ((int)0X871f),
        HalfBiasNormalNv = ((int)0X853a),
        ReplicateBorder = ((int)0X8153),
        PostTextureFilterScaleRangeSgix = ((int)0X817c),
        FogCoordinateArrayPointerExt = ((int)0X8456),
        Alpha16IccSgix = ((int)0X8468),
        MaxProgramLoopCountNv = ((int)0X88f8),
        Matrix21 = ((int)0X88d5),
        StaticReadArb = ((int)0X88e5),
        Texture14Arb = ((int)0X84ce),
        Matrix11 = ((int)0X88cb),
        Vertex4BitPgi = ((int)0X00000008),
        AllCompletedNv = ((int)0X84f2),
        Three = ((int)3),
        MaxSamplesExt = ((int)0X8d57),
        FenceConditionNv = ((int)0X84f4),
        Texture22Arb = ((int)0X84d6),
        ColorArrayStrideExt = ((int)0X8083),
        DrawBuffer4Ati = ((int)0X8829),
        MaxTextureBufferSizeExt = ((int)0X8c2b),
        PointSizeMinExt = ((int)0X8126),
        StencilBackFail = ((int)0X8801),
        DependentRgbTexture3DNv = ((int)0X8859),
        ColorSumClampNv = ((int)0X854f),
        Blend = ((int)0X0be2),
        PerStageConstantsNv = ((int)0X8535),
        Set = ((int)0X150f),
        IndexArrayExt = ((int)0X8077),
        DrawBuffer = ((int)0X0c01),
        ColorArrayBufferBindingArb = ((int)0X8898),
        Texture17Arb = ((int)0X84d1),
        PolygonOffsetFill = ((int)0X8037),
        Hilo8Nv = ((int)0X885e),
        ConstantAlphaExt = ((int)0X8003),
        Red = ((int)0X1903),
        LinearDetailAlphaSgis = ((int)0X8098),
        ConstantColor = ((int)0X8001),
        DepthStencilToBgraNv = ((int)0X886f),
        FogCoordArray = ((int)0X8457),
        Clamp = ((int)0X2900),
        HistogramSinkExt = ((int)0X802d),
        DotProductTextureCubeMapNv = ((int)0X86f0),
        MultisampleCoverageModesNv = ((int)0X8e12),
        ConstantColor1Nv = ((int)0X852b),
        CompressedRgbaS3tcDxt3Ext = ((int)0X83f2),
        Intensity12Ext = ((int)0X804c),
        Sluminance8Ext = ((int)0X8c47),
        Texture3DExt = ((int)0X806f),
        Texture16Arb = ((int)0X84d0),
        VertexArraySize = ((int)0X807a),
        PointSpriteCoordOrigin = ((int)0X8ca0),
        Rgba16 = ((int)0X805b),
        DepthBoundsTestExt = ((int)0X8890),
        UnsignedShort5551Ext = ((int)0X8034),
        FogFactorToAlphaSgix = ((int)0X836f),
        FramebufferAttachmentTexture3DZoffsetExt = ((int)0X8cd4),
        CompressedSignedRedGreenRgtc2Ext = ((int)0X8dbe),
        ClampToEdgeSgis = ((int)0X812f),
        CombinerBiasNv = ((int)0X8549),
        InvariantExt = ((int)0X87c2),
        ReadPixelDataRangeLengthNv = ((int)0X887b),
        FramebufferUnsupportedExt = ((int)0X8cdd),
        Modelview4Arb = ((int)0X8724),
        IntSamplerBufferExt = ((int)0X8dd0),
        Texture11Arb = ((int)0X84cb),
        Decr = ((int)0X1e03),
        Texture21Arb = ((int)0X84d5),
        ListBase = ((int)0X0b32),
        MaxListNesting = ((int)0X0b31),
        RgbaUnsignedDotProductMappingNv = ((int)0X86d9),
        Linear = ((int)0X2601),
        VertexArrayBufferBindingArb = ((int)0X8896),
        MaxProgramTemporaries = ((int)0X88a5),
        Source1RgbArb = ((int)0X8581),
        ElementArrayBufferArb = ((int)0X8893),
        ReclaimMemoryHintPgi = ((int)0X1a1fe),
        SecondaryColorArrayBufferBinding = ((int)0X889c),
        ProgramErrorStringNv = ((int)0X8874),
        ProxyColorTable = ((int)0X80d3),
        R1uiT2fV3fSun = ((int)0X85c9),
        TextureWrapR = ((int)0X8072),
        Luminance32fArb = ((int)0X8818),
        RgbaIntegerExt = ((int)0X8d99),
        RenderbufferDepthSizeExt = ((int)0X8d54),
        Texture10Arb = ((int)0X84ca),
        WritePixelDataRangePointerNv = ((int)0X887c),
        Keep = ((int)0X1e00),
        DotProductNv = ((int)0X86ec),
        AttribStackDepth = ((int)0X0bb0),
        FogCoordinateArrayExt = ((int)0X8457),
        Combiner2Nv = ((int)0X8552),
        MaxProgramResultComponentsNv = ((int)0X8909),
        ReadPixelDataRangeNv = ((int)0X8879),
        CombineAlphaArb = ((int)0X8572),
        ReplaceOldestSun = ((int)0X0003),
        LineWidthRange = ((int)0X0b22),
        BufferMapPointerArb = ((int)0X88bd),
        TextureCompareSgix = ((int)0X819a),
        FragmentShaderDerivativeHintArb = ((int)0X8b8b),
        AsyncMarkerSgix = ((int)0X8329),
        Sampler3DArb = ((int)0X8b5f),
        FramezoomSgix = ((int)0X818b),
        PnTrianglesNormalModeLinearAti = ((int)0X87f7),
        MaxElementsIndicesExt = ((int)0X80e9),
        Gl2Pass0Ext = ((int)0X80a2),
        FixedOnlyArb = ((int)0X891d),
        Light1 = ((int)0X4001),
        Fill = ((int)0X1b02),
        Subtract = ((int)0X84e7),
        LineSmooth = ((int)0X0b20),
        Rgb32uiExt = ((int)0X8d71),
        Modelview28Arb = ((int)0X873c),
        DrawBuffer3Ati = ((int)0X8828),
        SamplePatternSgis = ((int)0X80ac),
        Texture29Arb = ((int)0X84dd),
        TransposeColorMatrixArb = ((int)0X84e6),
        ProxyPostColorMatrixColorTableSgi = ((int)0X80d5),
        WeightArrayPointerArb = ((int)0X86ac),
        VertexShaderArb = ((int)0X8b31),
        FogSpecularTextureWin = ((int)0X80ec),
        OffsetProjectiveTextureRectangleScaleNv = ((int)0X8853),
        FragmentLight1Sgix = ((int)0X840d),
        Intensity16Ext = ((int)0X804d),
        Quads = ((int)0X0007),
        WritePixelDataRangeNv = ((int)0X8878),
        ObjectShaderSourceLengthArb = ((int)0X8b88),
        ColorAttachment2Ext = ((int)0X8ce2),
        IndexArrayPointerExt = ((int)0X8091),
        VariantValueExt = ((int)0X87e4),
        Matrix10 = ((int)0X88ca),
        ProgramTargetNv = ((int)0X8646),
        TriangleStrip = ((int)0X0005),
        ConvolutionBorderModeExt = ((int)0X8013),
        LinearMipmapLinear = ((int)0X2703),
        IndexArrayBufferBindingArb = ((int)0X8899),
        CompressedSignedLuminanceLatc1Ext = ((int)0X8c71),
        ArrayBufferBindingArb = ((int)0X8894),
        LuminanceAlphaFloat16Ati = ((int)0X881f),
        Texture28Arb = ((int)0X84dc),
        BlendDstRgbExt = ((int)0X80c8),
        MaxOptimizedVertexShaderInstructionsExt = ((int)0X87ca),
        HalfFloat = ((int)0X140b),
        DepthRange = ((int)0X0b70),
        NumFragmentRegistersAti = ((int)0X896e),
        Order = ((int)0X0a01),
        TimeElapsedExt = ((int)0X88bf),
        ReflectionMapArb = ((int)0X8512),
        UnpackImageHeight = ((int)0X806e),
        SignedRgbNv = ((int)0X86fe),
        Matrix2Nv = ((int)0X8632),
        GeometryOutputTypeExt = ((int)0X8ddc),
        FeedbackBufferPointer = ((int)0X0df0),
        OffsetTexture2DBiasNv = ((int)0X86e3),
        Xor = ((int)0X1506),
        MaxOptimizedVertexShaderLocalConstantsExt = ((int)0X87cc),
        AlphaMinClampIngr = ((int)0X8563),
        UnsignedInt2101010RevExt = ((int)0X8368),
        TextureCompareMode = ((int)0X884c),
        MaxProgramEnvParameters = ((int)0X88b5),
        Gl2Pass1Ext = ((int)0X80a3),
        ReadPixelDataRangePointerNv = ((int)0X887d),
        Modelview26Arb = ((int)0X873a),
        ClipPlane1 = ((int)0X3001),
        PixelMapAToA = ((int)0X0c79),
        Texture0Arb = ((int)0X84c0),
        ImplementationColorReadTypeOes = ((int)0X8b9a),
        BlueBitAti = ((int)0X00000004),
        TextureLodBiasTSgix = ((int)0X818f),
        TextureDepthSize = ((int)0X884a),
        ColorAttachment5Ext = ((int)0X8ce5),
        NormalArrayCountExt = ((int)0X8080),
        HistogramRedSize = ((int)0X8028),
        TextureCubeMapExt = ((int)0X8513),
        PackImageDepthSgis = ((int)0X8131),
        AttenuationExt = ((int)0X834d),
        GeometryProgramParameterBufferNv = ((int)0X8da3),
        VertexShaderVariantsExt = ((int)0X87d0),
        ProgramNativeAluInstructionsArb = ((int)0X8808),
        VertexArrayPointerExt = ((int)0X808e),
        ColorTableRedSize = ((int)0X80da),
        TransformFeedbackBufferBindingNv = ((int)0X8c8f),
        Luminance16Ext = ((int)0X8042),
        PixelTexGenAlphaMsSgix = ((int)0X818a),
        DepthComponent = ((int)0X1902),
        IndexArrayTypeExt = ((int)0X8085),
        VertexArraySizeExt = ((int)0X807a),
        ModelviewProjectionNv = ((int)0X8629),
        GlobalAlphaFactorSun = ((int)0X81da),
        Matrix16 = ((int)0X88d0),
        VertexWeightArrayExt = ((int)0X850c),
        CompressedAlpha = ((int)0X84e9),
        TextureLodBiasExt = ((int)0X8501),
        Flat = ((int)0X1d00),
        SrcAlpha = ((int)0X0302),
        ProgramPointSizeExt = ((int)0X8642),
        CompileStatus = ((int)0X8b81),
        Never = ((int)0X0200),
        True = ((int)1),
        UnsignedShort4444Reversed = ((int)0X8365),
        Reg18Ati = ((int)0X8933),
        VertexArrayRangeValidNv = ((int)0X851f),
        Return = ((int)0X0102),
        PostColorMatrixRedBiasSgi = ((int)0X80b8),
        NegativeOneExt = ((int)0X87df),
        FogMode = ((int)0X0b65),
        PolygonBit = ((int)0X00000008),
        Incr = ((int)0X1e02),
        ClipNearHintPgi = ((int)0X1a220),
        PassThroughToken = ((int)0X0700),
        AbgrExt = ((int)0X8000),
        EvalFractionalTessellationNv = ((int)0X86c5),
        TextureGreenSizeExt = ((int)0X805d),
        MaxProgramAttribComponentsNv = ((int)0X8908),
        MaxVertexShaderVariantsExt = ((int)0X87c6),
        CompressedLuminance = ((int)0X84ea),
        PackSubsampleRateSgix = ((int)0X85a0),
        SecondaryColorArrayType = ((int)0X845b),
        Map2VertexAttrib114Nv = ((int)0X867b),
        SamplesPassed = ((int)0X8914),
        TextureCompressionHintArb = ((int)0X84ef),
        Dot4Ati = ((int)0X8967),
        DualIntensity4Sgis = ((int)0X8118),
        RgbaIccSgix = ((int)0X8461),
        ConvolutionHeight = ((int)0X8019),
        LowerLeft = ((int)0X8ca1),
        FramebufferAttachmentObjectTypeExt = ((int)0X8cd0),
        PolygonSmooth = ((int)0X0b41),
        Alpha4Ext = ((int)0X803b),
        VariantArrayStrideExt = ((int)0X87e6),
        VariantArrayExt = ((int)0X87e8),
        Reg8Ati = ((int)0X8929),
        TransposeTextureMatrix = ((int)0X84e5),
        MaxProgramTexInstructionsArb = ((int)0X880c),
        PointToken = ((int)0X0701),
        Texture19Arb = ((int)0X84d3),
        CompressedTextureFormatsArb = ((int)0X86a3),
        UnsignedInvertNv = ((int)0X8537),
        Texture = ((int)0X1702),
        VariantDatatypeExt = ((int)0X87e5),
        Intensity32fArb = ((int)0X8817),
        ProjectionStackDepth = ((int)0X0ba4),
        SignedNegateNv = ((int)0X853d),
        FloatMat4Arb = ((int)0X8b5c),
        ClipPlane5 = ((int)0X3005),
        ColorMaterialFace = ((int)0X0b55),
        FragmentLight2Sgix = ((int)0X840e),
        Matrix1Nv = ((int)0X8631),
        Separable2DExt = ((int)0X8012),
        FloatRg16Nv = ((int)0X8886),
        PixelUnpackBufferBindingArb = ((int)0X88ef),
        FuncSubtractExt = ((int)0X800a),
        Matrix23 = ((int)0X88d7),
        Texture18Arb = ((int)0X84d2),
        Matrix13 = ((int)0X88cd),
        Luminance32iExt = ((int)0X8d86),
        RasterizerDiscardNv = ((int)0X8c89),
        CombineExt = ((int)0X8570),
        Alpha16uiExt = ((int)0X8d78),
        Modelview8Arb = ((int)0X8728),
        Luminance12Ext = ((int)0X8041),
        Greater = ((int)0X0204),
        QueryCounterBits = ((int)0X8864),
        BlendSrc = ((int)0X0be1),
        Texcoord3BitPgi = ((int)0X40000000),
        LocalConstantDatatypeExt = ((int)0X87ed),
        SignedAlpha8Nv = ((int)0X8706),
        ReplacementCodeArrayStrideSun = ((int)0X85c2),
        MaxTextureMaxAnisotropyExt = ((int)0X84ff),
        MaxMapTessellationNv = ((int)0X86d6),
        Dot3Rgba = ((int)0X86af),
        Compile = ((int)0X1300),
        Vertex23BitPgi = ((int)0X00000004),
        PointSizeMaxSgis = ((int)0X8127),
        DetailTextureLevelSgis = ((int)0X809a),
        ColorArrayListStrideIbm = ((int)103082),
        TextureWrapRExt = ((int)0X8072),
        MaxVertexAttribsArb = ((int)0X8869),
        VertexArrayRangeNv = ((int)0X851d),
        Rgb5Ext = ((int)0X8050),
        SampleBuffersArb = ((int)0X80a8),
        VertexPreclipSgix = ((int)0X83ee),
        Luminance16 = ((int)0X8042),
        ClipPlane2 = ((int)0X3002),
        MaxMatrixPaletteStackDepthArb = ((int)0X8841),
        Luminance12 = ((int)0X8041),
        BumpTexUnitsAti = ((int)0X8778),
        MaxConvolutionWidthExt = ((int)0X801a),
        SeparateSpecularColorExt = ((int)0X81fa),
        MaxPixelMapTable = ((int)0X0d34),
        FragmentColorMaterialSgix = ((int)0X8401),
        OffsetTexture2DMatrixNv = ((int)0X86e1),
        ArrayObjectOffsetAti = ((int)0X8767),
        OutputTextureCoord18Ext = ((int)0X87af),
        FloatVec4 = ((int)0X8b52),
        DrawBuffer13Arb = ((int)0X8832),
        CalligraphicFragmentSgix = ((int)0X8183),
        StencilIndex = ((int)0X1901),
        FogFuncSgis = ((int)0X812a),
        TextureDepth = ((int)0X8071),
        Texture4DBindingSgis = ((int)0X814f),
        StaticDraw = ((int)0X88e4),
        SignedIdentityNv = ((int)0X853c),
        Matrix31 = ((int)0X88df),
        TransposeColorMatrix = ((int)0X84e6),
        LuminanceAlpha32fArb = ((int)0X8819),
        StencilIndex16Ext = ((int)0X8d49),
        FeedbackBufferSize = ((int)0X0df1),
        Luminance6Alpha2 = ((int)0X8044),
        OutputTextureCoord4Ext = ((int)0X87a1),
        SampleCoverageArb = ((int)0X80a0),
        Rgb5 = ((int)0X8050),
        ResampleZeroFillOml = ((int)0X8987),
        MaxDeformationOrderSgix = ((int)0X8197),
        VertexDataHintPgi = ((int)0X1a22a),
        LineToken = ((int)0X0702),
        EyePlane = ((int)0X2502),
        TriangleStripAdjacencyExt = ((int)0X000d),
        UnpackSwapBytes = ((int)0X0cf0),
        VertexShaderOptimizedExt = ((int)0X87d4),
        DrawBuffer12Arb = ((int)0X8831),
        UnsignedShort1555Rev = ((int)0X8366),
        TextureNormalExt = ((int)0X85af),
        CndAti = ((int)0X896a),
        HistogramBlueSizeExt = ((int)0X802a),
        QueryResultArb = ((int)0X8866),
        HalfFloatArb = ((int)0X140b),
        VariantArrayPointerExt = ((int)0X87e9),
        Combine = ((int)0X8570),
        OcclusionTestResultHp = ((int)0X8166),
        InstrumentMeasurementsSgix = ((int)0X8181),
        MapStencil = ((int)0X0d11),
        MaxRectangleTextureSizeArb = ((int)0X84f8),
        Texture31Arb = ((int)0X84df),
        Rgb2Ext = ((int)0X804e),
        UnpackResampleOml = ((int)0X8985),
        FullStippleHintPgi = ((int)0X1a219),
        StaticDrawArb = ((int)0X88e4),
        PixelUnpackBufferBindingExt = ((int)0X88ef),
        ObjectLinear = ((int)0X2401),
        Add = ((int)0X0104),
        BufferAccess = ((int)0X88bb),
        HiloNv = ((int)0X86f4),
        Texture5 = ((int)0X84c5),
        Emission = ((int)0X1600),
        TextureMaterialFaceExt = ((int)0X8351),
        Matrix4Nv = ((int)0X8634),
        Intensity16IccSgix = ((int)0X846a),
        DepthComponent32Sgix = ((int)0X81a7),
        SwizzleStrqDqAti = ((int)0X897b),
        VectorExt = ((int)0X87bf),
        Texture30Arb = ((int)0X84de),
        BoolVec3Arb = ((int)0X8b58),
        ProgramResultComponentsNv = ((int)0X8907),
        PostTextureFilterBiasRangeSgix = ((int)0X817b),
        GeometryVerticesOutExt = ((int)0X8dda),
        TextureLuminanceTypeArb = ((int)0X8c14),
        Line = ((int)0X1b01),
        LightModelLocalViewer = ((int)0X0b51),
        RenderbufferBlueSizeExt = ((int)0X8d52),
        MaxTextureCoords = ((int)0X8871),
        BumpEnvmapAti = ((int)0X877b),
        PixelUnpackBufferBinding = ((int)0X88ef),
        ActiveAttributeMaxLength = ((int)0X8b8a),
        VertexArrayRangePointerNv = ((int)0X8521),
        Sampler1D = ((int)0X8b5d),
        ProxyPostImageTransformColorTableHp = ((int)0X8163),
        Matrix7Nv = ((int)0X8637),
        CullVertexEyePositionExt = ((int)0X81ab),
        Sampler1DArb = ((int)0X8b5d),
        ZeroExt = ((int)0X87dd),
        VertexShaderExt = ((int)0X8780),
        Rgba8iExt = ((int)0X8d8e),
        OutputTextureCoord3Ext = ((int)0X87a0),
        SmoothLineWidthGranularity = ((int)0X0b23),
        Matrix22 = ((int)0X88d6),
        TextureClipmapDepthSgix = ((int)0X8176),
        SignedRgb8UnsignedAlpha8Nv = ((int)0X870d),
        AlphaTestRef = ((int)0X0bc2),
        OneMinusSrcColor = ((int)0X0301),
        PackInvertMesa = ((int)0X8758),
        FogCoordinateArrayTypeExt = ((int)0X8454),
        ConvolutionFilterScaleExt = ((int)0X8014),
        MaxBindableUniformSizeExt = ((int)0X8ded),
        TexturePostSpecularHp = ((int)0X8168),
        CompressedLuminanceLatc1Ext = ((int)0X8c70),
        QuadraticAttenuation = ((int)0X1209),
        NormalMapNv = ((int)0X8511),
        Modelview31Arb = ((int)0X873f),
        TextureCubeMapNegativeZExt = ((int)0X851a),
        Texcoord2BitPgi = ((int)0X20000000),
        R3G3B2 = ((int)0X2a10),
        Spare1Nv = ((int)0X852f),
        CombineRgbArb = ((int)0X8571),
        TextureDepthSizeArb = ((int)0X884a),
        ColorAttachment9Ext = ((int)0X8ce9),
        Texture1Arb = ((int)0X84c1),
        PnTrianglesTesselationLevelAti = ((int)0X87f4),
        ClampReadColorArb = ((int)0X891c),
        TextureInternalFormat = ((int)0X1003),
        SampleAlphaToCoverageArb = ((int)0X809e),
        CullVertexIbm = ((int)103050),
        MaxCombinedTextureImageUnitsArb = ((int)0X8b4d),
        ReadFramebufferExt = ((int)0X8ca8),
        Gl422RevExt = ((int)0X80cd),
        ArrayElementLockCountExt = ((int)0X81a9),
        Reg11Ati = ((int)0X892c),
        PointSpriteArb = ((int)0X8861),
        CompressedRgbS3tcDxt1Ext = ((int)0X83f0),
        IntSampler1DArrayExt = ((int)0X8dce),
        FloatRNv = ((int)0X8880),
        NormalArrayExt = ((int)0X8075),
        MirrorClampToBorderExt = ((int)0X8912),
        NegativeYExt = ((int)0X87da),
        Matrix25 = ((int)0X88d9),
        R1uiC4ubV3fSun = ((int)0X85c5),
        MaxTextureStackDepth = ((int)0X0d39),
        ActiveVaryingMaxLengthNv = ((int)0X8c82),
        SampleAlphaToCoverage = ((int)0X809e),
        NativeGraphicsHandlePgi = ((int)0X1a202),
        TextureAlphaSizeExt = ((int)0X805f),
        HiScaleNv = ((int)0X870e),
        Histogram = ((int)0X8024),
        Srgb8Alpha8Ext = ((int)0X8c43),
        MaxVertexBindableUniformsExt = ((int)0X8de2),
        NearestMipmapNearest = ((int)0X2700),
        ResampleDecimateOml = ((int)0X8989),
        FramebufferIncompleteDimensionsExt = ((int)0X8cd9),
        TextureCubeMapPositiveZ = ((int)0X8519),
        PnTrianglesNormalModeQuadraticAti = ((int)0X87f8),
        TextureCubeMapPositiveX = ((int)0X8515),
        TextureCubeMapPositiveY = ((int)0X8517),
        SwizzleStrDrAti = ((int)0X8978),
        AttribArrayTypeNv = ((int)0X8625),
        Con26Ati = ((int)0X895b),
        DrawFramebufferExt = ((int)0X8ca9),
        PixelTexGenAlphaNoReplaceSgix = ((int)0X8188),
        EvalVertexAttrib15Nv = ((int)0X86d5),
        ObjectActiveUniformMaxLengthArb = ((int)0X8b87),
        Reg2Ati = ((int)0X8923),
        T4fV4f = ((int)0X2a28),
        AlphaTestFunc = ((int)0X0bc1),
        SwizzleStrqAti = ((int)0X897a),
        PixelTextureSgis = ((int)0X8353),
        RgbaSignedComponentsExt = ((int)0X8c3c),
        EvalTriangular2DNv = ((int)0X86c1),
        DependentHiloTexture2DNv = ((int)0X8858),
        Con11Ati = ((int)0X894c),
        ProgramNativeTemporaries = ((int)0X88a6),
        PixelMapGToG = ((int)0X0c77),
        CurrentRasterTextureCoords = ((int)0X0b06),
        Operand2AlphaArb = ((int)0X859a),
        ColorArrayType = ((int)0X8082),
        PnTrianglesAti = ((int)0X87f0),
        One = ((int)1),
        IuiV3fExt = ((int)0X81ae),
        NormalizedRangeExt = ((int)0X87e0),
        MaxRenderbufferSizeExt = ((int)0X84e8),
        IndexMaterialExt = ((int)0X81b8),
        CompBitAti = ((int)0X00000002),
        NormalArrayParallelPointersIntel = ((int)0X83f6),
        ObjectPlane = ((int)0X2501),
        TextureIntensitySize = ((int)0X8061),
        DtBiasNv = ((int)0X8717),
        TriangleListSun = ((int)0X81d7),
        MaxProgramTotalOutputComponentsNv = ((int)0X8c28),
        PostColorMatrixRedScaleSgi = ((int)0X80b4),
        PassThroughNv = ((int)0X86e6),
        Con12Ati = ((int)0X894d),
        Src1Alpha = ((int)0X8589),
        PixelSubsample4444Sgix = ((int)0X85a2),
        Render = ((int)0X1c00),
        Sampler2D = ((int)0X8b5e),
        AccumClearValue = ((int)0X0b80),
        EdgeFlagArrayPointerExt = ((int)0X8093),
        FogCoordSrc = ((int)0X8450),
        Operand0AlphaArb = ((int)0X8598),
        ColorSum = ((int)0X8458),
        T2fC3fV3f = ((int)0X2a2a),
        Gl4Pass2Ext = ((int)0X80a6),
        DepthPassInstrumentCountersSgix = ((int)0X8311),
        NormalArrayTypeExt = ((int)0X807e),
        OpRoundExt = ((int)0X8790),
        Luminance8 = ((int)0X8040),
        UniformBufferExt = ((int)0X8dee),
        UnsignedShort4444 = ((int)0X8033),
        DeleteStatus = ((int)0X8b80),
        RgbaFloat32Ati = ((int)0X8814),
        ScissorBit = ((int)0X00080000),
        T4fC4fN3fV4f = ((int)0X2a2d),
        SwizzleStqDqAti = ((int)0X8979),
        Int = ((int)0X1404),
        TextureBorderValuesNv = ((int)0X871a),
        PixelMapIToG = ((int)0X0c73),
        FloatR16Nv = ((int)0X8884),
        EvalVertexAttrib4Nv = ((int)0X86ca),
        GreenMinClampIngr = ((int)0X8561),
        BackPrimaryColorNv = ((int)0X8c77),
        UnsignedIdentityNv = ((int)0X8536),
        VertexShader = ((int)0X8b31),
        UnsignedShort1555RevExt = ((int)0X8366),
        LightModelAmbient = ((int)0X0b53),
        BoolVec3 = ((int)0X8b58),
        InterlaceSgix = ((int)0X8094),
        DrawBuffer14Ati = ((int)0X8833),
        StencilTagBitsExt = ((int)0X88f2),
        PixelTransform2DStackDepthExt = ((int)0X8336),
        WeightArrayBufferBinding = ((int)0X889e),
        MatrixExt = ((int)0X87c0),
        MaxGeometryTotalOutputComponentsExt = ((int)0X8de1),
        PolygonSmoothHint = ((int)0X0c53),
        MaxRationalEvalOrderNv = ((int)0X86d7),
        SrcAlphaSaturate = ((int)0X0308),
        TableTooLarge = ((int)0X8031),
        ElementArrayBufferBindingArb = ((int)0X8895),
        FramebufferIncompleteAttachmentExt = ((int)0X8cd6),
        Srgb8 = ((int)0X8c41),
        IndexTestRefExt = ((int)0X81b7),
        Float32UnsignedInt248RevNv = ((int)0X8dad),
        Con22Ati = ((int)0X8957),
        HistogramFormat = ((int)0X8027),
        FragmentColorMaterialParameterSgix = ((int)0X8403),
        ReadWrite = ((int)0X88ba),
        MaxArrayTextureLayersExt = ((int)0X88ff),
        NegativeZExt = ((int)0X87db),
        TextureBufferExt = ((int)0X8c2a),
        IntVec2 = ((int)0X8b53),
        IntVec3 = ((int)0X8b54),
        Rgb4Ext = ((int)0X804f),
        ConstEyeNv = ((int)0X86e5),
        DrawBuffer1Arb = ((int)0X8826),
        IntVec4 = ((int)0X8b55),
        ProxyTextureCubeMapArb = ((int)0X851b),
        Point = ((int)0X1b00),
        ClipPlane3 = ((int)0X3003),
        DepthComponent16 = ((int)0X81a5),
        LightModelSpecularVectorApple = ((int)0X85b0),
        PixelMapRToR = ((int)0X0c76),
        Luminance6Alpha2Ext = ((int)0X8044),
        Matrix29 = ((int)0X88dd),
        Matrix19 = ((int)0X88d3),
        IndexBitPgi = ((int)0X00080000),
        ResampleReplicateSgix = ((int)0X842e),
        Con3Ati = ((int)0X8944),
        PrimaryColorNv = ((int)0X852c),
        UnsignedIntS8S888Nv = ((int)0X86da),
        MaxProgramOutputVerticesNv = ((int)0X8c27),
        TextureCubeMap = ((int)0X8513),
        RenderbufferSamplesExt = ((int)0X8cab),
        Rgb8iExt = ((int)0X8d8f),
        DepthClearValue = ((int)0X0b73),
        SecondaryInterpolatorAti = ((int)0X896d),
        ColorAttachment1Ext = ((int)0X8ce1),
        TextureLightingModeHp = ((int)0X8167),
        ProxyTexture4DSgis = ((int)0X8135),
        UnsignedShort565Reversed = ((int)0X8364),
        NormalArrayBufferBindingArb = ((int)0X8897),
        TangentArrayPointerExt = ((int)0X8442),
        Operand0Alpha = ((int)0X8598),
        TextureCompressed = ((int)0X86a1),
        Luminance4 = ((int)0X803f),
        Con24Ati = ((int)0X8959),
        PixelTransform2DMatrixExt = ((int)0X8338),
        Luminance16iExt = ((int)0X8d8c),
        PostConvolutionColorTable = ((int)0X80d1),
        GenerateMipmapHint = ((int)0X8192),
        PhongWin = ((int)0X80ea),
        TextureDeformationBitSgix = ((int)0X00000001),
        LuminanceAlpha32uiExt = ((int)0X8d75),
        PackLsbFirst = ((int)0X0d01),
        OpRecipSqrtExt = ((int)0X8795),
        ProxyPostConvolutionColorTable = ((int)0X80d4),
        SecondaryColorNv = ((int)0X852d),
        MaxVertexShaderInvariantsExt = ((int)0X87c7),
        ConvolutionFormat = ((int)0X8017),
        Rgba32uiExt = ((int)0X8d70),
        ModulateAddAti = ((int)0X8744),
        TextureEnvMode = ((int)0X2200),
        SamplePatternExt = ((int)0X80ac),
        Select = ((int)0X1c02),
        TextureClipmapLodOffsetSgix = ((int)0X8175),
        DepthStencilNv = ((int)0X84f9),
        Rgba16iExt = ((int)0X8d88),
        UnpackSkipImagesExt = ((int)0X806d),
        MapColor = ((int)0X0d10),
        Max4DTextureSizeSgis = ((int)0X8138),
        VertexArrayParallelPointersIntel = ((int)0X83f5),
        OutputTextureCoord9Ext = ((int)0X87a6),
        OffsetProjectiveTexture2DScaleNv = ((int)0X8851),
        ReplaceMiddleSun = ((int)0X0002),
        MaxProgramNativeAddressRegisters = ((int)0X88b3),
        CompressedSluminanceAlpha = ((int)0X8c4b),
        OutputTextureCoord28Ext = ((int)0X87b9),
        BlueMinClampIngr = ((int)0X8562),
        ResampleAverageOml = ((int)0X8988),
        EvalVertexAttrib8Nv = ((int)0X86ce),
        PostColorMatrixAlphaBias = ((int)0X80bb),
        None = ((int)0),
        OneMinusConstantAlphaExt = ((int)0X8004),
        UnsignedIntSamplerCubeExt = ((int)0X8dd4),
        AlwaysSoftHintPgi = ((int)0X1a20d),
        Nor = ((int)0X1508),
        BiasBitAti = ((int)0X00000008),
        StencilBackWritemask = ((int)0X8ca5),
        TextureGreenTypeArb = ((int)0X8c11),
        MatrixIndexArrayStrideArb = ((int)0X8848),
        NegativeWExt = ((int)0X87dc),
        TextureMaxLodSgis = ((int)0X813b),
        LineBit = ((int)0X00000004),
        PixelMagFilterExt = ((int)0X8331),
        PostConvolutionGreenBiasExt = ((int)0X8021),
        Src2Alpha = ((int)0X858a),
        Modelview7Arb = ((int)0X8727),
        RgbScale = ((int)0X8573),
        PrimitiveRestartIndexNv = ((int)0X8559),
        FramebufferIncompleteReadBufferExt = ((int)0X8cdc),
        Con6Ati = ((int)0X8947),
        ProgramResidentNv = ((int)0X8647),
        MaxGeometryUniformComponentsExt = ((int)0X8ddf),
        ReflectionMapNv = ((int)0X8512),
        Rgb4S3tc = ((int)0X83a1),
        CompressedIntensity = ((int)0X84ec),
        FragmentShader = ((int)0X8b30),
        StencilBackPassDepthPass = ((int)0X8803),
        SignedRgbaNv = ((int)0X86fb),
        Con19Ati = ((int)0X8954),
        StencilBits = ((int)0X0d57),
        Dsdt8Nv = ((int)0X8709),
        TextureWrapQSgis = ((int)0X8137),
        FloatMat2 = ((int)0X8b5a),
        TextureCoordArrayBufferBindingArb = ((int)0X889a),
        Map1Normal = ((int)0X0d92),
        PostColorMatrixAlphaBiasSgi = ((int)0X80bb),
        RgbScaleExt = ((int)0X8573),
        UnsignedIntSampler3DExt = ((int)0X8dd3),
        PolygonOffsetPoint = ((int)0X2a01),
        TextureBorderColor = ((int)0X1004),
        TextureBindingCubeMapArb = ((int)0X8514),
        MaxPixelTransform2DStackDepthExt = ((int)0X8337),
        TextureClipmapVirtualDepthSgix = ((int)0X8174),
        IntVec2Arb = ((int)0X8b53),
        ObjectSubtypeArb = ((int)0X8b4f),
        DrawBuffer8Arb = ((int)0X882d),
        Con20Ati = ((int)0X8955),
        MaxTransformFeedbackInterleavedAttribsNv = ((int)0X8c8a),
        Modelview0MatrixExt = ((int)0X0ba6),
        TextureGenMode = ((int)0X2500),
        VertexSourceAti = ((int)0X8774),
        PolygonToken = ((int)0X0703),
        PostConvolutionAlphaBias = ((int)0X8023),
        AccumBlueBits = ((int)0X0d5a),
        DrawBuffer10Arb = ((int)0X882f),
        SubpixelBits = ((int)0X0d50),
        Dot3Ati = ((int)0X8966),
        Texture1DStackMesax = ((int)0X8759),
        Map1VertexAttrib64Nv = ((int)0X8666),
        MaxAsyncHistogramSgix = ((int)0X832d),
        AlphaFloat16Ati = ((int)0X881c),
        BinormalArrayPointerExt = ((int)0X8443),
        ColorArrayParallelPointersIntel = ((int)0X83f7),
        SamplerCube = ((int)0X8b60),
        Samples3Dfx = ((int)0X86b4),
        Source2RgbExt = ((int)0X8582),
        CurrentFogCoord = ((int)0X8453),
        DynamicReadArb = ((int)0X88e9),
        CompressedLuminanceAlphaLatc2Ext = ((int)0X8c72),
        MaxFragmentLightsSgix = ((int)0X8404),
        DepthPassInstrumentSgix = ((int)0X8310),
        Sampler2DArrayExt = ((int)0X8dc1),
        OutputTextureCoord15Ext = ((int)0X87ac),
        TransposeProjectionMatrixArb = ((int)0X84e4),
        Con29Ati = ((int)0X895e),
        ColorArrayStride = ((int)0X8083),
        Map1Index = ((int)0X0d91),
        NumGeneralCombinersNv = ((int)0X854e),
        Luminance4Ext = ((int)0X803f),
        CurrentProgram = ((int)0X8b8d),
        And = ((int)0X1501),
        OutputTextureCoord5Ext = ((int)0X87a2),
        CurrentRasterDistance = ((int)0X0b09),
        Con25Ati = ((int)0X895a),
        Gl4Bytes = ((int)0X1409),
        Load = ((int)0X0101),
        DualLuminance16Sgis = ((int)0X8117),
        Min = ((int)0X8007),
        Sluminance = ((int)0X8c46),
        NativeGraphicsEndHintPgi = ((int)0X1a204),
        MaxTextureImageUnitsArb = ((int)0X8872),
        FrontFace = ((int)0X0b46),
        DrawBuffer2Arb = ((int)0X8827),
        ResampleDecimateSgix = ((int)0X8430),
        DependentArTexture2DNv = ((int)0X86e9),
        PostColorMatrixRedBias = ((int)0X80b8),
        ColorTableLuminanceSize = ((int)0X80de),
        Map1VertexAttrib04Nv = ((int)0X8660),
        PixelMapIToR = ((int)0X0c72),
        NormalArrayPointerExt = ((int)0X808f),
        DoubleExt = ((int)0X140a),
        ProxyTexture2DExt = ((int)0X8064),
        ColorSumArb = ((int)0X8458),
        CurrentBinormalExt = ((int)0X843c),
        Modelview0StackDepthExt = ((int)0X0ba3),
        NegativeXExt = ((int)0X87d9),
        TextureCompressedImageSize = ((int)0X86a0),
        InterleavedAttribsNv = ((int)0X8c8c),
        DrawBuffer5Arb = ((int)0X882a),
        ShaderOperationNv = ((int)0X86df),
        ProgramTexInstructionsArb = ((int)0X8806),
        PointFadeThresholdSizeExt = ((int)0X8128),
        SpriteObjectAlignedSgix = ((int)0X814d),
        FogStart = ((int)0X0b63),
        TextureStencilSizeExt = ((int)0X88f1),
        MaxAsyncTexImageSgix = ((int)0X835f),
        ColorTableBlueSize = ((int)0X80dc),
        SignedIntensityNv = ((int)0X8707),
        RenderbufferStencilSizeExt = ((int)0X8d55),
        OneMinusConstantColor = ((int)0X8002),
        Texture7Arb = ((int)0X84c7),
        ProgramStringNv = ((int)0X8628),
        ColorTableGreenSize = ((int)0X80db),
        TextureGenR = ((int)0X0c62),
        CompressedRgba = ((int)0X84ee),
        SignedHilo8Nv = ((int)0X885f),
        ColorWritemask = ((int)0X0c23),
        BumpTargetAti = ((int)0X877c),
        ClampToBorderArb = ((int)0X812d),
        ResampleZeroFillSgix = ((int)0X842f),
        TransformFeedbackBufferSizeNv = ((int)0X8c85),
        FragmentLightModelNormalInterpolationSgix = ((int)0X840b),
        MaxVertexUnitsArb = ((int)0X86a4),
        PointSmoothHint = ((int)0X0c51),
        OutputTextureCoord22Ext = ((int)0X87b3),
        MaxVertexHintPgi = ((int)0X1a22d),
        MultisampleBitExt = ((int)0X20000000),
        StencilValueMask = ((int)0X0b93),
        CurrentRasterPosition = ((int)0X0b07),
        Sampler2DRectShadowArb = ((int)0X8b64),
        CullVertexObjectPositionExt = ((int)0X81ac),
        LuminanceIntegerExt = ((int)0X8d9c),
        AlwaysFastHintPgi = ((int)0X1a20c),
        FloatVec2 = ((int)0X8b50),
        FloatVec3 = ((int)0X8b51),
        TextureShaderNv = ((int)0X86de),
        OutputTextureCoord0Ext = ((int)0X879d),
        PostConvolutionColorTableSgi = ((int)0X80d1),
        VertexProgramPointSizeNv = ((int)0X8642),
        Light0 = ((int)0X4000),
        Gl4XBitAti = ((int)0X00000002),
        GreenMaxClampIngr = ((int)0X8565),
        Map1VertexAttrib124Nv = ((int)0X866c),
        TextureCubeMapNegativeY = ((int)0X8518),
        ArrayEnabled = ((int)0X8622),
        ClipPlane4 = ((int)0X3004),
        R1uiN3fV3fSun = ((int)0X85c7),
        PrimitivesGeneratedNv = ((int)0X8c87),
        VertexAttribArray0Nv = ((int)0X8650),
        SluminanceExt = ((int)0X8c46),
        TextureColorWritemaskSgis = ((int)0X81ef),
        StencilBackFailAti = ((int)0X8801),
        Ambient = ((int)0X1200),
        TexturePreSpecularHp = ((int)0X8169),
        Con21Ati = ((int)0X8956),
        OutputTextureCoord1Ext = ((int)0X879e),
        EmbossMapNv = ((int)0X855f),
        ConstantBorder = ((int)0X8151),
        NearestMipmapLinear = ((int)0X2702),
        Con5Ati = ((int)0X8946),
        ActiveTexture = ((int)0X84e0),
        EdgeFlagArrayCountExt = ((int)0X808d),
        PostTextureFilterScaleSgix = ((int)0X817a),
        FogCoordArrayBufferBinding = ((int)0X889d),
        ProgramNativeTexIndirectionsArb = ((int)0X880a),
        Replace = ((int)0X1e01),
        PointSprite = ((int)0X8861),
        UnsignedShort = ((int)0X1403),
        ConstantColorExt = ((int)0X8001),
        PerspectiveCorrectionHint = ((int)0X0c50),
        Normalize = ((int)0X0ba1),
        PostImageTransformColorTableHp = ((int)0X8162),
        QuarterBitAti = ((int)0X00000010),
        Map1VertexAttrib44Nv = ((int)0X8664),
        Fog = ((int)0X0b60),
        GeometryProgramNv = ((int)0X8c26),
        MatrixIndexArraySizeArb = ((int)0X8846),
        OutputTextureCoord6Ext = ((int)0X87a3),
        VertexArrayStorageHintApple = ((int)0X851f),
        RgbaS3tc = ((int)0X83a2),
        IndexArrayStrideExt = ((int)0X8086),
        HistogramExt = ((int)0X8024),
        VertexProgram = ((int)0X8620),
        CompressedLuminanceArb = ((int)0X84ea),
        NumCompressedTextureFormatsArb = ((int)0X86a2),
        GreenIntegerExt = ((int)0X8d95),
        ClipVolumeClippingHintExt = ((int)0X80f0),
        DrawBuffer15Arb = ((int)0X8834),
        UnsignedInt248Nv = ((int)0X84fa),
        CompressedRgbaFxt13Dfx = ((int)0X86b1),
        Noop = ((int)0X1505),
        Domain = ((int)0X0a02),
        Con23Ati = ((int)0X8958),
        ProgramInstruction = ((int)0X88a0),
        PixelPackBufferArb = ((int)0X88eb),
        TextureFilterControl = ((int)0X8500),
        LuminanceAlpha16uiExt = ((int)0X8d7b),
        Texture1DArrayExt = ((int)0X8c18),
        Texture1DStackBindingMesax = ((int)0X875d),
        PreviousArb = ((int)0X8578),
        ExpandNegateNv = ((int)0X8539),
        VibranceBiasNv = ((int)0X8719),
        VertexArrayBindingApple = ((int)0X85b5),
        ColorMatrix = ((int)0X80b1),
        T2fV3f = ((int)0X2a27),
        Luminance16fArb = ((int)0X881e),
        PrimaryColor = ((int)0X8577),
        FogCoordinateArrayListStrideIbm = ((int)103086),
        TextureBufferFormatExt = ((int)0X8c2e),
        MaxProgramParameterBufferBindingsNv = ((int)0X8da0),
        FogCoord = ((int)0X8451),
        MaxPaletteMatricesArb = ((int)0X8842),
        ObjectLinkStatusArb = ((int)0X8b82),
        MaxProgramLoopDepthNv = ((int)0X88f7),
        Lighting = ((int)0X0b50),
        ImageTransform2DHp = ((int)0X8161),
        SampleCoverageInvert = ((int)0X80ab),
        OrInverted = ((int)0X150d),
        MaxVertexVaryingComponentsExt = ((int)0X8dde),
        IndexArrayListStrideIbm = ((int)103083),
        ColorTableIntensitySize = ((int)0X80df),
        Map1VertexAttrib104Nv = ((int)0X866a),
        ColorTableAlphaSizeSgi = ((int)0X80dd),
        StreamReadArb = ((int)0X88e1),
        DetailTexture2DBindingSgis = ((int)0X8096),
        Reg26Ati = ((int)0X893b),
        VertexAttribArray2Nv = ((int)0X8652),
        HistogramWidthExt = ((int)0X8026),
        PolygonStippleBit = ((int)0X00000010),
        VertexArray = ((int)0X8074),
        HistogramLuminanceSize = ((int)0X802c),
        PnTrianglesNormalModeAti = ((int)0X87f3),
        ReplaceExt = ((int)0X8062),
        TrianglesAdjacencyExt = ((int)0X000c),
        ObjectActiveAttributeMaxLengthArb = ((int)0X8b8a),
        TextureLuminanceSize = ((int)0X8060),
        DetailTextureModeSgis = ((int)0X809b),
        PixelTexGenModeSgix = ((int)0X832b),
        EvalVertexAttrib14Nv = ((int)0X86d4),
        Alpha16iExt = ((int)0X8d8a),
        IntSampler2DArrayExt = ((int)0X8dcf),
        NormalArrayType = ((int)0X807e),
        Texture4 = ((int)0X84c4),
        StorageCachedApple = ((int)0X85be),
        FramebufferBindingExt = ((int)0X8ca6),
        CurrentTangentExt = ((int)0X843b),
        DepthAttachmentExt = ((int)0X8d00),
        OpMultiplyMatrixExt = ((int)0X8798),
        SamplerBufferExt = ((int)0X8dc2),
        PixelTileCacheIncrementSgix = ((int)0X813f),
        TransposeNv = ((int)0X862c),
        MaxClipPlanes = ((int)0X0d32),
        DotProductTexture1DNv = ((int)0X885c),
        OutputTextureCoord2Ext = ((int)0X879f),
        SignedRgbUnsignedAlphaNv = ((int)0X870c),
        FramebufferIncompleteMultisampleExt = ((int)0X8d56),
        ArrayBufferArb = ((int)0X8892),
        CurrentNormal = ((int)0X0b02),
        DistanceAttenuationExt = ((int)0X8129),
        Light7 = ((int)0X4007),
        Intensity8uiExt = ((int)0X8d7f),
        VertexShaderBindingExt = ((int)0X8781),
        TextureCompareFuncArb = ((int)0X884d),
        SingleColor = ((int)0X81f9),
        OpFloorExt = ((int)0X878f),
        Renderer = ((int)0X1f01),
        Texture4Arb = ((int)0X84c4),
        MaxProgramTexelOffsetNv = ((int)0X8905),
        ExpandNormalNv = ((int)0X8538),
        FragmentLight0Sgix = ((int)0X840c),
        OpIndexExt = ((int)0X8782),
        Alpha32uiExt = ((int)0X8d72),
        DualLuminance8Sgis = ((int)0X8115),
        UnsignedShort565Rev = ((int)0X8364),
        StreamCopyArb = ((int)0X88e2),
        Smooth = ((int)0X1d01),
        ScreenCoordinatesRend = ((int)0X8490),
        FogScaleValueSgix = ((int)0X81fd),
        Modelview6Arb = ((int)0X8726),
        DsdtNv = ((int)0X86f5),
        FloatRg32Nv = ((int)0X8887),
        Source2RgbArb = ((int)0X8582),
        UnpackRowLength = ((int)0X0cf2),
        AllAttribBits = unchecked((int)0Xffffffff),
        StrictLightingHintPgi = ((int)0X1a217),
        DetailTextureFuncPointsSgis = ((int)0X809c),
        OutputTextureCoord8Ext = ((int)0X87a5),
        CurrentMatrixStackDepthArb = ((int)0X8640),
        Reg1Ati = ((int)0X8922),
        RenderMode = ((int)0X0c40),
        MirrorClampExt = ((int)0X8742),
        Matrix6Nv = ((int)0X8636),
        ScaleByFourNv = ((int)0X853f),
        ClampToBorderSgis = ((int)0X812d),
        OutputTextureCoord30Ext = ((int)0X87bb),
        VertexStateProgramNv = ((int)0X8621),
        MaxProgramAddressRegisters = ((int)0X88b1),
        StackOverflow = ((int)0X0503),
        Map2VertexAttrib124Nv = ((int)0X867c),
        MaxTransformFeedbackSeparateAttribsNv = ((int)0X8c8b),
        CurrentAttribNv = ((int)0X8626),
        OneMinusDstAlpha = ((int)0X0305),
        FuncReverseSubtract = ((int)0X800b),
        Srgb8Ext = ((int)0X8c41),
        FragmentLight5Sgix = ((int)0X8411),
        TextureBinding2DArrayExt = ((int)0X8c1d),
        TextureBlueSize = ((int)0X805e),
        Matrix3 = ((int)0X88c3),
        Fastest = ((int)0X1101),
        MultisampleSgis = ((int)0X809d),
        QuadAlpha4Sgis = ((int)0X811e),
        Rgb10A2 = ((int)0X8059),
        PixelTileGridWidthSgix = ((int)0X8142),
        Map1Vertex4 = ((int)0X0d98),
        TextureClipmapCenterSgix = ((int)0X8171),
        Map1Vertex3 = ((int)0X0d97),
        StaticAti = ((int)0X8760),
        VariantExt = ((int)0X87c1),
        OpMovExt = ((int)0X8799),
        Multisample3Dfx = ((int)0X86b2),
        ScissorBox = ((int)0X0c10),
        SubtractArb = ((int)0X84e7),
        DepthScale = ((int)0X0d1e),
        TextureMaxLod = ((int)0X813b),
        DrawBuffer14 = ((int)0X8833),
        MultisampleBitArb = ((int)0X20000000),
        ActiveUniformMaxLength = ((int)0X8b87),
        ObjectValidateStatusArb = ((int)0X8b83),
        Du8dv8Ati = ((int)0X877a),
        ReplacementCodeSun = ((int)0X81d8),
        CompressedRgbaS3tcDxt1Ext = ((int)0X83f1),
        PointFadeThresholdSizeArb = ((int)0X8128),
        ObjectDeleteStatusArb = ((int)0X8b80),
        GeometryInputTypeExt = ((int)0X8ddb),
        ProgramAttribComponentsNv = ((int)0X8906),
        UnsignedInt5999RevExt = ((int)0X8c3e),
        IndexOffset = ((int)0X0d13),
        Matrix0Nv = ((int)0X8630),
        Con31Ati = ((int)0X8960),
        HalfBiasNegateNv = ((int)0X853b),
        DotProductTexture3DNv = ((int)0X86ef),
        Dither = ((int)0X0bd0),
        Short = ((int)0X1402),
        CompileAndExecute = ((int)0X1301),
        ArrayStride = ((int)0X8624),
        ProgramNativeAddressRegisters = ((int)0X88b2),
        Texture7 = ((int)0X84c7),
        NumInputInterpolatorComponentsAti = ((int)0X8973),
        PostConvolutionRedBiasExt = ((int)0X8020),
        SrgbAlpha = ((int)0X8c42),
        DepthComponent16Sgix = ((int)0X81a5),
        PixelPackBufferBindingExt = ((int)0X88ed),
        OutputTextureCoord26Ext = ((int)0X87b7),
        YcbcrMesa = ((int)0X8757),
        QuadLuminance4Sgis = ((int)0X8120),
        NumInstructionsPerPassAti = ((int)0X8971),
        Texcoord1BitPgi = ((int)0X10000000),
        Rgba16Ext = ((int)0X805b),
        SaturateBitAti = ((int)0X00000040),
        Alpha8Ext = ((int)0X803c),
        UnsignedInt = ((int)0X1405),
        Matrix3Nv = ((int)0X8633),
        MaxVertexAttribs = ((int)0X8869),
        MaxTextureCoordsNv = ((int)0X8871),
        RgbaFloatModeArb = ((int)0X8820),
        R1uiC3fV3fSun = ((int)0X85c6),
        FormatSubsample244244Oml = ((int)0X8983),
        VertexAttribArray15Nv = ((int)0X865f),
        TextureLightExt = ((int)0X8350),
        UnsignedShort565RevExt = ((int)0X8364),
        Con27Ati = ((int)0X895c),
        AlphaIntegerExt = ((int)0X8d97),
        Texture25Arb = ((int)0X84d9),
        MaxTrackMatricesNv = ((int)0X862f),
        DepthComponent16Arb = ((int)0X81a5),
        MovAti = ((int)0X8961),
        Bool = ((int)0X8b56),
        ModulateSignedAddAti = ((int)0X8745),
        StaticCopyArb = ((int)0X88e6),
        UnsignedIntSampler2DArrayExt = ((int)0X8dd7),
        Source3RgbNv = ((int)0X8583),
        TextureBindingBufferExt = ((int)0X8c2c),
        IuiN3fV3fExt = ((int)0X81b0),
        SecondaryColorArrayListIbm = ((int)103077),
        Texture2DArrayExt = ((int)0X8c1a),
        Texture16 = ((int)0X84d0),
        Texture17 = ((int)0X84d1),
        Texture14 = ((int)0X84ce),
        SpriteEyeAlignedSgix = ((int)0X814e),
        Source1AlphaExt = ((int)0X8589),
        OpExpBase2Ext = ((int)0X8791),
        Source3AlphaNv = ((int)0X858b),
        Texture10 = ((int)0X84ca),
        ProxyTextureRectangleNv = ((int)0X84f7),
        Rgba32iExt = ((int)0X8d82),
        InvariantDatatypeExt = ((int)0X87eb),
        Texture24Arb = ((int)0X84d8),
        Texture19 = ((int)0X84d3),
        ActiveStencilFaceExt = ((int)0X8911),
        ImageRotateOriginXHp = ((int)0X815a),
        DynamicCopy = ((int)0X88ea),
        CurrentFogCoordinateExt = ((int)0X8453),
        Con4Ati = ((int)0X8945),
        Matrix5Nv = ((int)0X8635),
        FogFuncPointsSgis = ((int)0X812b),
        FragmentShaderAti = ((int)0X8920),
        SmoothPointSizeGranularity = ((int)0X0b13),
        TextureColorTableSgi = ((int)0X80bc),
        GreenScale = ((int)0X0d18),
        TextureMatrix = ((int)0X0ba8),
        Texture2DBindingExt = ((int)0X8069),
        PrimitiveIdNv = ((int)0X8c7c),
        Modelview = ((int)0X1700),
        VertexArrayExt = ((int)0X8074),
        SampleCoverageValue = ((int)0X80aa),
        ShadingLanguageVersionArb = ((int)0X8b8c),
        MaxCubeMapTextureSizeExt = ((int)0X851c),
        BinormalArrayTypeExt = ((int)0X8440),
        MulAti = ((int)0X8964),
        ElementArrayTypeApple = ((int)0X8769),
        DotProductPassThroughNv = ((int)0X885b),
        ColorAttachment4Ext = ((int)0X8ce4),
        CurrentRasterNormalSgix = ((int)0X8406),
        TrackMatrixTransformNv = ((int)0X8649),
        UnsignedInt2101010Reversed = ((int)0X8368),
        ColorArrayPointer = ((int)0X8090),
        DiscardAti = ((int)0X8763),
        FloatClearColorValueNv = ((int)0X888d),
        ColorArraySize = ((int)0X8081),
        Spare0PlusSecondaryColorNv = ((int)0X8532),
        PixelCountAvailableNv = ((int)0X8867),
        RedIntegerExt = ((int)0X8d94),
        Color3BitPgi = ((int)0X00010000),
        Map1VertexAttrib134Nv = ((int)0X866d),
        TextureMagFilter = ((int)0X2800),
        EdgeFlagArrayPointer = ((int)0X8093),
        Texture26Arb = ((int)0X84da),
        FeedbackBufferType = ((int)0X0df2),
        ConvolutionFilterBias = ((int)0X8015),
        SampleAlphaToOneArb = ((int)0X809f),
        Rgba4S3tc = ((int)0X83a3),
        Rgb5A1 = ((int)0X8057),
        MaxProgramNativeTemporaries = ((int)0X88a7),
        MatColorIndexesBitPgi = ((int)0X01000000),
        BufferSize = ((int)0X8764),
        MaxTextureImageUnits = ((int)0X8872),
        Luminance = ((int)0X1909),
        VertexAttribArray11Nv = ((int)0X865b),
        GreenBits = ((int)0X0d53),
        Map1TextureCoord1 = ((int)0X0d93),
        BgrExt = ((int)0X80e0),
        PackCmykHintExt = ((int)0X800e),
        DepthComponent24Sgix = ((int)0X81a6),
        PixelMapIToBSize = ((int)0X0cb4),
        PointSmooth = ((int)0X0b10),
        RgbaIntegerModeExt = ((int)0X8d9e),
        VertexAttribArray7Nv = ((int)0X8657),
        Rgba12 = ((int)0X805a),
        DrawBuffer6Ati = ((int)0X882b),
        TransformFeedbackBufferNv = ((int)0X8c8e),
        TextureMinLod = ((int)0X813a),
        NearestClipmapNearestSgix = ((int)0X844d),
        DontCare = ((int)0X1100),
        ObjectActiveAttributesArb = ((int)0X8b89),
        UnsignedIntVec3Ext = ((int)0X8dc7),
        MaxProgramNativeAluInstructionsArb = ((int)0X880e),
        LightEnvModeSgix = ((int)0X8407),
        VertexAttribArray13Nv = ((int)0X865d),
        Luminance8Ext = ((int)0X8040),
        VertexIdNv = ((int)0X8c7b),
        AverageExt = ((int)0X8335),
        VertexAttribArray14Nv = ((int)0X865e),
        CompareRToTexture = ((int)0X884e),
        SluminanceAlphaExt = ((int)0X8c44),
        Sampler2DArb = ((int)0X8b5e),
        Rgb8 = ((int)0X8051),
        MaxOptimizedVertexShaderLocalsExt = ((int)0X87ce),
        AttribArraySizeNv = ((int)0X8623),
        MatrixPaletteArb = ((int)0X8840),
        PrimaryColorExt = ((int)0X8577),
        ScissorTest = ((int)0X0c11),
        PackSkipVolumesSgis = ((int)0X8130),
        ProxyTexture2DArrayExt = ((int)0X8c1b),
        RgbFloat32Ati = ((int)0X8815),
        Sampler1DShadow = ((int)0X8b61),
        Sluminance8Alpha8 = ((int)0X8c45),
        UnsignedIntVec2Ext = ((int)0X8dc6),
        StencilIndex8Ext = ((int)0X8d48),
        TypeRgbaFloatAti = ((int)0X8820),
        PixelTileGridDepthSgix = ((int)0X8144),
        Con30Ati = ((int)0X895f),
        Coeff = ((int)0X0a00),
        Nicest = ((int)0X1102),
        CombinerMappingNv = ((int)0X8543),
        FogCoordinateExt = ((int)0X8451),
        SampleAlphaToMaskSgis = ((int)0X809e),
        Reg7Ati = ((int)0X8928),
        UnsignedShort4444RevExt = ((int)0X8365),
        TextureMaxLevel = ((int)0X813d),
        IntSampler3DExt = ((int)0X8dcb),
        Gl422AverageExt = ((int)0X80ce),
        Rgb16iExt = ((int)0X8d89),
        Modelview1Arb = ((int)0X850a),
        Operand2RgbArb = ((int)0X8592),
        SecondaryColorArrayListStrideIbm = ((int)103087),
        LinearSharpenAlphaSgis = ((int)0X80ae),
        UnsignedNormalizedArb = ((int)0X8c17),
        Map2Normal = ((int)0X0db2),
        Texture23Arb = ((int)0X84d7),
        SecondaryColorArrayPointerExt = ((int)0X845d),
        Samples = ((int)0X80a9),
        VertexAttribArray12Nv = ((int)0X865c),
        PnTrianglesPointModeCubicAti = ((int)0X87f6),
        FogHint = ((int)0X0c54),
        MaxTrackMatrixStackDepthNv = ((int)0X862e),
        ZExt = ((int)0X87d7),
        Light5 = ((int)0X4005),
        ViewportBit = ((int)0X00000800),
        CurrentMatrixStackDepthNv = ((int)0X8640),
        EyePointSgis = ((int)0X81f4),
        RenderbufferGreenSizeExt = ((int)0X8d51),
        Ycrcb422Sgix = ((int)0X81bb),
        HistogramWidth = ((int)0X8026),
        UnsignedShort88Apple = ((int)0X85ba),
        UnsignedIntVec4Ext = ((int)0X8dc8),
        Texture23 = ((int)0X84d7),
        ShaderSourceLength = ((int)0X8b88),
        LightModelColorControl = ((int)0X81f8),
        TransposeModelviewMatrixArb = ((int)0X84e3),
        IndexTestFuncExt = ((int)0X81b6),
        DsdtMagNv = ((int)0X86f6),
        MinmaxSink = ((int)0X8030),
        StreamCopy = ((int)0X88e2),
        UpperLeft = ((int)0X8ca2),
        OffsetHiloTexture2DNv = ((int)0X8854),
        PackAlignment = ((int)0X0d05),
        PixelFragmentAlphaSourceSgis = ((int)0X8355),
        OffsetProjectiveTextureRectangleNv = ((int)0X8852),
        OutputTextureCoord23Ext = ((int)0X87b4),
        Reg31Ati = ((int)0X8940),
        ObjectAttachedObjectsArb = ((int)0X8b85),
        Green = ((int)0X1904),
        NumCompressedTextureFormats = ((int)0X86a2),
        Matrix27 = ((int)0X88db),
        CombinerComponentUsageNv = ((int)0X8544),
        SelectionBufferPointer = ((int)0X0df3),
        TextureMinLodSgis = ((int)0X813a),
        IntSamplerCubeExt = ((int)0X8dcc),
        RenderbufferCoverageSamplesNv = ((int)0X8cab),
        PixelPackBufferBinding = ((int)0X88ed),
        CombinerScaleNv = ((int)0X8548),
        FragmentDepth = ((int)0X8452),
        ProgramErrorStringArb = ((int)0X8874),
        FramebufferIncompleteMissingAttachmentExt = ((int)0X8cd7),
        BumpNumTexUnitsAti = ((int)0X8777),
        UnsignedIntSampler2DRectExt = ((int)0X8dd5),
        SliceAccumSun = ((int)0X85cc),
        Luminance16Alpha16Ext = ((int)0X8048),
        ObjectInfoLogLengthArb = ((int)0X8b84),
        Matrix15 = ((int)0X88cf),
        EyeLinear = ((int)0X2400),
        PostConvolutionRedScale = ((int)0X801c),
        N3fV3f = ((int)0X2a25),
        MatrixMode = ((int)0X0ba0),
        PackSwapBytes = ((int)0X0d00),
        RenderbufferExt = ((int)0X8d41),
        MaxTextureLodBias = ((int)0X84fd),
        CmykaExt = ((int)0X800d),
        CompressedRgb = ((int)0X84ed),
        DrawBuffer5Ati = ((int)0X882a),
        TextureCubeMapNegativeXExt = ((int)0X8516),
        ProgramTexIndirectionsArb = ((int)0X8807),
        MaxProgramAttribs = ((int)0X88ad),
        Intensity32iExt = ((int)0X8d85),
        SecondaryColorArray = ((int)0X845e),
        SmoothLineWidthRange = ((int)0X0b22),
        PointSizeMinSgis = ((int)0X8126),
        TangentArrayExt = ((int)0X8439),
        T2fC4ubV3f = ((int)0X2a29),
        ObjectBufferUsageAti = ((int)0X8765),
        FloatMat3 = ((int)0X8b5b),
        Repeat = ((int)0X2901),
        Lequal = ((int)0X0203),
        GeometryDeformationSgix = ((int)0X8194),
        LuminanceAlpha32iExt = ((int)0X8d87),
        Rgba12Ext = ((int)0X805a),
        AccumAlphaBits = ((int)0X0d5b),
        TextureClipmapFrameSgix = ((int)0X8172),
        QuadMeshSun = ((int)0X8614),
        PolygonOffsetFactorExt = ((int)0X8038),
        TextureLodBias = ((int)0X8501),
        CombineAlphaExt = ((int)0X8572),
        TransposeCurrentMatrixArb = ((int)0X88b7),
        BlendSrcAlpha = ((int)0X80cb),
        UnpackCmykHintExt = ((int)0X800f),
        StencilTest = ((int)0X0b90),
        CurrentTextureCoords = ((int)0X0b03),
        TextureCompareModeArb = ((int)0X884c),
        OpMinExt = ((int)0X878b),
        NativeGraphicsBeginHintPgi = ((int)0X1a203),
        PostColorMatrixBlueScaleSgi = ((int)0X80b6),
        TextureWrapT = ((int)0X2803),
        CurrentRasterIndex = ((int)0X0b05),
        Matrix20 = ((int)0X88d4),
        Matrix30 = ((int)0X88de),
        PostColorMatrixGreenBiasSgi = ((int)0X80b9),
        VertexShaderInstructionsExt = ((int)0X87cf),
        Luminance16Alpha16 = ((int)0X8048),
        TransposeProjectionMatrix = ((int)0X84e4),
        StencilBackRef = ((int)0X8ca3),
        Texture9 = ((int)0X84c9),
        TextureCoordArrayListIbm = ((int)103074),
        PostColorMatrixColorTableSgi = ((int)0X80d2),
        GeometryShaderExt = ((int)0X8dd9),
        Back = ((int)0X0405),
        LinkStatus = ((int)0X8b82),
        FramebufferExt = ((int)0X8d40),
        Intensity12 = ((int)0X804c),
        FragmentMaterialExt = ((int)0X8349),
        T2fN3fV3f = ((int)0X2a2b),
        PixelSubsample4242Sgix = ((int)0X85a4),
        TextureCoordArrayExt = ((int)0X8078),
        Combiner7Nv = ((int)0X8557),
        VertexStream1Ati = ((int)0X876d),
        Modelview3Arb = ((int)0X8723),
        Source1AlphaArb = ((int)0X8589),
        BoolVec4Arb = ((int)0X8b59),
        PointSize = ((int)0X0b11),
        IndexShift = ((int)0X0d12),
        LinearClipmapLinearSgix = ((int)0X8170),
        VertexWeightArrayStrideExt = ((int)0X850f),
        CombinerCdDotProductNv = ((int)0X8546),
        VertexArrayRangeLengthApple = ((int)0X851e),
        BackRight = ((int)0X0403),
        ClientVertexArrayBit = ((int)0X00000002),
        Operand1AlphaArb = ((int)0X8599),
        TextureHiSizeNv = ((int)0X871b),
        MaxEvalOrder = ((int)0X0d30),
        PackSkipPixels = ((int)0X0d04),
        Intensity4Ext = ((int)0X804a),
        PointFadeThresholdSizeSgis = ((int)0X8128),
        MaxAsyncReadPixelsSgix = ((int)0X8361),
        ProxyTexture2DStackMesax = ((int)0X875c),
        NormalArrayStride = ((int)0X807f),
        PixelMapBToBSize = ((int)0X0cb8),
        MaxProgramAluInstructionsArb = ((int)0X880b),
        MaxElementsVerticesExt = ((int)0X80e8),
        FloatRgNv = ((int)0X8881),
        ProgramLength = ((int)0X8627),
        MapTessellationNv = ((int)0X86c2),
        Intensity16iExt = ((int)0X8d8b),
        PostColorMatrixBlueBias = ((int)0X80ba),
        ColorTableSgi = ((int)0X80d0),
        SrgbAlphaExt = ((int)0X8c42),
        EyeRadialNv = ((int)0X855b),
        BgraIntegerExt = ((int)0X8d9b),
        EvalVertexAttrib2Nv = ((int)0X86c8),
        PixelTexGenQRoundSgix = ((int)0X8185),
        SharpenTextureFuncPointsSgis = ((int)0X80b0),
        QueryResultAvailable = ((int)0X8867),
        QuadLuminance8Sgis = ((int)0X8121),
        ShadingLanguageVersion = ((int)0X8b8c),
        MaxCombinedTextureImageUnits = ((int)0X8b4d),
        CompareRToTextureArb = ((int)0X884e),
        Texture4DsizeSgis = ((int)0X8136),
        CurrentBit = ((int)0X00000001),
        Operand0Rgb = ((int)0X8590),
        Byte = ((int)0X1400),
        IndexArrayPointer = ((int)0X8091),
        CoordReplace = ((int)0X8862),
        Matrix17 = ((int)0X88d1),
        BgrIntegerExt = ((int)0X8d9a),
        BoolVec2 = ((int)0X8b57),
        Texture3Arb = ((int)0X84c3),
        Convolution2DExt = ((int)0X8011),
        VertexPreclipHintSgix = ((int)0X83ef),
        ReferencePlaneEquationSgix = ((int)0X817e),
        CurrentColor = ((int)0X0b00),
        Operand0RgbExt = ((int)0X8590),
        Luminance4Alpha4Ext = ((int)0X8043),
        OneMinusDstColor = ((int)0X0307),
        ProxyTextureCubeMap = ((int)0X851b),
        HalfFloatNv = ((int)0X140b),
        Map1GridSegments = ((int)0X0dd1),
        VertexStream4Ati = ((int)0X8770),
        ScaleByTwoNv = ((int)0X853e),
        TextureBorder = ((int)0X1005),
        Matrix2 = ((int)0X88c2),
        VariableANv = ((int)0X8523),
        Matrix0 = ((int)0X88c0),
        Matrix1 = ((int)0X88c1),
        Matrix6 = ((int)0X88c6),
        Matrix7 = ((int)0X88c7),
        BlueIntegerExt = ((int)0X8d96),
        Matrix5 = ((int)0X88c5),
        UnsignedShort88RevMesa = ((int)0X85bb),
        MaxProgramNativeInstructions = ((int)0X88a3),
        QuadStrip = ((int)0X0008),
        DepthComponent24 = ((int)0X81a6),
        ClientActiveTextureArb = ((int)0X84e1),
        SharedTexturePaletteExt = ((int)0X81fb),
        NormalMap = ((int)0X8511),
        DependentRgbTextureCubeMapNv = ((int)0X885a),
        ImageTranslateXHp = ((int)0X8157),
        FramebufferAttachmentTextureLevelExt = ((int)0X8cd2),
        DepthFunc = ((int)0X0b74),
        Front = ((int)0X0404),
        Intensity8iExt = ((int)0X8d91),
        V3f = ((int)0X2a21),
        UnsignedShort4444Rev = ((int)0X8365),
        Map2VertexAttrib134Nv = ((int)0X867d),
        Dot3RgbArb = ((int)0X86ae),
        PolygonOffsetExt = ((int)0X8037),
        Operand3RgbNv = ((int)0X8593),
        DrawBuffer6Arb = ((int)0X882b),
        AuxBuffers = ((int)0X0c00),
        Gl3DColor = ((int)0X0602),
        CompressedRedGreenRgtc2Ext = ((int)0X8dbd),
        GreenBitAti = ((int)0X00000002),
        FragmentProgramBindingNv = ((int)0X8873),
        PackResampleSgix = ((int)0X842c),
        Source0Rgb = ((int)0X8580),
        Map2Color4 = ((int)0X0db0),
        SpriteAxialSgix = ((int)0X814c),
        BufferMapPointer = ((int)0X88bd),
        VertexStream6Ati = ((int)0X8772),
        ClientAttribStackDepth = ((int)0X0bb1),
        ObjectCompileStatusArb = ((int)0X8b81),
        TextureBindingRectangleNv = ((int)0X84f6),
        MaxActiveLightsSgix = ((int)0X8405),
        DsBiasNv = ((int)0X8716),
        VertexProgramParameterBufferNv = ((int)0X8da2),
        VariableCNv = ((int)0X8525),
        SampleMaskExt = ((int)0X80a0),
        FuncAddExt = ((int)0X8006),
        MaxVertexShaderLocalsExt = ((int)0X87c9),
        Gl4Pass3Sgis = ((int)0X80a7),
        MultisampleFilterHintNv = ((int)0X8534),
        TransformHintApple = ((int)0X85b1),
        Depth32fStencil8Nv = ((int)0X8dac),
        PostColorMatrixGreenBias = ((int)0X80b9),
        FloatRgb32Nv = ((int)0X8889),
        PackSkipRows = ((int)0X0d03),
        DepthBufferFloatModeNv = ((int)0X8daf),
        PackResampleOml = ((int)0X8984),
        PixelMapIToISize = ((int)0X0cb0),
        FogCoordinateArrayBufferBindingArb = ((int)0X889d),
        LinearMipmapNearest = ((int)0X2701),
        FogBit = ((int)0X00000080),
        TextureCoordArrayTypeExt = ((int)0X8089),
        R5G6B5A8IccSgix = ((int)0X8467),
        Con28Ati = ((int)0X895d),
        ProgramBinding = ((int)0X8677),
        DepthComponent32fNv = ((int)0X8dab),
        Rgba8Ext = ((int)0X8058),
        Modelview30Arb = ((int)0X873e),
        Minmax = ((int)0X802e),
        EdgeFlagArrayBufferBinding = ((int)0X889b),
        Con9Ati = ((int)0X894a),
        DynamicDraw = ((int)0X88e8),
        EvalVertexAttrib7Nv = ((int)0X86cd),
        AsyncTexImageSgix = ((int)0X835c),
        Reg6Ati = ((int)0X8927),
        SamplerCubeShadowExt = ((int)0X8dc5),
        Previous = ((int)0X8578),
        MinmaxSinkExt = ((int)0X8030),
        Equal = ((int)0X0202),
        VariableENv = ((int)0X8527),
        SpotExponent = ((int)0X1205),
        Operand0AlphaExt = ((int)0X8598),
        IndexArrayListIbm = ((int)103073),
        MaxGeneralCombinersNv = ((int)0X854d),
        DynamicAti = ((int)0X8761),
        Rgb16uiExt = ((int)0X8d77),
        VertexArrayRangeWithoutFlushNv = ((int)0X8533),
        MaxConvolutionWidth = ((int)0X801a),
        PixelTileBestAlignmentSgix = ((int)0X813e),
        BufferMapped = ((int)0X88bc),
        VertexStream3Ati = ((int)0X876f),
        BitmapToken = ((int)0X0704),
        TextureClipmapOffsetSgix = ((int)0X8173),
        HistogramSink = ((int)0X802d),
        ProxyPostColorMatrixColorTable = ((int)0X80d5),
        BufferMappedArb = ((int)0X88bc),
        TextureDepthExt = ((int)0X8071),
        PixelFragmentRgbSourceSgis = ((int)0X8354),
        EvalVertexAttrib11Nv = ((int)0X86d1),
        ShadeModel = ((int)0X0b54),
        FogOffsetSgix = ((int)0X8198),
        VariableFNv = ((int)0X8528),
        PointSizeRange = ((int)0X0b12),
        DrawBuffer12Ati = ((int)0X8831),
        FramebufferIncompleteLayerCountExt = ((int)0X8da9),
        Gl4DColorTexture = ((int)0X0604),
        Matrix26 = ((int)0X88da),
        LinesAdjacencyExt = ((int)0X000a),
        Map1GridDomain = ((int)0X0dd0),
        ConstantColor0Nv = ((int)0X852a),
        MaxProgramNativeTexInstructionsArb = ((int)0X880f),
        PixelCounterBitsNv = ((int)0X8864),
        OpCrossProductExt = ((int)0X8797),
        FragmentNormalExt = ((int)0X834a),
        TransformFeedbackBufferModeNv = ((int)0X8c7f),
        FragmentProgramParameterBufferNv = ((int)0X8da4),
        VariableGNv = ((int)0X8529),
        VertexArrayStrideExt = ((int)0X807c),
        ProgramTemporaries = ((int)0X88a4),
        MapAttribVOrderNv = ((int)0X86c4),
        TextureCubeMapPositiveXArb = ((int)0X8515),
        VertexAttribArray10Nv = ((int)0X865a),
        TextureCompareFailValueArb = ((int)0X80bf),
        UnpackSkipVolumesSgis = ((int)0X8132),
        PixelTexGenAlphaReplaceSgix = ((int)0X8187),
        VertexStream5Ati = ((int)0X8771),
        QuadTextureSelectSgis = ((int)0X8125),
        PreferDoublebufferHintPgi = ((int)0X1a1f8),
        TextureDeformationSgix = ((int)0X8195),
        ConvolutionFilterBiasExt = ((int)0X8015),
        ClampVertexColorArb = ((int)0X891a),
        Modelview11Arb = ((int)0X872b),
        IntensityIccSgix = ((int)0X8464),
        EdgeFlagArrayListIbm = ((int)103075),
        AverageHp = ((int)0X8160),
        PixelPackBufferBindingArb = ((int)0X88ed),
        Depth = ((int)0X1801),
        VertexStream0Ati = ((int)0X876c),
        PostConvolutionGreenScaleExt = ((int)0X801d),
        Map2VertexAttrib64Nv = ((int)0X8676),
        MatrixIndexArrayArb = ((int)0X8844),
        TextureCoordArrayStrideExt = ((int)0X808a),
        MaxGeometryVaryingComponentsExt = ((int)0X8ddd),
        ProxyTexture1DExt = ((int)0X8063),
        LinearDetailSgis = ((int)0X8097),
        LuminanceAlphaIccSgix = ((int)0X8465),
        RgbS3tc = ((int)0X83a0),
        TextureCubeMapNegativeX = ((int)0X8516),
        Operand0RgbArb = ((int)0X8590),
        TextureCubeMapNegativeZ = ((int)0X851a),
        BlendDst = ((int)0X0be0),
        FragmentColorMaterialFaceSgix = ((int)0X8402),
        ReadOnly = ((int)0X88b8),
        ConvolutionWidthExt = ((int)0X8018),
        DrawBuffer11Ati = ((int)0X8830),
        IgnoreBorderHp = ((int)0X8150),
        CombinerAbDotProductNv = ((int)0X8545),
        PolygonOffsetUnits = ((int)0X2a00),
        ColorAttachment10Ext = ((int)0X8cea),
        Modelview1StackDepthExt = ((int)0X8502),
        TextureCubeMapPositiveZArb = ((int)0X8519),
        FramebufferAttachmentTextureLayerExt = ((int)0X8cd4),
        TextureResident = ((int)0X8067),
        WeightArrayArb = ((int)0X86ad),
        Rgba8 = ((int)0X8058),
        HistogramGreenSizeExt = ((int)0X8029),
        PixelUnpackBuffer = ((int)0X88ec),
        VertexStream7Ati = ((int)0X8773),
        Rgba2 = ((int)0X8055),
        Gl4Pass2Sgis = ((int)0X80a6),
        StencilRef = ((int)0X0b97),
        TextureBinding1DArrayExt = ((int)0X8c1c),
        DsdtMagIntensityNv = ((int)0X86dc),
        Combiner1Nv = ((int)0X8551),
        Rgba4 = ((int)0X8056),
        PostConvolutionGreenBias = ((int)0X8021),
        PolygonOffsetFactor = ((int)0X8038),
    }

    public enum ArbImaging
    {
        PostConvolutionAlphaScale = ((int)0X801f),
        Separable2D = ((int)0X8012),
        ConvolutionBorderMode = ((int)0X8013),
        ColorTableFormat = ((int)0X80d8),
        HistogramRedSize = ((int)0X8028),
        ProxyColorTable = ((int)0X80d3),
        PostColorMatrixGreenBias = ((int)0X80b9),
        PostConvolutionGreenScale = ((int)0X801d),
        PostConvolutionBlueScale = ((int)0X801e),
        ConvolutionHeight = ((int)0X8019),
        MaxConvolutionWidth = ((int)0X801a),
        Convolution2D = ((int)0X8011),
        TableTooLarge = ((int)0X8031),
        ColorMatrixStackDepth = ((int)0X80b2),
        PostConvolutionColorTable = ((int)0X80d1),
        PostColorMatrixBlueBias = ((int)0X80ba),
        PostColorMatrixColorTable = ((int)0X80d2),
        HistogramFormat = ((int)0X8027),
        ConstantBorder = ((int)0X8151),
        ProxyPostConvolutionColorTable = ((int)0X80d4),
        PostConvolutionGreenBias = ((int)0X8021),
        Convolution1D = ((int)0X8010),
        HistogramGreenSize = ((int)0X8029),
        HistogramLuminanceSize = ((int)0X802c),
        PostColorMatrixAlphaBias = ((int)0X80bb),
        HistogramAlphaSize = ((int)0X802b),
        ProxyPostColorMatrixColorTable = ((int)0X80d5),
        ColorTable = ((int)0X80d0),
        BlendEquation = ((int)0X8009),
        ColorTableWidth = ((int)0X80d9),
        HistogramSink = ((int)0X802d),
        ColorMatrix = ((int)0X80b1),
        ColorTableAlphaSize = ((int)0X80dd),
        OneMinusConstantColor = ((int)0X8002),
        Reduce = ((int)0X8016),
        ConvolutionWidth = ((int)0X8018),
        PostColorMatrixRedBias = ((int)0X80b8),
        ColorTableLuminanceSize = ((int)0X80de),
        ReplicateBorder = ((int)0X8153),
        Histogram = ((int)0X8024),
        PostConvolutionRedScale = ((int)0X801c),
        OneMinusConstantAlpha = ((int)0X8004),
        MaxColorMatrixStackDepth = ((int)0X80b3),
        Minmax = ((int)0X802e),
        HistogramWidth = ((int)0X8026),
        ColorTableScale = ((int)0X80d6),
        PostConvolutionAlphaBias = ((int)0X8023),
        PostColorMatrixGreenScale = ((int)0X80b5),
        ConstantColor = ((int)0X8001),
        ConvolutionFilterScale = ((int)0X8014),
        ColorTableGreenSize = ((int)0X80db),
        PostColorMatrixBlueScale = ((int)0X80b6),
        PostConvolutionBlueBias = ((int)0X8022),
        MaxConvolutionHeight = ((int)0X801b),
        MinmaxFormat = ((int)0X802f),
        ColorTableRedSize = ((int)0X80da),
        ColorTableBias = ((int)0X80d7),
        ProxyHistogram = ((int)0X8025),
        PostColorMatrixRedScale = ((int)0X80b4),
        PostConvolutionRedBias = ((int)0X8020),
        BlendColor = ((int)0X8005),
        MinmaxSink = ((int)0X8030),
        ConstantAlpha = ((int)0X8003),
        ColorTableIntensitySize = ((int)0X80df),
        ColorTableBlueSize = ((int)0X80dc),
        ConvolutionFormat = ((int)0X8017),
        ConvolutionFilterBias = ((int)0X8015),
        PostColorMatrixAlphaScale = ((int)0X80b7),
        ConvolutionBorderColor = ((int)0X8154),
        HistogramBlueSize = ((int)0X802a),
    }

    public enum BlendEquationMode
    {
        FuncReverseSubtract = ((int)0X800b),
        FuncAdd = ((int)0X8006),
        FuncSubtract = ((int)0X800a),
        Max = ((int)0X8008),
        Min = ((int)0X8007),
    }

    public enum TextureEnvModeCombine
    {
        Dot3Rgba = ((int)0X86af),
        Dot3Rgb = ((int)0X86ae),
        Add = ((int)0X0104),
        Modulate = ((int)0X2100),
        Replace = ((int)0X1e01),
        Subtract = ((int)0X84e7),
        AddSigned = ((int)0X8574),
        Interpolate = ((int)0X8575),
    }

    public enum TextureEnvModeSource
    {
        Texture5 = ((int)0X84c5),
        Texture3 = ((int)0X84c3),
        Texture30 = ((int)0X84de),
        Texture = ((int)0X1702),
        Texture12 = ((int)0X84cc),
        Texture13 = ((int)0X84cd),
        Texture6 = ((int)0X84c6),
        Previous = ((int)0X8578),
        Texture16 = ((int)0X84d0),
        Texture17 = ((int)0X84d1),
        Texture14 = ((int)0X84ce),
        Texture15 = ((int)0X84cf),
        PrimaryColor = ((int)0X8577),
        Texture28 = ((int)0X84dc),
        Texture10 = ((int)0X84ca),
        Texture11 = ((int)0X84cb),
        Texture8 = ((int)0X84c8),
        Texture18 = ((int)0X84d2),
        Texture19 = ((int)0X84d3),
        Texture2 = ((int)0X84c2),
        Texture31 = ((int)0X84df),
        Texture26 = ((int)0X84da),
        Texture27 = ((int)0X84db),
        Texture24 = ((int)0X84d8),
        Texture25 = ((int)0X84d9),
        Texture22 = ((int)0X84d6),
        Texture23 = ((int)0X84d7),
        Texture20 = ((int)0X84d4),
        Texture21 = ((int)0X84d5),
        Texture0 = ((int)0X84c0),
        Texture29 = ((int)0X84dd),
        Texture7 = ((int)0X84c7),
        Constant = ((int)0X8576),
        Texture1 = ((int)0X84c1),
        Texture4 = ((int)0X84c4),
        Texture9 = ((int)0X84c9),
    }

    public enum TextureEnvModeOperandRgb
    {
        OneMinusSrcColor = ((int)0X0301),
        SrcColor = ((int)0X0300),
        OneMinusSrcAlpha = ((int)0X0303),
        SrcAlpha = ((int)0X0302),
    }

    public enum TextureEnvModeOperandAlpha
    {
        OneMinusSrcAlpha = ((int)0X0303),
        SrcAlpha = ((int)0X0302),
    }

    public enum TextureEnvModeScale
    {
        Two = ((int)2),
        One = ((int)1),
        Four = ((int)4),
    }

    public enum TextureUnit
    {
        Texture17 = ((int)0X84d1),
        Texture8 = ((int)0X84c8),
        Texture10 = ((int)0X84ca),
        Texture12 = ((int)0X84cc),
        Texture13 = ((int)0X84cd),
        Texture9 = ((int)0X84c9),
        Texture11 = ((int)0X84cb),
        Texture29 = ((int)0X84dd),
        Texture1 = ((int)0X84c1),
        Texture26 = ((int)0X84da),
        Texture18 = ((int)0X84d2),
        Texture19 = ((int)0X84d3),
        Texture22 = ((int)0X84d6),
        Texture23 = ((int)0X84d7),
        Texture6 = ((int)0X84c6),
        Texture21 = ((int)0X84d5),
        Texture7 = ((int)0X84c7),
        Texture5 = ((int)0X84c5),
        Texture28 = ((int)0X84dc),
        Texture2 = ((int)0X84c2),
        Texture3 = ((int)0X84c3),
        Texture25 = ((int)0X84d9),
        Texture30 = ((int)0X84de),
        Texture31 = ((int)0X84df),
        Texture0 = ((int)0X84c0),
        Texture27 = ((int)0X84db),
        Texture24 = ((int)0X84d8),
        Texture16 = ((int)0X84d0),
        Texture15 = ((int)0X84cf),
        Texture14 = ((int)0X84ce),
        Texture20 = ((int)0X84d4),
        Texture4 = ((int)0X84c4),
    }

    public enum TextureCompareMode
    {
        CompareRToTexture = ((int)0X884e),
    }

    public enum FogPointerType
    {
        Float = ((int)0X1406),
        Double = ((int)0X140a),
    }

    public enum PointParameterName
    {
        PointFadeThresholdSize = ((int)0X8128),
        PointSizeMax = ((int)0X8127),
        PointDistanceAttenuation = ((int)0X8129),
        PointSizeMin = ((int)0X8126),
        PointSpriteCoordOrigin = ((int)0X8ca0),
    }

    public enum QueryTarget
    {
        SamplesPassed = ((int)0X8914),
    }

    public enum GetQueryParam
    {
        QueryCounterBits = ((int)0X8864),
        CurrentQuery = ((int)0X8865),
    }

    public enum GetQueryObjectParam
    {
        QueryResultAvailable = ((int)0X8867),
        QueryResult = ((int)0X8866),
    }

    public enum BufferTarget
    {
        ArrayBuffer = ((int)0X8892),
        ElementArrayBuffer = ((int)0X8893),
        PixelUnpackBuffer = ((int)0X88ec),
        PixelPackBuffer = ((int)0X88eb),
    }

    public enum BufferUsageHint
    {
        StreamDraw = ((int)0X88e0),
        DynamicCopy = ((int)0X88ea),
        StaticDraw = ((int)0X88e4),
        StaticCopy = ((int)0X88e6),
        StaticRead = ((int)0X88e5),
        StreamCopy = ((int)0X88e2),
        DynamicDraw = ((int)0X88e8),
        DynamicRead = ((int)0X88e9),
        StreamRead = ((int)0X88e1),
    }

    public enum BufferAccess
    {
        WriteOnly = ((int)0X88b9),
        ReadWrite = ((int)0X88ba),
        ReadOnly = ((int)0X88b8),
    }

    public enum BufferParameterName
    {
        BufferUsage = ((int)0X8765),
        BufferSize = ((int)0X8764),
        BufferAccess = ((int)0X88bb),
        BufferMapped = ((int)0X88bc),
    }

    public enum BufferPointer
    {
        BufferMapPointer = ((int)0X88bd),
    }

    public enum ShaderType
    {
        GeometryShaderExt = ((int)0X8dd9),
        FragmentShader = ((int)0X8b30),
        VertexShader = ((int)0X8b31),
    }

    public enum ActiveUniformType
    {
        FloatMat4x2 = ((int)0X8b69),
        Sampler2DShadow = ((int)0X8b62),
        Bool = ((int)0X8b56),
        IntVec4 = ((int)0X8b55),
        FloatMat4x3 = ((int)0X8b6a),
        FloatMat3x2 = ((int)0X8b67),
        SamplerCube = ((int)0X8b60),
        FloatMat2x3 = ((int)0X8b65),
        FloatMat2x4 = ((int)0X8b66),
        FloatMat3x4 = ((int)0X8b68),
        BoolVec2 = ((int)0X8b57),
        Sampler1D = ((int)0X8b5d),
        FloatMat2 = ((int)0X8b5a),
        FloatMat3 = ((int)0X8b5b),
        Sampler3D = ((int)0X8b5f),
        Sampler2D = ((int)0X8b5e),
        FloatVec2 = ((int)0X8b50),
        FloatVec3 = ((int)0X8b51),
        Int = ((int)0X1404),
        Sampler1DShadow = ((int)0X8b61),
        BoolVec4 = ((int)0X8b59),
        FloatVec4 = ((int)0X8b52),
        Float = ((int)0X1406),
        FloatMat4 = ((int)0X8b5c),
        BoolVec3 = ((int)0X8b58),
        IntVec2 = ((int)0X8b53),
        IntVec3 = ((int)0X8b54),
    }

    public enum ActiveAttribType
    {
        FloatMat2 = ((int)0X8b5a),
        Float = ((int)0X1406),
        FloatVec2 = ((int)0X8b50),
        FloatVec3 = ((int)0X8b51),
        FloatMat3 = ((int)0X8b5b),
        FloatVec4 = ((int)0X8b52),
        FloatMat4 = ((int)0X8b5c),
    }

    public enum VertexAttribPointerType
    {
        UnsignedByte = ((int)0X1401),
        Byte = ((int)0X1400),
        UnsignedInt = ((int)0X1405),
        Short = ((int)0X1402),
        Int = ((int)0X1404),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        UnsignedShort = ((int)0X1403),
    }

    public enum ShaderParameter
    {
        DeleteStatus = ((int)0X8b80),
        InfoLogLength = ((int)0X8b84),
        CompileStatus = ((int)0X8b81),
        ShaderSourceLength = ((int)0X8b88),
        ShaderType = ((int)0X8b4f),
    }

    public enum ProgramParameter
    {
        ActiveAttributeMaxLength = ((int)0X8b8a),
        DeleteStatus = ((int)0X8b80),
        ActiveUniformMaxLength = ((int)0X8b87),
        AttachedShaders = ((int)0X8b85),
        ActiveUniforms = ((int)0X8b86),
        InfoLogLength = ((int)0X8b84),
        ValidateStatus = ((int)0X8b83),
        ActiveAttributes = ((int)0X8b89),
        LinkStatus = ((int)0X8b82),
    }

    public enum VertexAttribParameter
    {
        ArrayEnabled = ((int)0X8622),
        ArrayNormalized = ((int)0X886a),
        ArraySize = ((int)0X8623),
        CurrentVertexAttrib = ((int)0X8626),
        ArrayStride = ((int)0X8624),
        ArrayType = ((int)0X8625),
    }

    public enum VertexAttribPointerParameter
    {
        ArrayPointer = ((int)0X8645),
    }

    public enum DrawBuffersEnum
    {
        FrontRight = ((int)0X0401),
        BackLeft = ((int)0X0402),
        BackRight = ((int)0X0403),
        Aux1 = ((int)0X040a),
        Aux0 = ((int)0X0409),
        Aux3 = ((int)0X040c),
        Aux2 = ((int)0X040b),
        FrontLeft = ((int)0X0400),
        None = ((int)0),
    }

    public enum PointSpriteCoordOriginParameter
    {
        UpperLeft = ((int)0X8ca2),
        LowerLeft = ((int)0X8ca1),
    }

    public enum TextureEnvModePointSprite
    {
        True = ((int)1),
        False = ((int)0),
    }

    public enum ArbMultitexture
    {
        Texture17Arb = ((int)0X84d1),
        MaxTextureUnitsArb = ((int)0X84e2),
        Texture29Arb = ((int)0X84dd),
        Texture1Arb = ((int)0X84c1),
        Texture2Arb = ((int)0X84c2),
        Texture26Arb = ((int)0X84da),
        Texture19Arb = ((int)0X84d3),
        Texture6Arb = ((int)0X84c6),
        ActiveTextureArb = ((int)0X84e0),
        Texture23Arb = ((int)0X84d7),
        Texture7Arb = ((int)0X84c7),
        Texture13Arb = ((int)0X84cd),
        Texture16Arb = ((int)0X84d0),
        Texture30Arb = ((int)0X84de),
        Texture28Arb = ((int)0X84dc),
        Texture25Arb = ((int)0X84d9),
        Texture4Arb = ((int)0X84c4),
        Texture15Arb = ((int)0X84cf),
        Texture18Arb = ((int)0X84d2),
        Texture3Arb = ((int)0X84c3),
        Texture22Arb = ((int)0X84d6),
        Texture0Arb = ((int)0X84c0),
        Texture12Arb = ((int)0X84cc),
        Texture21Arb = ((int)0X84d5),
        Texture24Arb = ((int)0X84d8),
        Texture11Arb = ((int)0X84cb),
        Texture14Arb = ((int)0X84ce),
        Texture8Arb = ((int)0X84c8),
        Texture20Arb = ((int)0X84d4),
        Texture31Arb = ((int)0X84df),
        ClientActiveTextureArb = ((int)0X84e1),
        Texture9Arb = ((int)0X84c9),
        Texture5Arb = ((int)0X84c5),
        Texture10Arb = ((int)0X84ca),
        Texture27Arb = ((int)0X84db),
    }

    public enum ArbTransposeMatrix
    {
        TransposeProjectionMatrixArb = ((int)0X84e4),
        TransposeTextureMatrixArb = ((int)0X84e5),
        TransposeModelviewMatrixArb = ((int)0X84e3),
        TransposeColorMatrixArb = ((int)0X84e6),
    }

    public enum ArbTextureEnvAdd
    {
    }

    public enum ArbTextureCubeMap
    {
        TextureCubeMapPositiveYArb = ((int)0X8517),
        ProxyTextureCubeMapArb = ((int)0X851b),
        TextureCubeMapPositiveZArb = ((int)0X8519),
        TextureCubeMapPositiveXArb = ((int)0X8515),
        TextureCubeMapNegativeYArb = ((int)0X8518),
        TextureBindingCubeMapArb = ((int)0X8514),
        TextureCubeMapArb = ((int)0X8513),
        MaxCubeMapTextureSizeArb = ((int)0X851c),
        TextureCubeMapNegativeZArb = ((int)0X851a),
        TextureCubeMapNegativeXArb = ((int)0X8516),
        ReflectionMapArb = ((int)0X8512),
        NormalMapArb = ((int)0X8511),
    }

    public enum ArbTextureCompression
    {
        CompressedRgbArb = ((int)0X84ed),
        TextureCompressedArb = ((int)0X86a1),
        CompressedIntensityArb = ((int)0X84ec),
        CompressedTextureFormatsArb = ((int)0X86a3),
        NumCompressedTextureFormatsArb = ((int)0X86a2),
        CompressedAlphaArb = ((int)0X84e9),
        TextureCompressionHintArb = ((int)0X84ef),
        CompressedLuminanceAlphaArb = ((int)0X84eb),
        TextureCompressedImageSizeArb = ((int)0X86a0),
        CompressedRgbaArb = ((int)0X84ee),
        CompressedLuminanceArb = ((int)0X84ea),
    }

    public enum ArbTextureBorderClamp
    {
        ClampToBorderArb = ((int)0X812d),
    }

    public enum ArbPointParameters
    {
        PointSizeMinArb = ((int)0X8126),
        PointDistanceAttenuationArb = ((int)0X8129),
        PointSizeMaxArb = ((int)0X8127),
        PointFadeThresholdSizeArb = ((int)0X8128),
    }

    public enum ArbVertexBlend
    {
        Modelview26Arb = ((int)0X873a),
        WeightArrayTypeArb = ((int)0X86a9),
        Modelview23Arb = ((int)0X8737),
        Modelview1Arb = ((int)0X850a),
        WeightArrayStrideArb = ((int)0X86aa),
        WeightArrayArb = ((int)0X86ad),
        Modelview2Arb = ((int)0X8722),
        Modelview14Arb = ((int)0X872e),
        Modelview15Arb = ((int)0X872f),
        Modelview3Arb = ((int)0X8723),
        Modelview21Arb = ((int)0X8735),
        Modelview27Arb = ((int)0X873b),
        ActiveVertexUnitsArb = ((int)0X86a5),
        Modelview7Arb = ((int)0X8727),
        Modelview9Arb = ((int)0X8729),
        Modelview12Arb = ((int)0X872c),
        Modelview20Arb = ((int)0X8734),
        Modelview18Arb = ((int)0X8732),
        MaxVertexUnitsArb = ((int)0X86a4),
        Modelview19Arb = ((int)0X8733),
        Modelview25Arb = ((int)0X8739),
        Modelview31Arb = ((int)0X873f),
        Modelview4Arb = ((int)0X8724),
        WeightArraySizeArb = ((int)0X86ab),
        Modelview24Arb = ((int)0X8738),
        VertexBlendArb = ((int)0X86a7),
        Modelview30Arb = ((int)0X873e),
        Modelview6Arb = ((int)0X8726),
        Modelview13Arb = ((int)0X872d),
        WeightArrayPointerArb = ((int)0X86ac),
        Modelview29Arb = ((int)0X873d),
        Modelview0Arb = ((int)0X1700),
        Modelview22Arb = ((int)0X8736),
        Modelview8Arb = ((int)0X8728),
        CurrentWeightArb = ((int)0X86a8),
        Modelview28Arb = ((int)0X873c),
        WeightSumUnityArb = ((int)0X86a6),
        Modelview11Arb = ((int)0X872b),
        Modelview17Arb = ((int)0X8731),
        Modelview16Arb = ((int)0X8730),
        Modelview5Arb = ((int)0X8725),
        Modelview10Arb = ((int)0X872a),
    }

    public enum ArbMatrixPalette
    {
        MatrixIndexArrayArb = ((int)0X8844),
        MatrixIndexArraySizeArb = ((int)0X8846),
        MaxMatrixPaletteStackDepthArb = ((int)0X8841),
        MaxPaletteMatricesArb = ((int)0X8842),
        MatrixIndexArrayTypeArb = ((int)0X8847),
        MatrixIndexArrayStrideArb = ((int)0X8848),
        MatrixIndexArrayPointerArb = ((int)0X8849),
        MatrixPaletteArb = ((int)0X8840),
        CurrentPaletteMatrixArb = ((int)0X8843),
        CurrentMatrixIndexArb = ((int)0X8845),
    }

    public enum ArbTextureEnvCombine
    {
        CombineRgbArb = ((int)0X8571),
        Source2AlphaArb = ((int)0X858a),
        Operand2AlphaArb = ((int)0X859a),
        Source0AlphaArb = ((int)0X8588),
        Operand0RgbArb = ((int)0X8590),
        SubtractArb = ((int)0X84e7),
        AddSignedArb = ((int)0X8574),
        Source2RgbArb = ((int)0X8582),
        Operand1AlphaArb = ((int)0X8599),
        RgbScaleArb = ((int)0X8573),
        Operand0AlphaArb = ((int)0X8598),
        Source0RgbArb = ((int)0X8580),
        CombineArb = ((int)0X8570),
        PreviousArb = ((int)0X8578),
        InterpolateArb = ((int)0X8575),
        ConstantArb = ((int)0X8576),
        Operand1RgbArb = ((int)0X8591),
        Operand2RgbArb = ((int)0X8592),
        PrimaryColorArb = ((int)0X8577),
        CombineAlphaArb = ((int)0X8572),
        Source1RgbArb = ((int)0X8581),
        Source1AlphaArb = ((int)0X8589),
    }

    public enum ArbTextureEnvCrossbar
    {
    }

    public enum ArbTextureEnvDot3
    {
        Dot3RgbArb = ((int)0X86ae),
        Dot3RgbaArb = ((int)0X86af),
    }

    public enum ArbTextureMirroredRepeat
    {
        MirroredRepeatArb = ((int)0X8370),
    }

    public enum ArbDepthTexture
    {
        DepthComponent24Arb = ((int)0X81a6),
        TextureDepthSizeArb = ((int)0X884a),
        DepthTextureModeArb = ((int)0X884b),
        DepthComponent16Arb = ((int)0X81a5),
        DepthComponent32Arb = ((int)0X81a7),
    }

    public enum ArbShadow
    {
        TextureCompareModeArb = ((int)0X884c),
        TextureCompareFuncArb = ((int)0X884d),
        CompareRToTextureArb = ((int)0X884e),
    }

    public enum ArbShadowAmbient
    {
        TextureCompareFailValueArb = ((int)0X80bf),
    }

    public enum ArbWindowPos
    {
    }

    public enum ArbVertexProgram
    {
        TransposeCurrentMatrixArb = ((int)0X88b7),
        VertexProgramTwoSideArb = ((int)0X8643),
        CurrentMatrixStackDepthArb = ((int)0X8640),
        ProgramErrorPositionArb = ((int)0X864b),
        MaxVertexAttribsArb = ((int)0X8869),
        ProgramErrorStringArb = ((int)0X8874),
        MaxProgramMatrixStackDepthArb = ((int)0X862e),
        MaxProgramMatricesArb = ((int)0X862f),
        ColorSumArb = ((int)0X8458),
        CurrentMatrixArb = ((int)0X8641),
        VertexProgramPointSizeArb = ((int)0X8642),
        ProgramFormatAsciiArb = ((int)0X8875),
    }

    public enum AssemblyProgramTargetArb
    {
        VertexProgram = ((int)0X8620),
        GeometryProgramNv = ((int)0X8c26),
        FragmentProgram = ((int)0X8804),
    }

    public enum AssemblyProgramFormatArb
    {
        ProgramFormatAsciiArb = ((int)0X8875),
    }

    public enum AssemblyProgramParameterArb
    {
        MaxProgramAttribs = ((int)0X88ad),
        MaxProgramLocalParameters = ((int)0X88b4),
        ProgramAluInstructionsArb = ((int)0X8805),
        ProgramAttribs = ((int)0X88ac),
        ProgramTemporaries = ((int)0X88a4),
        MaxProgramNativeAddressRegisters = ((int)0X88b3),
        ProgramNativeAluInstructionsArb = ((int)0X8808),
        MaxProgramNativeTexInstructionsArb = ((int)0X880f),
        MaxProgramTexIndirectionsArb = ((int)0X880d),
        ProgramParameters = ((int)0X88a8),
        ProgramNativeTemporaries = ((int)0X88a6),
        MaxProgramNativeTexIndirectionsArb = ((int)0X8810),
        ProgramNativeAttribs = ((int)0X88ae),
        ProgramAddressRegisters = ((int)0X88b0),
        ProgramUnderNativeLimits = ((int)0X88b6),
        ProgramNativeInstructions = ((int)0X88a2),
        MaxProgramParameters = ((int)0X88a9),
        MaxProgramEnvParameters = ((int)0X88b5),
        ProgramFormat = ((int)0X8876),
        MaxProgramTexInstructionsArb = ((int)0X880c),
        MaxProgramInstructions = ((int)0X88a1),
        ProgramTexIndirectionsArb = ((int)0X8807),
        ProgramTexInstructionsArb = ((int)0X8806),
        ProgramNativeParameters = ((int)0X88aa),
        ProgramBinding = ((int)0X8677),
        MaxProgramNativeTemporaries = ((int)0X88a7),
        MaxProgramNativeAttribs = ((int)0X88af),
        MaxProgramAddressRegisters = ((int)0X88b1),
        MaxProgramNativeParameters = ((int)0X88ab),
        ProgramNativeTexInstructionsArb = ((int)0X8809),
        ProgramNativeAddressRegisters = ((int)0X88b2),
        MaxProgramTemporaries = ((int)0X88a5),
        ProgramLength = ((int)0X8627),
        MaxProgramAluInstructionsArb = ((int)0X880b),
        MaxProgramNativeAluInstructionsArb = ((int)0X880e),
        MaxProgramNativeInstructions = ((int)0X88a3),
        ProgramNativeTexIndirectionsArb = ((int)0X880a),
        ProgramInstruction = ((int)0X88a0),
    }

    public enum AssemblyProgramStringParameterArb
    {
        ProgramString = ((int)0X8628),
    }

    public enum MatrixModeArb
    {
        Matrix23 = ((int)0X88d7),
        Matrix26 = ((int)0X88da),
        Matrix16 = ((int)0X88d0),
        Texture = ((int)0X1702),
        Matrix20 = ((int)0X88d4),
        Matrix30 = ((int)0X88de),
        Matrix10 = ((int)0X88ca),
        Matrix25 = ((int)0X88d9),
        Matrix15 = ((int)0X88cf),
        Matrix21 = ((int)0X88d5),
        Matrix31 = ((int)0X88df),
        Matrix11 = ((int)0X88cb),
        Matrix14 = ((int)0X88ce),
        Matrix8 = ((int)0X88c8),
        Matrix9 = ((int)0X88c9),
        Projection = ((int)0X1701),
        Matrix2 = ((int)0X88c2),
        Matrix3 = ((int)0X88c3),
        Matrix0 = ((int)0X88c0),
        Matrix28 = ((int)0X88dc),
        Matrix6 = ((int)0X88c6),
        Matrix7 = ((int)0X88c7),
        Matrix4 = ((int)0X88c4),
        Matrix5 = ((int)0X88c5),
        Color = ((int)0X1800),
        Matrix27 = ((int)0X88db),
        Matrix17 = ((int)0X88d1),
        Matrix29 = ((int)0X88dd),
        Matrix19 = ((int)0X88d3),
        Matrix18 = ((int)0X88d2),
        Matrix13 = ((int)0X88cd),
        Matrix1 = ((int)0X88c1),
        Modelview = ((int)0X1700),
        Matrix24 = ((int)0X88d8),
        Matrix22 = ((int)0X88d6),
        Matrix12 = ((int)0X88cc),
    }

    public enum VertexAttribParameterArb
    {
        ArrayEnabled = ((int)0X8622),
        ArrayNormalized = ((int)0X886a),
        ArraySize = ((int)0X8623),
        CurrentVertexAttrib = ((int)0X8626),
        ArrayStride = ((int)0X8624),
        ArrayType = ((int)0X8625),
    }

    public enum VertexAttribPointerParameterArb
    {
        ArrayPointer = ((int)0X8645),
    }

    public enum VertexAttribPointerTypeArb
    {
        UnsignedByte = ((int)0X1401),
        Byte = ((int)0X1400),
        UnsignedInt = ((int)0X1405),
        Short = ((int)0X1402),
        Int = ((int)0X1404),
        Float = ((int)0X1406),
        Double = ((int)0X140a),
        UnsignedShort = ((int)0X1403),
    }

    public enum ArbFragmentProgram
    {
        MaxTextureImageUnitsArb = ((int)0X8872),
        MaxTextureCoordsArb = ((int)0X8871),
    }

    public enum BufferTargetArb
    {
        ArrayBuffer = ((int)0X8892),
        ElementArrayBuffer = ((int)0X8893),
    }

    public enum BufferUsageArb
    {
        StreamDraw = ((int)0X88e0),
        DynamicCopy = ((int)0X88ea),
        StaticDraw = ((int)0X88e4),
        StaticCopy = ((int)0X88e6),
        StaticRead = ((int)0X88e5),
        StreamCopy = ((int)0X88e2),
        DynamicDraw = ((int)0X88e8),
        DynamicRead = ((int)0X88e9),
        StreamRead = ((int)0X88e1),
    }

    public enum BufferAccessArb
    {
        WriteOnly = ((int)0X88b9),
        ReadWrite = ((int)0X88ba),
        ReadOnly = ((int)0X88b8),
    }

    public enum BufferParameterNameArb
    {
        BufferUsage = ((int)0X8765),
        BufferSize = ((int)0X8764),
        BufferAccess = ((int)0X88bb),
        BufferMapped = ((int)0X88bc),
    }

    public enum BufferPointerNameArb
    {
        BufferMapPointer = ((int)0X88bd),
    }

    public enum ArbVertexBufferObject
    {
        ElementArrayBufferBindingArb = ((int)0X8895),
        ArrayBufferBindingArb = ((int)0X8894),
        VertexArrayBufferBindingArb = ((int)0X8896),
        TextureCoordArrayBufferBindingArb = ((int)0X889a),
        ReadOnlyArb = ((int)0X88b8),
        DynamicDrawArb = ((int)0X88e8),
        BufferSizeArb = ((int)0X8764),
        SecondaryColorArrayBufferBindingArb = ((int)0X889c),
        BufferUsageArb = ((int)0X8765),
        BufferAccessArb = ((int)0X88bb),
        StreamDrawArb = ((int)0X88e0),
        DynamicCopyArb = ((int)0X88ea),
        WeightArrayBufferBindingArb = ((int)0X889e),
        EdgeFlagArrayBufferBindingArb = ((int)0X889b),
        VertexAttribArrayBufferBindingArb = ((int)0X889f),
        NormalArrayBufferBindingArb = ((int)0X8897),
        WriteOnlyArb = ((int)0X88b9),
        ColorArrayBufferBindingArb = ((int)0X8898),
        ArrayBufferArb = ((int)0X8892),
        BufferMapPointerArb = ((int)0X88bd),
        StaticDrawArb = ((int)0X88e4),
        ReadWriteArb = ((int)0X88ba),
        BufferMappedArb = ((int)0X88bc),
        StreamCopyArb = ((int)0X88e2),
        StaticReadArb = ((int)0X88e5),
        ElementArrayBufferArb = ((int)0X8893),
        StaticCopyArb = ((int)0X88e6),
        StreamReadArb = ((int)0X88e1),
        DynamicReadArb = ((int)0X88e9),
        IndexArrayBufferBindingArb = ((int)0X8899),
        FogCoordinateArrayBufferBindingArb = ((int)0X889d),
    }

    public enum ArbOcclusionQuery
    {
        SamplesPassedArb = ((int)0X8914),
        QueryResultArb = ((int)0X8866),
        QueryCounterBitsArb = ((int)0X8864),
        QueryResultAvailableArb = ((int)0X8867),
        CurrentQueryArb = ((int)0X8865),
    }

    public enum ArbShaderObjects
    {
        IntVec2Arb = ((int)0X8b53),
        IntVec4Arb = ((int)0X8b55),
        FloatVec2Arb = ((int)0X8b50),
        IntVec3Arb = ((int)0X8b54),
        ObjectInfoLogLengthArb = ((int)0X8b84),
        Sampler3DArb = ((int)0X8b5f),
        ObjectTypeArb = ((int)0X8b4e),
        ProgramObjectArb = ((int)0X8b40),
        ObjectActiveUniformMaxLengthArb = ((int)0X8b87),
        SamplerCubeArb = ((int)0X8b60),
        Sampler2DArb = ((int)0X8b5e),
        Sampler1DShadowArb = ((int)0X8b61),
        ObjectLinkStatusArb = ((int)0X8b82),
        Sampler1DArb = ((int)0X8b5d),
        BoolVec4Arb = ((int)0X8b59),
        ObjectDeleteStatusArb = ((int)0X8b80),
        FloatVec4Arb = ((int)0X8b52),
        ObjectShaderSourceLengthArb = ((int)0X8b88),
        BoolVec3Arb = ((int)0X8b58),
        ObjectAttachedObjectsArb = ((int)0X8b85),
        FloatVec3Arb = ((int)0X8b51),
        BoolVec2Arb = ((int)0X8b57),
        FloatMat2Arb = ((int)0X8b5a),
        Sampler2DRectShadowArb = ((int)0X8b64),
        ObjectValidateStatusArb = ((int)0X8b83),
        Sampler2DRectArb = ((int)0X8b63),
        FloatMat4Arb = ((int)0X8b5c),
        Sampler2DShadowArb = ((int)0X8b62),
        ShaderObjectArb = ((int)0X8b48),
        ObjectActiveUniformsArb = ((int)0X8b86),
        FloatMat3Arb = ((int)0X8b5b),
        BoolArb = ((int)0X8b56),
        ObjectSubtypeArb = ((int)0X8b4f),
        ObjectCompileStatusArb = ((int)0X8b81),
    }

    public enum ArbVertexShader
    {
        MaxVertexUniformComponentsArb = ((int)0X8b4a),
        ObjectActiveAttributesArb = ((int)0X8b89),
        MaxVertexTextureImageUnitsArb = ((int)0X8b4c),
        MaxVaryingFloatsArb = ((int)0X8b4b),
        MaxCombinedTextureImageUnitsArb = ((int)0X8b4d),
        ObjectActiveAttributeMaxLengthArb = ((int)0X8b8a),
        VertexShaderArb = ((int)0X8b31),
    }

    public enum ArbFragmentShader
    {
        MaxFragmentUniformComponentsArb = ((int)0X8b49),
        FragmentShaderArb = ((int)0X8b30),
        FragmentShaderDerivativeHintArb = ((int)0X8b8b),
    }

    public enum ArbShadingLanguage100
    {
        ShadingLanguageVersionArb = ((int)0X8b8c),
    }

    public enum ArbTextureNonPowerOfTwo
    {
    }

    public enum ArbPointSprite
    {
        CoordReplaceArb = ((int)0X8862),
        PointSpriteArb = ((int)0X8861),
    }

    public enum ArbFragmentProgramShadow
    {
    }

    public enum ArbDrawBuffers
    {
        DrawBuffer9Arb = ((int)0X882e),
        DrawBuffer12Arb = ((int)0X8831),
        DrawBuffer3Arb = ((int)0X8828),
        MaxDrawBuffersArb = ((int)0X8824),
        DrawBuffer7Arb = ((int)0X882c),
        DrawBuffer2Arb = ((int)0X8827),
        DrawBuffer0Arb = ((int)0X8825),
        DrawBuffer14Arb = ((int)0X8833),
        DrawBuffer6Arb = ((int)0X882b),
        DrawBuffer4Arb = ((int)0X8829),
        DrawBuffer8Arb = ((int)0X882d),
        DrawBuffer13Arb = ((int)0X8832),
        DrawBuffer1Arb = ((int)0X8826),
        DrawBuffer11Arb = ((int)0X8830),
        DrawBuffer10Arb = ((int)0X882f),
        DrawBuffer15Arb = ((int)0X8834),
        DrawBuffer5Arb = ((int)0X882a),
    }

    public enum ArbTextureRectangle
    {
        TextureBindingRectangleArb = ((int)0X84f6),
        MaxRectangleTextureSizeArb = ((int)0X84f8),
        ProxyTextureRectangleArb = ((int)0X84f7),
        TextureRectangleArb = ((int)0X84f5),
    }

    public enum ArbColorBufferFloat
    {
        ClampReadColorArb = ((int)0X891c),
        FixedOnlyArb = ((int)0X891d),
        RgbaFloatModeArb = ((int)0X8820),
        ClampFragmentColorArb = ((int)0X891b),
        ClampVertexColorArb = ((int)0X891a),
    }

    public enum ArbHalfFloatPixel
    {
        HalfFloatArb = ((int)0X140b),
    }

    public enum ArbTextureFloat
    {
        UnsignedNormalizedArb = ((int)0X8c17),
        Intensity16fArb = ((int)0X881d),
        LuminanceAlpha32fArb = ((int)0X8819),
        TextureAlphaTypeArb = ((int)0X8c13),
        LuminanceAlpha16fArb = ((int)0X881f),
        TextureDepthTypeArb = ((int)0X8c16),
        TextureGreenTypeArb = ((int)0X8c11),
        Rgb16fArb = ((int)0X881b),
        TextureBlueTypeArb = ((int)0X8c12),
        Rgba16fArb = ((int)0X881a),
        Rgba32fArb = ((int)0X8814),
        Intensity32fArb = ((int)0X8817),
        Luminance16fArb = ((int)0X881e),
        Alpha16fArb = ((int)0X881c),
        Luminance32fArb = ((int)0X8818),
        TextureRedTypeArb = ((int)0X8c10),
        Alpha32fArb = ((int)0X8816),
        Rgb32fArb = ((int)0X8815),
        TextureLuminanceTypeArb = ((int)0X8c14),
        TextureIntensityTypeArb = ((int)0X8c15),
    }

    public enum ArbPixelBufferObject
    {
        PixelUnpackBufferBindingArb = ((int)0X88ef),
        PixelPackBufferArb = ((int)0X88eb),
        PixelUnpackBufferArb = ((int)0X88ec),
        PixelPackBufferBindingArb = ((int)0X88ed),
    }

    public enum ExtSubtexture
    {
    }

    public enum ExtCopyTexture
    {
    }

    public enum ExtMiscAttribute
    {
    }

    public enum ExtBlendLogicOp
    {
    }

    public enum ExtPointParameters
    {
        PointFadeThresholdSizeExt = ((int)0X8128),
        DistanceAttenuationExt = ((int)0X8129),
        PointSizeMaxExt = ((int)0X8127),
        PointSizeMinExt = ((int)0X8126),
    }

    public enum SgixTagSampleBuffer
    {
    }

    public enum SgixPolynomialFfd
    {
        DeformationsMaskSgix = ((int)0X8196),
        TextureDeformationSgix = ((int)0X8195),
        MaxDeformationOrderSgix = ((int)0X8197),
        GeometryDeformationSgix = ((int)0X8194),
    }

    public enum SgixFlushRaster
    {
    }

    public enum HpImageTransform
    {
        ImageTranslateXHp = ((int)0X8157),
        ImageRotateAngleHp = ((int)0X8159),
        CubicHp = ((int)0X815f),
        ImageRotateOriginYHp = ((int)0X815b),
        ImageTranslateYHp = ((int)0X8158),
        ImageScaleYHp = ((int)0X8156),
        ImageCubicWeightHp = ((int)0X815e),
        PostImageTransformColorTableHp = ((int)0X8162),
        ImageMinFilterHp = ((int)0X815d),
        AverageHp = ((int)0X8160),
        ImageMagFilterHp = ((int)0X815c),
        ProxyPostImageTransformColorTableHp = ((int)0X8163),
        ImageScaleXHp = ((int)0X8155),
        ImageTransform2DHp = ((int)0X8161),
        ImageRotateOriginXHp = ((int)0X815a),
    }

    public enum IngrPaletteBuffer
    {
    }

    public enum ExtColorSubtable
    {
    }

    public enum PgiVertexHints
    {
        MaxVertexHintPgi = ((int)0X1a22d),
        VertexDataHintPgi = ((int)0X1a22a),
        Texcoord2BitPgi = ((int)0X20000000),
        Color4BitPgi = ((int)0X00020000),
        Vertex23BitPgi = ((int)0X00000004),
        EdgeflagBitPgi = ((int)0X00040000),
        MatShininessBitPgi = ((int)0X02000000),
        Color3BitPgi = ((int)0X00010000),
        IndexBitPgi = ((int)0X00080000),
        Texcoord3BitPgi = ((int)0X40000000),
        MaterialSideHintPgi = ((int)0X1a22c),
        MatAmbientAndDiffuseBitPgi = ((int)0X00200000),
        Texcoord1BitPgi = ((int)0X10000000),
        MatEmissionBitPgi = ((int)0X00800000),
        MatDiffuseBitPgi = ((int)0X00400000),
        VertexConsistentHintPgi = ((int)0X1a22b),
        MatColorIndexesBitPgi = ((int)0X01000000),
        NormalBitPgi = ((int)0X08000000),
        Vertex4BitPgi = ((int)0X00000008),
        Texcoord4BitPgi = unchecked((int)0X80000000),
        MatAmbientBitPgi = ((int)0X00100000),
        MatSpecularBitPgi = ((int)0X04000000),
    }

    public enum PgiMiscHints
    {
        ClipNearHintPgi = ((int)0X1a220),
        AllowDrawWinHintPgi = ((int)0X1a20f),
        BackNormalsHintPgi = ((int)0X1a223),
        StrictDepthfuncHintPgi = ((int)0X1a216),
        NativeGraphicsHandlePgi = ((int)0X1a202),
        StrictLightingHintPgi = ((int)0X1a217),
        StrictScissorHintPgi = ((int)0X1a218),
        AlwaysFastHintPgi = ((int)0X1a20c),
        ConserveMemoryHintPgi = ((int)0X1a1fd),
        PreferDoublebufferHintPgi = ((int)0X1a1f8),
        WideLineHintPgi = ((int)0X1a222),
        ClipFarHintPgi = ((int)0X1a221),
        AllowDrawFrgHintPgi = ((int)0X1a210),
        AlwaysSoftHintPgi = ((int)0X1a20d),
        AllowDrawObjHintPgi = ((int)0X1a20e),
        AllowDrawMemHintPgi = ((int)0X1a211),
        FullStippleHintPgi = ((int)0X1a219),
        NativeGraphicsBeginHintPgi = ((int)0X1a203),
        ReclaimMemoryHintPgi = ((int)0X1a1fe),
        NativeGraphicsEndHintPgi = ((int)0X1a204),
    }

    public enum ExtPalettedTexture
    {
        ColorIndex1Ext = ((int)0X80e2),
        ColorIndex8Ext = ((int)0X80e5),
        ColorIndex2Ext = ((int)0X80e3),
        ColorIndex16Ext = ((int)0X80e7),
        ColorIndex4Ext = ((int)0X80e4),
        TextureIndexSizeExt = ((int)0X80ed),
        ColorIndex12Ext = ((int)0X80e6),
    }

    public enum ExtClipVolumeHint
    {
        ClipVolumeClippingHintExt = ((int)0X80f0),
    }

    public enum ExtIndexTexture
    {
    }

    public enum ExtIndexMaterial
    {
        IndexMaterialExt = ((int)0X81b8),
        IndexMaterialFaceExt = ((int)0X81ba),
        IndexMaterialParameterExt = ((int)0X81b9),
    }

    public enum ExtIndexFunc
    {
        IndexTestRefExt = ((int)0X81b7),
        IndexTestFuncExt = ((int)0X81b6),
        IndexTestExt = ((int)0X81b5),
    }

    public enum ExtIndexArrayFormats
    {
        T2fIuiN3fV2fExt = ((int)0X81b3),
        T2fIuiN3fV3fExt = ((int)0X81b4),
        T2fIuiV2fExt = ((int)0X81b1),
        T2fIuiV3fExt = ((int)0X81b2),
        IuiV3fExt = ((int)0X81ae),
        IuiN3fV3fExt = ((int)0X81b0),
        IuiN3fV2fExt = ((int)0X81af),
        IuiV2fExt = ((int)0X81ad),
    }

    public enum ExtCompiledVertexArray
    {
        ArrayElementLockCountExt = ((int)0X81a9),
        ArrayElementLockFirstExt = ((int)0X81a8),
    }

    public enum ExtCullVertex
    {
        CullVertexObjectPositionExt = ((int)0X81ac),
        CullVertexExt = ((int)0X81aa),
        CullVertexEyePositionExt = ((int)0X81ab),
    }

    public enum IbmRasterposClip
    {
        RasterPositionUnclippedIbm = ((int)0X19262),
    }

    public enum HpTextureLighting
    {
        TextureLightingModeHp = ((int)0X8167),
        TexturePreSpecularHp = ((int)0X8169),
        TexturePostSpecularHp = ((int)0X8168),
    }

    public enum ExtDrawRangeElements
    {
        MaxElementsVerticesExt = ((int)0X80e8),
        MaxElementsIndicesExt = ((int)0X80e9),
    }

    public enum WinPhongShading
    {
        PhongHintWin = ((int)0X80eb),
        PhongWin = ((int)0X80ea),
    }

    public enum WinSpecularFog
    {
        FogSpecularTextureWin = ((int)0X80ec),
    }

    public enum ExtLightTexture
    {
        ShadowAttenuationExt = ((int)0X834e),
        FragmentDepthExt = ((int)0X8452),
        TextureLightExt = ((int)0X8350),
        AttenuationExt = ((int)0X834d),
        TextureMaterialParameterExt = ((int)0X8352),
        FragmentMaterialExt = ((int)0X8349),
        FragmentNormalExt = ((int)0X834a),
        TextureMaterialFaceExt = ((int)0X8351),
        TextureApplicationModeExt = ((int)0X834f),
        FragmentColorExt = ((int)0X834c),
    }

    public enum SgixAsync
    {
        AsyncMarkerSgix = ((int)0X8329),
    }

    public enum IntelTextureScissor
    {
    }

    public enum HpOcclusionTest
    {
        OcclusionTestResultHp = ((int)0X8166),
        OcclusionTestHp = ((int)0X8165),
    }

    public enum ExtPixelTransformColorTable
    {
    }

    public enum ExtSecondaryColor
    {
        SecondaryColorArrayPointerExt = ((int)0X845d),
        ColorSumExt = ((int)0X8458),
        SecondaryColorArraySizeExt = ((int)0X845a),
        CurrentSecondaryColorExt = ((int)0X8459),
        SecondaryColorArrayTypeExt = ((int)0X845b),
        SecondaryColorArrayExt = ((int)0X845e),
        SecondaryColorArrayStrideExt = ((int)0X845c),
    }

    public enum ExtTexturePerturbNormal
    {
        PerturbExt = ((int)0X85ae),
        TextureNormalExt = ((int)0X85af),
    }

    public enum ExtMultiDrawArrays
    {
    }

    public enum ExtFogCoord
    {
        FragmentDepthExt = ((int)0X8452),
        CurrentFogCoordinateExt = ((int)0X8453),
        FogCoordinateArrayStrideExt = ((int)0X8455),
        FogCoordinateArrayPointerExt = ((int)0X8456),
        FogCoordinateArrayExt = ((int)0X8457),
        FogCoordinateExt = ((int)0X8451),
        FogCoordinateArrayTypeExt = ((int)0X8454),
        FogCoordinateSourceExt = ((int)0X8450),
    }

    public enum RendScreenCoordinates
    {
        InvertedScreenWRend = ((int)0X8491),
        ScreenCoordinatesRend = ((int)0X8490),
    }

    public enum ExtCoordinateFrame
    {
        TangentArrayTypeExt = ((int)0X843e),
        BinormalArrayTypeExt = ((int)0X8440),
        Map1TangentExt = ((int)0X8444),
        CurrentTangentExt = ((int)0X843b),
        Map2BinormalExt = ((int)0X8447),
        CurrentBinormalExt = ((int)0X843c),
        TangentArrayPointerExt = ((int)0X8442),
        Map1BinormalExt = ((int)0X8446),
        BinormalArrayPointerExt = ((int)0X8443),
        BinormalArrayExt = ((int)0X843a),
        Map2TangentExt = ((int)0X8445),
        TangentArrayExt = ((int)0X8439),
        BinormalArrayStrideExt = ((int)0X8441),
        TangentArrayStrideExt = ((int)0X843f),
    }

    public enum ExtTextureEnvCombine
    {
        Operand2AlphaExt = ((int)0X859a),
        CombineRgbExt = ((int)0X8571),
        Source1AlphaExt = ((int)0X8589),
        Operand1RgbExt = ((int)0X8591),
        PreviousExt = ((int)0X8578),
        Operand1AlphaExt = ((int)0X8599),
        AddSignedExt = ((int)0X8574),
        ConstantExt = ((int)0X8576),
        RgbScaleExt = ((int)0X8573),
        Source0AlphaExt = ((int)0X8588),
        InterpolateExt = ((int)0X8575),
        Source2RgbExt = ((int)0X8582),
        PrimaryColorExt = ((int)0X8577),
        CombineExt = ((int)0X8570),
        Source0RgbExt = ((int)0X8580),
        Source1RgbExt = ((int)0X8581),
        Operand0AlphaExt = ((int)0X8598),
        Operand2RgbExt = ((int)0X8592),
        CombineAlphaExt = ((int)0X8572),
        Source2AlphaExt = ((int)0X858a),
        Operand0RgbExt = ((int)0X8590),
    }

    public enum AppleSpecularVector
    {
        LightModelSpecularVectorApple = ((int)0X85b0),
    }

    public enum AppleTransformHint
    {
        TransformHintApple = ((int)0X85b1),
    }

    public enum SgixFogScale
    {
        FogScaleSgix = ((int)0X81fc),
        FogScaleValueSgix = ((int)0X81fd),
    }

    public enum SunxConstantData
    {
        UnpackConstantDataSunx = ((int)0X81d5),
        TextureConstantDataSunx = ((int)0X81d6),
    }

    public enum SunGlobalAlpha
    {
        GlobalAlphaFactorSun = ((int)0X81da),
        GlobalAlphaSun = ((int)0X81d9),
    }

    public enum SunTriangleList
    {
        R1uiC4ubV3fSun = ((int)0X85c5),
        ReplaceMiddleSun = ((int)0X0002),
        ReplacementCodeArrayStrideSun = ((int)0X85c2),
        RestartSun = ((int)0X0001),
        ReplaceOldestSun = ((int)0X0003),
        ReplacementCodeArrayTypeSun = ((int)0X85c1),
        R1uiN3fV3fSun = ((int)0X85c7),
        R1uiT2fV3fSun = ((int)0X85c9),
        R1uiT2fN3fV3fSun = ((int)0X85ca),
        R1uiV3fSun = ((int)0X85c4),
        ReplacementCodeSun = ((int)0X81d8),
        TriangleListSun = ((int)0X81d7),
        R1uiT2fC4fN3fV3fSun = ((int)0X85cb),
        ReplacementCodeArraySun = ((int)0X85c0),
        R1uiC3fV3fSun = ((int)0X85c6),
        R1uiC4fN3fV3fSun = ((int)0X85c8),
        ReplacementCodeArrayPointerSun = ((int)0X85c3),
    }

    public enum SunVertex
    {
    }

    public enum ExtBlendFuncSeparate
    {
        BlendSrcRgbExt = ((int)0X80c9),
        BlendDstAlphaExt = ((int)0X80ca),
        BlendSrcAlphaExt = ((int)0X80cb),
        BlendDstRgbExt = ((int)0X80c8),
    }

    public enum IngrColorClamp
    {
        BlueMaxClampIngr = ((int)0X8566),
        RedMinClampIngr = ((int)0X8560),
        AlphaMinClampIngr = ((int)0X8563),
        AlphaMaxClampIngr = ((int)0X8567),
        GreenMaxClampIngr = ((int)0X8565),
        BlueMinClampIngr = ((int)0X8562),
        GreenMinClampIngr = ((int)0X8561),
        RedMaxClampIngr = ((int)0X8564),
    }

    public enum IngrInterlaceRead
    {
        InterlaceReadIngr = ((int)0X8568),
    }

    public enum ExtStencilWrap
    {
        DecrWrapExt = ((int)0X8508),
        IncrWrapExt = ((int)0X8507),
    }

    public enum Ext422Pixels
    {
        Gl422RevAverageExt = ((int)0X80cf),
        Gl422RevExt = ((int)0X80cd),
        Gl422AverageExt = ((int)0X80ce),
        Gl422Ext = ((int)0X80cc),
    }

    public enum NvTexgenReflection
    {
        ReflectionMapNv = ((int)0X8512),
        NormalMapNv = ((int)0X8511),
    }

    public enum ExtTextureCubeMap
    {
        TextureCubeMapExt = ((int)0X8513),
        ProxyTextureCubeMapExt = ((int)0X851b),
        TextureCubeMapNegativeZExt = ((int)0X851a),
        TextureCubeMapPositiveZExt = ((int)0X8519),
        TextureCubeMapPositiveYExt = ((int)0X8517),
        TextureBindingCubeMapExt = ((int)0X8514),
        NormalMapExt = ((int)0X8511),
        MaxCubeMapTextureSizeExt = ((int)0X851c),
        TextureCubeMapPositiveXExt = ((int)0X8515),
        ReflectionMapExt = ((int)0X8512),
        TextureCubeMapNegativeXExt = ((int)0X8516),
        TextureCubeMapNegativeYExt = ((int)0X8518),
    }

    public enum SunConvolutionBorderModes
    {
        WrapBorderSun = ((int)0X81d4),
    }

    public enum ExtTextureEnvAdd
    {
    }

    public enum ExtTextureLodBias
    {
        TextureLodBiasExt = ((int)0X8501),
        MaxTextureLodBiasExt = ((int)0X84fd),
        TextureFilterControlExt = ((int)0X8500),
    }

    public enum ExtTextureFilterAnisotropic
    {
        TextureMaxAnisotropyExt = ((int)0X84fe),
        MaxTextureMaxAnisotropyExt = ((int)0X84ff),
    }

    public enum ExtVertexWeighting
    {
        Modelview1StackDepthExt = ((int)0X8502),
        VertexWeightArraySizeExt = ((int)0X850d),
        Modelview0MatrixExt = ((int)0X0ba6),
        VertexWeightingExt = ((int)0X8509),
        VertexWeightArrayPointerExt = ((int)0X8510),
        Modelview1MatrixExt = ((int)0X8506),
        VertexWeightArrayTypeExt = ((int)0X850e),
        Modelview0StackDepthExt = ((int)0X0ba3),
        VertexWeightArrayStrideExt = ((int)0X850f),
        Modelview0Ext = ((int)0X1700),
        Modelview1Ext = ((int)0X850a),
        CurrentVertexWeightExt = ((int)0X850b),
        VertexWeightArrayExt = ((int)0X850c),
    }

    public enum NvLightMaxExponent
    {
        MaxSpotExponentNv = ((int)0X8505),
        MaxShininessNv = ((int)0X8504),
    }

    public enum NvVertexArrayRange
    {
        VertexArrayRangeNv = ((int)0X851d),
        VertexArrayRangeValidNv = ((int)0X851f),
        VertexArrayRangeLengthNv = ((int)0X851e),
        MaxVertexArrayRangeElementNv = ((int)0X8520),
        VertexArrayRangePointerNv = ((int)0X8521),
    }

    public enum NvRegisterCombiners
    {
        VariableDNv = ((int)0X8526),
        ETimesFNv = ((int)0X8531),
        CombinerMappingNv = ((int)0X8543),
        CombinerCdOutputNv = ((int)0X854b),
        Combiner7Nv = ((int)0X8557),
        Combiner4Nv = ((int)0X8554),
        Texture1Arb = ((int)0X84c1),
        HalfBiasNegateNv = ((int)0X853b),
        VariableANv = ((int)0X8523),
        CombinerComponentUsageNv = ((int)0X8544),
        CombinerSumOutputNv = ((int)0X854c),
        ScaleByFourNv = ((int)0X853f),
        ScaleByTwoNv = ((int)0X853e),
        CombinerBiasNv = ((int)0X8549),
        SignedNegateNv = ((int)0X853d),
        VariableENv = ((int)0X8527),
        BiasByNegativeOneHalfNv = ((int)0X8541),
        CombinerInputNv = ((int)0X8542),
        UnsignedInvertNv = ((int)0X8537),
        SignedIdentityNv = ((int)0X853c),
        SecondaryColorNv = ((int)0X852d),
        Combiner3Nv = ((int)0X8553),
        Spare0Nv = ((int)0X852e),
        CombinerAbDotProductNv = ((int)0X8545),
        None = ((int)0),
        VariableBNv = ((int)0X8524),
        CombinerAbOutputNv = ((int)0X854a),
        Spare1Nv = ((int)0X852f),
        Combiner2Nv = ((int)0X8552),
        ConstantColor0Nv = ((int)0X852a),
        Texture0Arb = ((int)0X84c0),
        Combiner6Nv = ((int)0X8556),
        DiscardNv = ((int)0X8530),
        VariableFNv = ((int)0X8528),
        ExpandNegateNv = ((int)0X8539),
        Combiner1Nv = ((int)0X8551),
        MaxGeneralCombinersNv = ((int)0X854d),
        ColorSumClampNv = ((int)0X854f),
        ScaleByOneHalfNv = ((int)0X8540),
        CombinerMuxSumNv = ((int)0X8547),
        CombinerScaleNv = ((int)0X8548),
        VariableCNv = ((int)0X8525),
        NumGeneralCombinersNv = ((int)0X854e),
        Fog = ((int)0X0b60),
        Combiner5Nv = ((int)0X8555),
        RegisterCombinersNv = ((int)0X8522),
        ConstantColor1Nv = ((int)0X852b),
        HalfBiasNormalNv = ((int)0X853a),
        Zero = ((int)0),
        UnsignedIdentityNv = ((int)0X8536),
        Spare0PlusSecondaryColorNv = ((int)0X8532),
        VariableGNv = ((int)0X8529),
        PrimaryColorNv = ((int)0X852c),
        Combiner0Nv = ((int)0X8550),
        CombinerCdDotProductNv = ((int)0X8546),
        ExpandNormalNv = ((int)0X8538),
    }

    public enum NvFogDistance
    {
        EyeRadialNv = ((int)0X855b),
        EyePlane = ((int)0X2502),
        EyePlaneAbsoluteNv = ((int)0X855c),
        FogDistanceModeNv = ((int)0X855a),
    }

    public enum NvTexgenEmboss
    {
        EmbossConstantNv = ((int)0X855e),
        EmbossMapNv = ((int)0X855f),
        EmbossLightNv = ((int)0X855d),
    }

    public enum NvBlendSquare
    {
    }

    public enum NvTextureEnvCombine4
    {
        Operand3RgbNv = ((int)0X8593),
        Combine4Nv = ((int)0X8503),
        Source3AlphaNv = ((int)0X858b),
        Source3RgbNv = ((int)0X8583),
        Operand3AlphaNv = ((int)0X859b),
    }

    public enum MesaResizeBuffers
    {
    }

    public enum MesaWindowPos
    {
    }

    public enum IbmCullVertex
    {
        CullVertexIbm = ((int)103050),
    }

    public enum IbmMultimodeDrawArrays
    {
    }

    public enum IbmVertexArrayLists
    {
        TextureCoordArrayListStrideIbm = ((int)103084),
        NormalArrayListStrideIbm = ((int)103081),
        ColorArrayListStrideIbm = ((int)103082),
        SecondaryColorArrayListStrideIbm = ((int)103087),
        VertexArrayListIbm = ((int)103070),
        IndexArrayListIbm = ((int)103073),
        NormalArrayListIbm = ((int)103071),
        SecondaryColorArrayListIbm = ((int)103077),
        FogCoordinateArrayListStrideIbm = ((int)103086),
        VertexArrayListStrideIbm = ((int)103080),
        TextureCoordArrayListIbm = ((int)103074),
        ColorArrayListIbm = ((int)103072),
        EdgeFlagArrayListStrideIbm = ((int)103085),
        FogCoordinateArrayListIbm = ((int)103076),
        IndexArrayListStrideIbm = ((int)103083),
        EdgeFlagArrayListIbm = ((int)103075),
    }

    public enum SgixYcrcbSubsample
    {
        PixelSubsample2424Sgix = ((int)0X85a3),
        UnpackSubsampleRateSgix = ((int)0X85a1),
        PackSubsampleRateSgix = ((int)0X85a0),
        PixelSubsample4242Sgix = ((int)0X85a4),
        PixelSubsample4444Sgix = ((int)0X85a2),
    }

    public enum SgixYcrcba
    {
        YcrcbaSgix = ((int)0X8319),
        YcrcbSgix = ((int)0X8318),
    }

    public enum SgiDepthPassInstrument
    {
        DepthPassInstrumentCountersSgix = ((int)0X8311),
        DepthPassInstrumentSgix = ((int)0X8310),
        DepthPassInstrumentMaxSgix = ((int)0X8312),
    }

    public enum Gl3DfxTextureCompressionFxt1
    {
        CompressedRgbaFxt13Dfx = ((int)0X86b1),
        CompressedRgbFxt13Dfx = ((int)0X86b0),
    }

    public enum Gl3DfxMultisample
    {
        MultisampleBit3Dfx = ((int)0X20000000),
        Samples3Dfx = ((int)0X86b4),
        SampleBuffers3Dfx = ((int)0X86b3),
        Multisample3Dfx = ((int)0X86b2),
    }

    public enum Gl3DfxTbuffer
    {
    }

    public enum ExtMultisample
    {
        Gl4Pass0Ext = ((int)0X80a4),
        MultisampleExt = ((int)0X809d),
        Gl1PassExt = ((int)0X80a1),
        MultisampleBitExt = ((int)0X20000000),
        Gl2Pass0Ext = ((int)0X80a2),
        SamplesExt = ((int)0X80a9),
        SamplePatternExt = ((int)0X80ac),
        SampleMaskValueExt = ((int)0X80aa),
        SampleAlphaToMaskExt = ((int)0X809e),
        SampleMaskInvertExt = ((int)0X80ab),
        Gl4Pass2Ext = ((int)0X80a6),
        Gl4Pass1Ext = ((int)0X80a5),
        Gl4Pass3Ext = ((int)0X80a7),
        SampleMaskExt = ((int)0X80a0),
        Gl2Pass1Ext = ((int)0X80a3),
        SampleBuffersExt = ((int)0X80a8),
        SampleAlphaToOneExt = ((int)0X809f),
    }

    public enum ExtTextureEnvDot3
    {
        Dot3RgbExt = ((int)0X8740),
        Dot3RgbaExt = ((int)0X8741),
    }

    public enum AtiTextureMirrorOnce
    {
        MirrorClampToEdgeAti = ((int)0X8743),
        MirrorClampAti = ((int)0X8742),
    }

    public enum NvFence
    {
        FenceStatusNv = ((int)0X84f3),
        AllCompletedNv = ((int)0X84f2),
        FenceConditionNv = ((int)0X84f4),
    }

    public enum IbmTextureMirroredRepeat
    {
        MirroredRepeatIbm = ((int)0X8370),
    }

    public enum NvEvaluators
    {
        EvalFractionalTessellationNv = ((int)0X86c5),
        EvalTriangular2DNv = ((int)0X86c1),
        EvalVertexAttrib14Nv = ((int)0X86d4),
        MaxMapTessellationNv = ((int)0X86d6),
        EvalVertexAttrib2Nv = ((int)0X86c8),
        EvalVertexAttrib0Nv = ((int)0X86c6),
        EvalVertexAttrib11Nv = ((int)0X86d1),
        EvalVertexAttrib15Nv = ((int)0X86d5),
        MapAttribVOrderNv = ((int)0X86c4),
        EvalVertexAttrib3Nv = ((int)0X86c9),
        EvalVertexAttrib10Nv = ((int)0X86d0),
        EvalVertexAttrib7Nv = ((int)0X86cd),
        EvalVertexAttrib9Nv = ((int)0X86cf),
        EvalVertexAttrib5Nv = ((int)0X86cb),
        MaxRationalEvalOrderNv = ((int)0X86d7),
        MapTessellationNv = ((int)0X86c2),
        Eval2DNv = ((int)0X86c0),
        EvalVertexAttrib6Nv = ((int)0X86cc),
        EvalVertexAttrib8Nv = ((int)0X86ce),
        EvalVertexAttrib4Nv = ((int)0X86ca),
        EvalVertexAttrib1Nv = ((int)0X86c7),
        MapAttribUOrderNv = ((int)0X86c3),
        EvalVertexAttrib12Nv = ((int)0X86d2),
        EvalVertexAttrib13Nv = ((int)0X86d3),
    }

    public enum NvPackedDepthStencil
    {
        DepthStencilNv = ((int)0X84f9),
        UnsignedInt248Nv = ((int)0X84fa),
    }

    public enum NvRegisterCombiners2
    {
        PerStageConstantsNv = ((int)0X8535),
    }

    public enum NvTextureCompressionVtc
    {
    }

    public enum NvTextureRectangle
    {
        ProxyTextureRectangleNv = ((int)0X84f7),
        TextureRectangleNv = ((int)0X84f5),
        MaxRectangleTextureSizeNv = ((int)0X84f8),
        TextureBindingRectangleNv = ((int)0X84f6),
    }

    public enum NvTextureShader
    {
        HiloNv = ((int)0X86f4),
        OffsetTexture2DMatrixNv = ((int)0X86e1),
        ShaderConsistentNv = ((int)0X86dd),
        OffsetTextureScaleNv = ((int)0X86e2),
        DotProductDiffuseCubeMapNv = ((int)0X86f1),
        SignedAlpha8Nv = ((int)0X8706),
        LoScaleNv = ((int)0X870f),
        SignedIntensity8Nv = ((int)0X8708),
        OffsetTextureRectangleScaleNv = ((int)0X864d),
        TextureShaderNv = ((int)0X86de),
        TextureHiSizeNv = ((int)0X871b),
        PassThroughNv = ((int)0X86e6),
        DependentArTexture2DNv = ((int)0X86e9),
        SignedAlphaNv = ((int)0X8705),
        VibranceBiasNv = ((int)0X8719),
        ConstEyeNv = ((int)0X86e5),
        UnsignedIntS8S888Nv = ((int)0X86da),
        LoBiasNv = ((int)0X8715),
        ShaderOperationNv = ((int)0X86df),
        SignedLuminanceAlphaNv = ((int)0X8703),
        VibranceScaleNv = ((int)0X8713),
        Dsdt8Nv = ((int)0X8709),
        SignedIntensityNv = ((int)0X8707),
        OffsetTexture2DNv = ((int)0X86e8),
        SignedLuminance8Alpha8Nv = ((int)0X8704),
        TextureBorderValuesNv = ((int)0X871a),
        SignedHilo16Nv = ((int)0X86fa),
        DsScaleNv = ((int)0X8710),
        SignedRgb8Nv = ((int)0X86ff),
        DotProductDepthReplaceNv = ((int)0X86ed),
        PreviousTextureInputNv = ((int)0X86e4),
        OffsetTextureRectangleNv = ((int)0X864c),
        DependentGbTexture2DNv = ((int)0X86ea),
        CullFragmentNv = ((int)0X86e7),
        DotProductTexture2DNv = ((int)0X86ee),
        OffsetTextureMatrixNv = ((int)0X86e1),
        RgbaUnsignedDotProductMappingNv = ((int)0X86d9),
        SignedRgbNv = ((int)0X86fe),
        HiBiasNv = ((int)0X8714),
        Dsdt8Mag8Intensity8Nv = ((int)0X870b),
        OffsetTexture2DScaleNv = ((int)0X86e2),
        CullModesNv = ((int)0X86e0),
        DotProductReflectCubeMapNv = ((int)0X86f2),
        SignedRgbaNv = ((int)0X86fb),
        TextureLoSizeNv = ((int)0X871c),
        DtBiasNv = ((int)0X8717),
        DsdtMagNv = ((int)0X86f6),
        Hilo16Nv = ((int)0X86f8),
        DotProductConstEyeReflectCubeMapNv = ((int)0X86f3),
        DsdtMagVibNv = ((int)0X86f7),
        SignedHiloNv = ((int)0X86f9),
        DotProductTextureCubeMapNv = ((int)0X86f0),
        Dsdt8Mag8Nv = ((int)0X870a),
        SignedRgbUnsignedAlphaNv = ((int)0X870c),
        DotProductTextureRectangleNv = ((int)0X864e),
        SignedRgb8UnsignedAlpha8Nv = ((int)0X870d),
        MagnitudeScaleNv = ((int)0X8712),
        MagnitudeBiasNv = ((int)0X8718),
        OffsetTextureBiasNv = ((int)0X86e3),
        SignedLuminance8Nv = ((int)0X8702),
        DtScaleNv = ((int)0X8711),
        SignedLuminanceNv = ((int)0X8701),
        DsdtNv = ((int)0X86f5),
        TextureDtSizeNv = ((int)0X871e),
        DotProductNv = ((int)0X86ec),
        HiScaleNv = ((int)0X870e),
        DsdtMagIntensityNv = ((int)0X86dc),
        OffsetTexture2DBiasNv = ((int)0X86e3),
        TextureDsSizeNv = ((int)0X871d),
        SignedRgba8Nv = ((int)0X86fc),
        TextureMagSizeNv = ((int)0X871f),
        UnsignedInt88S8S8RevNv = ((int)0X86db),
        DsBiasNv = ((int)0X8716),
    }

    public enum NvTextureShader2
    {
        DotProductTexture3DNv = ((int)0X86ef),
    }

    public enum NvVertexArrayRange2
    {
        VertexArrayRangeWithoutFlushNv = ((int)0X8533),
    }

    public enum NvVertexProgram
    {
        VertexProgramTwoSideNv = ((int)0X8643),
        AttribArraySizeNv = ((int)0X8623),
        VertexAttribArray8Nv = ((int)0X8658),
        VertexAttribArray10Nv = ((int)0X865a),
        Map2VertexAttrib54Nv = ((int)0X8675),
        Map1VertexAttrib54Nv = ((int)0X8665),
        VertexAttribArray13Nv = ((int)0X865d),
        Map2VertexAttrib64Nv = ((int)0X8676),
        TrackMatrixTransformNv = ((int)0X8649),
        ProgramResidentNv = ((int)0X8647),
        Map1VertexAttrib144Nv = ((int)0X866e),
        Matrix5Nv = ((int)0X8635),
        Map1VertexAttrib24Nv = ((int)0X8662),
        VertexAttribArray14Nv = ((int)0X865e),
        VertexAttribArray11Nv = ((int)0X865b),
        ProgramLengthNv = ((int)0X8627),
        VertexAttribArray7Nv = ((int)0X8657),
        Map2VertexAttrib34Nv = ((int)0X8673),
        VertexProgramPointSizeNv = ((int)0X8642),
        Matrix4Nv = ((int)0X8634),
        VertexAttribArray1Nv = ((int)0X8651),
        Map2VertexAttrib124Nv = ((int)0X867c),
        Map2VertexAttrib84Nv = ((int)0X8678),
        AttribArrayStrideNv = ((int)0X8624),
        VertexAttribArray5Nv = ((int)0X8655),
        ProgramParameterNv = ((int)0X8644),
        Map2VertexAttrib134Nv = ((int)0X867d),
        Matrix7Nv = ((int)0X8637),
        TransposeNv = ((int)0X862c),
        VertexProgramBindingNv = ((int)0X864a),
        ProgramErrorPositionNv = ((int)0X864b),
        CurrentMatrixStackDepthNv = ((int)0X8640),
        Map1VertexAttrib44Nv = ((int)0X8664),
        Matrix6Nv = ((int)0X8636),
        VertexAttribArray2Nv = ((int)0X8652),
        Map2VertexAttrib04Nv = ((int)0X8670),
        Map1VertexAttrib94Nv = ((int)0X8669),
        AttribArrayPointerNv = ((int)0X8645),
        Map1VertexAttrib14Nv = ((int)0X8661),
        Map2VertexAttrib114Nv = ((int)0X867b),
        Map2VertexAttrib144Nv = ((int)0X867e),
        Map2VertexAttrib24Nv = ((int)0X8672),
        VertexProgramNv = ((int)0X8620),
        Matrix1Nv = ((int)0X8631),
        VertexStateProgramNv = ((int)0X8621),
        Map2VertexAttrib154Nv = ((int)0X867f),
        InverseTransposeNv = ((int)0X862d),
        VertexAttribArray0Nv = ((int)0X8650),
        VertexAttribArray15Nv = ((int)0X865f),
        Map1VertexAttrib64Nv = ((int)0X8666),
        TrackMatrixNv = ((int)0X8648),
        VertexAttribArray9Nv = ((int)0X8659),
        CurrentMatrixNv = ((int)0X8641),
        ProgramTargetNv = ((int)0X8646),
        MaxTrackMatrixStackDepthNv = ((int)0X862e),
        CurrentAttribNv = ((int)0X8626),
        VertexAttribArray4Nv = ((int)0X8654),
        Matrix0Nv = ((int)0X8630),
        Map2VertexAttrib74Nv = ((int)0X8677),
        InverseNv = ((int)0X862b),
        VertexAttribArray12Nv = ((int)0X865c),
        IdentityNv = ((int)0X862a),
        Map2VertexAttrib104Nv = ((int)0X867a),
        VertexAttribArray6Nv = ((int)0X8656),
        Map1VertexAttrib104Nv = ((int)0X866a),
        Map1VertexAttrib34Nv = ((int)0X8663),
        Map1VertexAttrib114Nv = ((int)0X866b),
        VertexAttribArray3Nv = ((int)0X8653),
        Map2VertexAttrib44Nv = ((int)0X8674),
        ProgramStringNv = ((int)0X8628),
        Matrix3Nv = ((int)0X8633),
        Map1VertexAttrib84Nv = ((int)0X8668),
        Map1VertexAttrib74Nv = ((int)0X8667),
        Map2VertexAttrib94Nv = ((int)0X8679),
        Map1VertexAttrib154Nv = ((int)0X866f),
        Map1VertexAttrib04Nv = ((int)0X8660),
        MaxTrackMatricesNv = ((int)0X862f),
        ModelviewProjectionNv = ((int)0X8629),
        Map2VertexAttrib14Nv = ((int)0X8671),
        Map1VertexAttrib124Nv = ((int)0X866c),
        AttribArrayTypeNv = ((int)0X8625),
        Matrix2Nv = ((int)0X8632),
        Map1VertexAttrib134Nv = ((int)0X866d),
    }

    public enum SgixScalebiasHint
    {
        ScalebiasHintSgix = ((int)0X8322),
    }

    public enum OmlInterlace
    {
        InterlaceOml = ((int)0X8980),
        InterlaceReadOml = ((int)0X8981),
    }

    public enum OmlSubsample
    {
        FormatSubsample2424Oml = ((int)0X8982),
        FormatSubsample244244Oml = ((int)0X8983),
    }

    public enum OmlResample
    {
        ResampleReplicateOml = ((int)0X8986),
        PackResampleOml = ((int)0X8984),
        ResampleZeroFillOml = ((int)0X8987),
        ResampleDecimateOml = ((int)0X8989),
        UnpackResampleOml = ((int)0X8985),
        ResampleAverageOml = ((int)0X8988),
    }

    public enum NvCopyDepthToColor
    {
        DepthStencilToRgbaNv = ((int)0X886e),
        DepthStencilToBgraNv = ((int)0X886f),
    }

    public enum AtiEnvmapBumpmap
    {
        DudvAti = ((int)0X8779),
        BumpEnvmapAti = ((int)0X877b),
        BumpTexUnitsAti = ((int)0X8778),
        BumpTargetAti = ((int)0X877c),
        BumpRotMatrixAti = ((int)0X8775),
        Du8dv8Ati = ((int)0X877a),
        BumpNumTexUnitsAti = ((int)0X8777),
        BumpRotMatrixSizeAti = ((int)0X8776),
    }

    public enum AtiFragmentShader
    {
        Con2Ati = ((int)0X8943),
        Dot4Ati = ((int)0X8967),
        FragmentShaderAti = ((int)0X8920),
        Con4Ati = ((int)0X8945),
        Con17Ati = ((int)0X8952),
        Reg25Ati = ((int)0X893a),
        Reg30Ati = ((int)0X893f),
        Con20Ati = ((int)0X8955),
        Reg19Ati = ((int)0X8934),
        LerpAti = ((int)0X8969),
        Con21Ati = ((int)0X8956),
        Reg8Ati = ((int)0X8929),
        Reg12Ati = ((int)0X892d),
        Con12Ati = ((int)0X894d),
        Con28Ati = ((int)0X895d),
        Reg11Ati = ((int)0X892c),
        Reg26Ati = ((int)0X893b),
        Reg31Ati = ((int)0X8940),
        Dot2AddAti = ((int)0X896c),
        NumInputInterpolatorComponentsAti = ((int)0X8973),
        Reg5Ati = ((int)0X8926),
        Con29Ati = ((int)0X895e),
        NumInstructionsPerPassAti = ((int)0X8971),
        Con10Ati = ((int)0X894b),
        Con22Ati = ((int)0X8957),
        SwizzleStrqAti = ((int)0X897a),
        SwizzleStqAti = ((int)0X8977),
        AddAti = ((int)0X8963),
        Con6Ati = ((int)0X8947),
        Con1Ati = ((int)0X8942),
        Con11Ati = ((int)0X894c),
        Reg27Ati = ((int)0X893c),
        Dot3Ati = ((int)0X8966),
        Reg28Ati = ((int)0X893d),
        Con3Ati = ((int)0X8944),
        Con18Ati = ((int)0X8953),
        SwizzleStrqDqAti = ((int)0X897b),
        CompBitAti = ((int)0X00000002),
        Con23Ati = ((int)0X8958),
        Con5Ati = ((int)0X8946),
        Con19Ati = ((int)0X8954),
        SecondaryInterpolatorAti = ((int)0X896d),
        Reg13Ati = ((int)0X892e),
        Reg20Ati = ((int)0X8935),
        Con8Ati = ((int)0X8949),
        NumPassesAti = ((int)0X8970),
        Reg29Ati = ((int)0X893e),
        NegateBitAti = ((int)0X00000004),
        Reg2Ati = ((int)0X8923),
        Reg7Ati = ((int)0X8928),
        Reg9Ati = ((int)0X892a),
        GreenBitAti = ((int)0X00000002),
        Reg14Ati = ((int)0X892f),
        Reg0Ati = ((int)0X8921),
        Cnd0Ati = ((int)0X896b),
        SwizzleStrDrAti = ((int)0X8978),
        Reg15Ati = ((int)0X8930),
        Con13Ati = ((int)0X894e),
        Reg21Ati = ((int)0X8936),
        Reg6Ati = ((int)0X8927),
        SubAti = ((int)0X8965),
        Con24Ati = ((int)0X8959),
        Con25Ati = ((int)0X895a),
        MadAti = ((int)0X8968),
        SaturateBitAti = ((int)0X00000040),
        MulAti = ((int)0X8964),
        Con7Ati = ((int)0X8948),
        ColorAlphaPairingAti = ((int)0X8975),
        NumFragmentConstantsAti = ((int)0X896f),
        BlueBitAti = ((int)0X00000004),
        Con30Ati = ((int)0X895f),
        EighthBitAti = ((int)0X00000020),
        Reg16Ati = ((int)0X8931),
        MovAti = ((int)0X8961),
        Reg22Ati = ((int)0X8937),
        BiasBitAti = ((int)0X00000008),
        Con9Ati = ((int)0X894a),
        Con14Ati = ((int)0X894f),
        Con26Ati = ((int)0X895b),
        Con31Ati = ((int)0X8960),
        QuarterBitAti = ((int)0X00000010),
        NumFragmentRegistersAti = ((int)0X896e),
        SwizzleStqDqAti = ((int)0X8979),
        Con15Ati = ((int)0X8950),
        CndAti = ((int)0X896a),
        Reg18Ati = ((int)0X8933),
        Reg17Ati = ((int)0X8932),
        Reg23Ati = ((int)0X8938),
        NumLoopbackComponentsAti = ((int)0X8974),
        Reg4Ati = ((int)0X8925),
        Reg3Ati = ((int)0X8924),
        Con27Ati = ((int)0X895c),
        Gl8XBitAti = ((int)0X00000004),
        NumInstructionsTotalAti = ((int)0X8972),
        HalfBitAti = ((int)0X00000008),
        Reg1Ati = ((int)0X8922),
        SwizzleStrAti = ((int)0X8976),
        Con16Ati = ((int)0X8951),
        Reg24Ati = ((int)0X8939),
        Gl4XBitAti = ((int)0X00000002),
        Con0Ati = ((int)0X8941),
        Gl2XBitAti = ((int)0X00000001),
        Reg10Ati = ((int)0X892b),
        RedBitAti = ((int)0X00000001),
    }

    public enum AtiPnTriangles
    {
        MaxPnTrianglesTesselationLevelAti = ((int)0X87f1),
        PnTrianglesTesselationLevelAti = ((int)0X87f4),
        PnTrianglesNormalModeQuadraticAti = ((int)0X87f8),
        PnTrianglesAti = ((int)0X87f0),
        PnTrianglesPointModeCubicAti = ((int)0X87f6),
        PnTrianglesNormalModeLinearAti = ((int)0X87f7),
        PnTrianglesPointModeLinearAti = ((int)0X87f5),
        PnTrianglesNormalModeAti = ((int)0X87f3),
        PnTrianglesPointModeAti = ((int)0X87f2),
    }

    public enum AtiVertexArrayObject
    {
        DiscardAti = ((int)0X8763),
        DynamicAti = ((int)0X8761),
        ArrayObjectBufferAti = ((int)0X8766),
        PreserveAti = ((int)0X8762),
        StaticAti = ((int)0X8760),
        ObjectBufferUsageAti = ((int)0X8765),
        ObjectBufferSizeAti = ((int)0X8764),
        ArrayObjectOffsetAti = ((int)0X8767),
    }

    public enum ExtVertexShader
    {
        LocalConstantValueExt = ((int)0X87ec),
        OutputTextureCoord1Ext = ((int)0X879e),
        VertexShaderVariantsExt = ((int)0X87d0),
        OutputColor0Ext = ((int)0X879b),
        OpMaxExt = ((int)0X878a),
        OutputTextureCoord9Ext = ((int)0X87a6),
        VertexShaderBindingExt = ((int)0X8781),
        LocalExt = ((int)0X87c4),
        YExt = ((int)0X87d6),
        VertexShaderLocalsExt = ((int)0X87d3),
        MaxOptimizedVertexShaderInstructionsExt = ((int)0X87ca),
        MvpMatrixExt = ((int)0X87e3),
        OutputTextureCoord6Ext = ((int)0X87a3),
        OpCrossProductExt = ((int)0X8797),
        OpRoundExt = ((int)0X8790),
        OpMulExt = ((int)0X8786),
        LocalConstantExt = ((int)0X87c3),
        VariantDatatypeExt = ((int)0X87e5),
        OpMultiplyMatrixExt = ((int)0X8798),
        OutputTextureCoord7Ext = ((int)0X87a4),
        NegativeWExt = ((int)0X87dc),
        MaxVertexShaderLocalConstantsExt = ((int)0X87c8),
        OpClampExt = ((int)0X878e),
        NegativeOneExt = ((int)0X87df),
        OpLogBase2Ext = ((int)0X8792),
        OutputTextureCoord16Ext = ((int)0X87ad),
        ZeroExt = ((int)0X87dd),
        ZExt = ((int)0X87d7),
        OutputTextureCoord20Ext = ((int)0X87b1),
        OpSetLtExt = ((int)0X878d),
        OutputTextureCoord29Ext = ((int)0X87ba),
        OutputTextureCoord11Ext = ((int)0X87a8),
        FullRangeExt = ((int)0X87e1),
        OutputTextureCoord4Ext = ((int)0X87a1),
        MaxVertexShaderInstructionsExt = ((int)0X87c5),
        OutputTextureCoord30Ext = ((int)0X87bb),
        MatrixExt = ((int)0X87c0),
        InvariantDatatypeExt = ((int)0X87eb),
        OutputVertexExt = ((int)0X879a),
        OpFracExt = ((int)0X8789),
        OutputTextureCoord24Ext = ((int)0X87b5),
        VariantValueExt = ((int)0X87e4),
        OpMinExt = ((int)0X878b),
        OpFloorExt = ((int)0X878f),
        OpSubExt = ((int)0X8796),
        VertexShaderExt = ((int)0X8780),
        OutputTextureCoord5Ext = ((int)0X87a2),
        VertexShaderInvariantsExt = ((int)0X87d1),
        OutputTextureCoord18Ext = ((int)0X87af),
        OutputColor1Ext = ((int)0X879c),
        MaxVertexShaderInvariantsExt = ((int)0X87c7),
        VertexShaderInstructionsExt = ((int)0X87cf),
        VertexShaderLocalConstantsExt = ((int)0X87d2),
        OpIndexExt = ((int)0X8782),
        MaxOptimizedVertexShaderLocalConstantsExt = ((int)0X87cc),
        OutputTextureCoord13Ext = ((int)0X87aa),
        MaxOptimizedVertexShaderInvariantsExt = ((int)0X87cd),
        MaxOptimizedVertexShaderLocalsExt = ((int)0X87ce),
        VertexShaderOptimizedExt = ((int)0X87d4),
        OutputTextureCoord15Ext = ((int)0X87ac),
        MaxVertexShaderVariantsExt = ((int)0X87c6),
        InvariantExt = ((int)0X87c2),
        OutputTextureCoord26Ext = ((int)0X87b7),
        OutputTextureCoord10Ext = ((int)0X87a7),
        OutputTextureCoord25Ext = ((int)0X87b6),
        OutputFogExt = ((int)0X87bd),
        MaxVertexShaderLocalsExt = ((int)0X87c9),
        OutputTextureCoord21Ext = ((int)0X87b2),
        OneExt = ((int)0X87de),
        OpDot3Ext = ((int)0X8784),
        VariantArrayPointerExt = ((int)0X87e9),
        NormalizedRangeExt = ((int)0X87e0),
        VariantArrayTypeExt = ((int)0X87e7),
        OpExpBase2Ext = ((int)0X8791),
        OutputTextureCoord3Ext = ((int)0X87a0),
        OutputTextureCoord2Ext = ((int)0X879f),
        OpDot4Ext = ((int)0X8785),
        OutputTextureCoord31Ext = ((int)0X87bc),
        OpMovExt = ((int)0X8799),
        WExt = ((int)0X87d8),
        OutputTextureCoord22Ext = ((int)0X87b3),
        OpMaddExt = ((int)0X8788),
        NegativeXExt = ((int)0X87d9),
        VariantArrayExt = ((int)0X87e8),
        InvariantValueExt = ((int)0X87ea),
        OpAddExt = ((int)0X8787),
        OpRecipSqrtExt = ((int)0X8795),
        LocalConstantDatatypeExt = ((int)0X87ed),
        OpNegateExt = ((int)0X8783),
        NegativeYExt = ((int)0X87da),
        OutputTextureCoord0Ext = ((int)0X879d),
        OutputTextureCoord27Ext = ((int)0X87b8),
        MaxOptimizedVertexShaderVariantsExt = ((int)0X87cb),
        OutputTextureCoord28Ext = ((int)0X87b9),
        OutputTextureCoord17Ext = ((int)0X87ae),
        OpPowerExt = ((int)0X8793),
        OutputTextureCoord19Ext = ((int)0X87b0),
        OutputTextureCoord8Ext = ((int)0X87a5),
        VariantExt = ((int)0X87c1),
        CurrentVertexExt = ((int)0X87e2),
        VariantArrayStrideExt = ((int)0X87e6),
        NegativeZExt = ((int)0X87db),
        OutputTextureCoord12Ext = ((int)0X87a9),
        XExt = ((int)0X87d5),
        OpRecipExt = ((int)0X8794),
        OpSetGeExt = ((int)0X878c),
        ScalarExt = ((int)0X87be),
        OutputTextureCoord23Ext = ((int)0X87b4),
        OutputTextureCoord14Ext = ((int)0X87ab),
        VectorExt = ((int)0X87bf),
    }

    public enum AtiVertexStreams
    {
        VertexStream2Ati = ((int)0X876e),
        VertexStream5Ati = ((int)0X8771),
        VertexSourceAti = ((int)0X8774),
        VertexStream0Ati = ((int)0X876c),
        VertexStream3Ati = ((int)0X876f),
        VertexStream6Ati = ((int)0X8772),
        MaxVertexStreamsAti = ((int)0X876b),
        VertexStream1Ati = ((int)0X876d),
        VertexStream4Ati = ((int)0X8770),
        VertexStream7Ati = ((int)0X8773),
    }

    public enum AtiElementArray
    {
        ElementArrayTypeAti = ((int)0X8769),
        ElementArrayAti = ((int)0X8768),
        ElementArrayPointerAti = ((int)0X876a),
    }

    public enum SunMeshArray
    {
        QuadMeshSun = ((int)0X8614),
        TriangleMeshSun = ((int)0X8615),
    }

    public enum SunSliceAccum
    {
        SliceAccumSun = ((int)0X85cc),
    }

    public enum NvMultisampleFilterHint
    {
        MultisampleFilterHintNv = ((int)0X8534),
    }

    public enum NvDepthClamp
    {
        DepthClampNv = ((int)0X864f),
    }

    public enum NvOcclusionQuery
    {
        PixelCounterBitsNv = ((int)0X8864),
        PixelCountNv = ((int)0X8866),
        CurrentOcclusionQueryIdNv = ((int)0X8865),
        PixelCountAvailableNv = ((int)0X8867),
    }

    public enum NvPointSprite
    {
        CoordReplaceNv = ((int)0X8862),
        PointSpriteRModeNv = ((int)0X8863),
        PointSpriteNv = ((int)0X8861),
    }

    public enum NvTextureShader3
    {
        DependentRgbTextureCubeMapNv = ((int)0X885a),
        OffsetHiloProjectiveTexture2DNv = ((int)0X8856),
        OffsetHiloTextureRectangleNv = ((int)0X8855),
        SignedHilo8Nv = ((int)0X885f),
        DotProductAffineDepthReplaceNv = ((int)0X885d),
        DotProductTexture1DNv = ((int)0X885c),
        OffsetProjectiveTextureRectangleScaleNv = ((int)0X8853),
        OffsetProjectiveTexture2DNv = ((int)0X8850),
        OffsetHiloTexture2DNv = ((int)0X8854),
        DependentRgbTexture3DNv = ((int)0X8859),
        OffsetProjectiveTextureRectangleNv = ((int)0X8852),
        OffsetProjectiveTexture2DScaleNv = ((int)0X8851),
        DotProductPassThroughNv = ((int)0X885b),
        Hilo8Nv = ((int)0X885e),
        OffsetHiloProjectiveTextureRectangleNv = ((int)0X8857),
        ForceBlueToOneNv = ((int)0X8860),
        DependentHiloTexture2DNv = ((int)0X8858),
    }

    public enum NvVertexProgram11
    {
    }

    public enum ExtShadowFuncs
    {
    }

    public enum ExtStencilTwoSide
    {
        StencilTestTwoSideExt = ((int)0X8910),
        ActiveStencilFaceExt = ((int)0X8911),
    }

    public enum AtiTextFragmentShader
    {
        TextFragmentShaderAti = ((int)0X8200),
    }

    public enum AppleClientStorage
    {
        UnpackClientStorageApple = ((int)0X85b2),
    }

    public enum AppleElementArray
    {
        ElementArrayPointerApple = ((int)0X876a),
        ElementArrayTypeApple = ((int)0X8769),
        ElementArrayApple = ((int)0X8768),
    }

    public enum AppleFence
    {
        FenceApple = ((int)0X8a0b),
        DrawPixelsApple = ((int)0X8a0a),
    }

    public enum AppleVertexArrayObject
    {
        VertexArrayBindingApple = ((int)0X85b5),
    }

    public enum AppleVertexArrayRange
    {
        VertexArrayRangePointerApple = ((int)0X8521),
        VertexArrayRangeLengthApple = ((int)0X851e),
        VertexArrayRangeApple = ((int)0X851d),
        StorageCachedApple = ((int)0X85be),
        StorageSharedApple = ((int)0X85bf),
        VertexArrayStorageHintApple = ((int)0X851f),
    }

    public enum AppleYcbcr422
    {
        UnsignedShort88Apple = ((int)0X85ba),
        UnsignedShort88RevApple = ((int)0X85bb),
        Ycbcr422Apple = ((int)0X85b9),
    }

    public enum S3S3tc
    {
        Rgba4S3tc = ((int)0X83a3),
        RgbS3tc = ((int)0X83a0),
        Rgb4S3tc = ((int)0X83a1),
        RgbaS3tc = ((int)0X83a2),
    }

    public enum AtiDrawBuffers
    {
        DrawBuffer2Ati = ((int)0X8827),
        DrawBuffer0Ati = ((int)0X8825),
        DrawBuffer7Ati = ((int)0X882c),
        DrawBuffer12Ati = ((int)0X8831),
        DrawBuffer6Ati = ((int)0X882b),
        DrawBuffer9Ati = ((int)0X882e),
        MaxDrawBuffersAti = ((int)0X8824),
        DrawBuffer1Ati = ((int)0X8826),
        DrawBuffer4Ati = ((int)0X8829),
        DrawBuffer8Ati = ((int)0X882d),
        DrawBuffer14Ati = ((int)0X8833),
        DrawBuffer15Ati = ((int)0X8834),
        DrawBuffer11Ati = ((int)0X8830),
        DrawBuffer10Ati = ((int)0X882f),
        DrawBuffer3Ati = ((int)0X8828),
        DrawBuffer5Ati = ((int)0X882a),
        DrawBuffer13Ati = ((int)0X8832),
    }

    public enum AtiPixelFormatFloat
    {
        TypeRgbaFloatAti = ((int)0X8820),
        ColorClearUnclampedValueAti = ((int)0X8835),
    }

    public enum AtiTextureEnvCombine3
    {
        ModulateSignedAddAti = ((int)0X8745),
        ModulateSubtractAti = ((int)0X8746),
        ModulateAddAti = ((int)0X8744),
    }

    public enum AtiTextureFloat
    {
        IntensityFloat32Ati = ((int)0X8817),
        LuminanceFloat32Ati = ((int)0X8818),
        RgbaFloat32Ati = ((int)0X8814),
        LuminanceFloat16Ati = ((int)0X881e),
        RgbFloat32Ati = ((int)0X8815),
        LuminanceAlphaFloat32Ati = ((int)0X8819),
        AlphaFloat32Ati = ((int)0X8816),
        RgbaFloat16Ati = ((int)0X881a),
        AlphaFloat16Ati = ((int)0X881c),
        LuminanceAlphaFloat16Ati = ((int)0X881f),
        IntensityFloat16Ati = ((int)0X881d),
        RgbFloat16Ati = ((int)0X881b),
    }

    public enum NvFloatBuffer
    {
        FloatRgNv = ((int)0X8881),
        FloatR16Nv = ((int)0X8884),
        TextureFloatComponentsNv = ((int)0X888c),
        FloatRNv = ((int)0X8880),
        FloatRgbaNv = ((int)0X8883),
        FloatClearColorValueNv = ((int)0X888d),
        FloatR32Nv = ((int)0X8885),
        FloatRgbaModeNv = ((int)0X888e),
        FloatRgba16Nv = ((int)0X888a),
        FloatRgb32Nv = ((int)0X8889),
        FloatRgb16Nv = ((int)0X8888),
        FloatRg16Nv = ((int)0X8886),
        FloatRgba32Nv = ((int)0X888b),
        FloatRgbNv = ((int)0X8882),
        FloatRg32Nv = ((int)0X8887),
    }

    public enum NvFragmentProgram
    {
        ProgramErrorStringNv = ((int)0X8874),
        FragmentProgramNv = ((int)0X8870),
        MaxFragmentProgramLocalParametersNv = ((int)0X8868),
        FragmentProgramBindingNv = ((int)0X8873),
        MaxTextureImageUnitsNv = ((int)0X8872),
        MaxTextureCoordsNv = ((int)0X8871),
    }

    public enum NvHalfFloat
    {
        HalfFloatNv = ((int)0X140b),
    }

    public enum NvPixelDataRange
    {
        ReadPixelDataRangeLengthNv = ((int)0X887b),
        ReadPixelDataRangeNv = ((int)0X8879),
        WritePixelDataRangeLengthNv = ((int)0X887a),
        ReadPixelDataRangePointerNv = ((int)0X887d),
        WritePixelDataRangePointerNv = ((int)0X887c),
        WritePixelDataRangeNv = ((int)0X8878),
    }

    public enum NvPrimitiveRestart
    {
        PrimitiveRestartIndexNv = ((int)0X8559),
        PrimitiveRestartNv = ((int)0X8558),
    }

    public enum NvTextureExpandNormal
    {
        TextureUnsignedRemapModeNv = ((int)0X888f),
    }

    public enum NvVertexProgram2
    {
    }

    public enum AtiMapObjectBuffer
    {
    }

    public enum AtiSeparateStencil
    {
        StencilBackPassDepthPassAti = ((int)0X8803),
        StencilBackFailAti = ((int)0X8801),
        StencilBackPassDepthFailAti = ((int)0X8802),
        StencilBackFuncAti = ((int)0X8800),
    }

    public enum AtiVertexAttribArrayObject
    {
    }

    public enum OesReadFormat
    {
        ImplementationColorReadFormatOes = ((int)0X8b9b),
        ImplementationColorReadTypeOes = ((int)0X8b9a),
    }

    public enum ExtDepthBoundsTest
    {
        DepthBoundsTestExt = ((int)0X8890),
        DepthBoundsExt = ((int)0X8891),
    }

    public enum ExtTextureMirrorClamp
    {
        MirrorClampExt = ((int)0X8742),
        MirrorClampToBorderExt = ((int)0X8912),
        MirrorClampToEdgeExt = ((int)0X8743),
    }

    public enum ExtBlendEquationSeparate
    {
        BlendEquationAlphaExt = ((int)0X883d),
        BlendEquationRgbExt = ((int)0X8009),
    }

    public enum MesaPackInvert
    {
        PackInvertMesa = ((int)0X8758),
    }

    public enum MesaYcbcrTexture
    {
        YcbcrMesa = ((int)0X8757),
        UnsignedShort88Mesa = ((int)0X85ba),
        UnsignedShort88RevMesa = ((int)0X85bb),
    }

    public enum ExtPixelBufferObject
    {
        PixelPackBufferBindingExt = ((int)0X88ed),
        PixelPackBufferExt = ((int)0X88eb),
        PixelUnpackBufferExt = ((int)0X88ec),
        PixelUnpackBufferBindingExt = ((int)0X88ef),
    }

    public enum NvFragmentProgramOption
    {
    }

    public enum NvFragmentProgram2
    {
        MaxProgramCallDepthNv = ((int)0X88f5),
        MaxProgramLoopCountNv = ((int)0X88f8),
        MaxProgramExecInstructionsNv = ((int)0X88f4),
        MaxProgramIfDepthNv = ((int)0X88f6),
        MaxProgramLoopDepthNv = ((int)0X88f7),
    }

    public enum NvVertexProgram2Option
    {
        MaxProgramCallDepthNv = ((int)0X88f5),
        MaxProgramExecInstructionsNv = ((int)0X88f4),
    }

    public enum NvVertexProgram3
    {
        MaxVertexTextureImageUnitsArb = ((int)0X8b4c),
    }

    public enum GenerateMipmapTarget
    {
        Texture1D = ((int)0X0de0),
        Texture3D = ((int)0X806f),
        TextureCubeMap = ((int)0X8513),
        Texture2D = ((int)0X0de1),
    }

    public enum FramebufferTarget
    {
        FramebufferExt = ((int)0X8d40),
    }

    public enum RenderbufferTarget
    {
        RenderbufferExt = ((int)0X8d41),
    }

    public enum RenderbufferStorage
    {
        StencilIndex4Ext = ((int)0X8d47),
        StencilIndex1Ext = ((int)0X8d46),
        StencilIndex16Ext = ((int)0X8d49),
        StencilIndex8Ext = ((int)0X8d48),
    }

    public enum FramebufferErrorCode
    {
        FramebufferIncompleteFormatsExt = ((int)0X8cda),
        FramebufferIncompleteMissingAttachmentExt = ((int)0X8cd7),
        FramebufferUnsupportedExt = ((int)0X8cdd),
        FramebufferIncompleteAttachmentExt = ((int)0X8cd6),
        FramebufferCompleteExt = ((int)0X8cd5),
        FramebufferIncompleteDimensionsExt = ((int)0X8cd9),
        FramebufferIncompleteReadBufferExt = ((int)0X8cdc),
        FramebufferIncompleteDrawBufferExt = ((int)0X8cdb),
    }

    public enum FramebufferAttachment
    {
        ColorAttachment11Ext = ((int)0X8ceb),
        ColorAttachment6Ext = ((int)0X8ce6),
        ColorAttachment8Ext = ((int)0X8ce8),
        ColorAttachment0Ext = ((int)0X8ce0),
        ColorAttachment3Ext = ((int)0X8ce3),
        ColorAttachment14Ext = ((int)0X8cee),
        ColorAttachment1Ext = ((int)0X8ce1),
        ColorAttachment4Ext = ((int)0X8ce4),
        ColorAttachment7Ext = ((int)0X8ce7),
        ColorAttachment9Ext = ((int)0X8ce9),
        ColorAttachment10Ext = ((int)0X8cea),
        DepthAttachmentExt = ((int)0X8d00),
        ColorAttachment2Ext = ((int)0X8ce2),
        ColorAttachment12Ext = ((int)0X8cec),
        ColorAttachment5Ext = ((int)0X8ce5),
        ColorAttachment15Ext = ((int)0X8cef),
        ColorAttachment13Ext = ((int)0X8ced),
        StencilAttachmentExt = ((int)0X8d20),
    }

    public enum FramebufferParameterName
    {
        FramebufferAttachmentObjectTypeExt = ((int)0X8cd0),
        FramebufferAttachmentTextureCubeMapFaceExt = ((int)0X8cd3),
        FramebufferAttachmentObjectNameExt = ((int)0X8cd1),
        FramebufferAttachmentTexture3DZoffsetExt = ((int)0X8cd4),
        FramebufferAttachmentTextureLevelExt = ((int)0X8cd2),
    }

    public enum RenderbufferParameterName
    {
        RenderbufferHeightExt = ((int)0X8d43),
        RenderbufferInternalFormatExt = ((int)0X8d44),
        RenderbufferAlphaSizeExt = ((int)0X8d53),
        RenderbufferRedSizeExt = ((int)0X8d50),
        RenderbufferBlueSizeExt = ((int)0X8d52),
        RenderbufferStencilSizeExt = ((int)0X8d55),
        RenderbufferWidthExt = ((int)0X8d42),
        RenderbufferDepthSizeExt = ((int)0X8d54),
        RenderbufferGreenSizeExt = ((int)0X8d51),
    }

    public enum GremedyStringMarker
    {
    }

    public enum ExtPackedDepthStencil
    {
        TextureStencilSizeExt = ((int)0X88f1),
        Depth24Stencil8Ext = ((int)0X88f0),
        DepthStencilExt = ((int)0X84f9),
        UnsignedInt248Ext = ((int)0X84fa),
    }

    public enum ExtStencilClearTag
    {
        StencilClearTagValueExt = ((int)0X88f3),
        StencilTagBitsExt = ((int)0X88f2),
    }

    public enum ExtTextureSrgb
    {
        Srgb8Alpha8Ext = ((int)0X8c43),
        Sluminance8Ext = ((int)0X8c47),
        Sluminance8Alpha8Ext = ((int)0X8c45),
        SluminanceExt = ((int)0X8c46),
        CompressedSluminanceAlphaExt = ((int)0X8c4b),
        CompressedSrgbAlphaExt = ((int)0X8c49),
        CompressedSrgbAlphaS3tcDxt5Ext = ((int)0X8c4f),
        Srgb8Ext = ((int)0X8c41),
        SrgbAlphaExt = ((int)0X8c42),
        CompressedSrgbAlphaS3tcDxt3Ext = ((int)0X8c4e),
        SluminanceAlphaExt = ((int)0X8c44),
        CompressedSluminanceExt = ((int)0X8c4a),
        SrgbExt = ((int)0X8c40),
        CompressedSrgbS3tcDxt1Ext = ((int)0X8c4c),
        CompressedSrgbExt = ((int)0X8c48),
        CompressedSrgbAlphaS3tcDxt1Ext = ((int)0X8c4d),
    }

    public enum ExtFramebufferBlit
    {
        DrawFramebufferBindingExt = ((int)0X8caa),
        ReadFramebufferExt = ((int)0X8ca8),
        ReadFramebufferBindingExt = ((int)0X8ca6),
        DrawFramebufferExt = ((int)0X8ca9),
    }

    public enum ExtFramebufferMultisample
    {
        FramebufferIncompleteMultisampleExt = ((int)0X8d56),
        RenderbufferSamplesExt = ((int)0X8cab),
        MaxSamplesExt = ((int)0X8d57),
    }

    public enum MesaxTextureStack
    {
        Texture2DStackMesax = ((int)0X875a),
        Texture2DStackBindingMesax = ((int)0X875e),
        ProxyTexture2DStackMesax = ((int)0X875c),
        Texture1DStackMesax = ((int)0X8759),
        Texture1DStackBindingMesax = ((int)0X875d),
        ProxyTexture1DStackMesax = ((int)0X875b),
    }

    public enum ExtTimerQuery
    {
        TimeElapsedExt = ((int)0X88bf),
    }

    public enum ExtGpuProgramParameters
    {
    }

    public enum AppleFlushBufferRange
    {
        BufferSerializedModifyApple = ((int)0X8a12),
        BufferFlushingUnmapApple = ((int)0X8a13),
    }

    public enum NvGpuProgram4
    {
        MaxProgramTexelOffsetNv = ((int)0X8905),
        MaxProgramAttribComponentsNv = ((int)0X8908),
        ProgramAttribComponentsNv = ((int)0X8906),
        MaxProgramGenericAttribsNv = ((int)0X8da5),
        ProgramResultComponentsNv = ((int)0X8907),
        MinProgramTexelOffsetNv = ((int)0X8904),
        MaxProgramResultComponentsNv = ((int)0X8909),
        MaxProgramGenericResultsNv = ((int)0X8da6),
    }

    public enum NvGeometryProgram4
    {
        FramebufferAttachmentTextureLayerExt = ((int)0X8cd4),
        LineStripAdjacencyExt = ((int)0X000b),
        FramebufferIncompleteLayerTargetsExt = ((int)0X8da8),
        FramebufferIncompleteLayerCountExt = ((int)0X8da9),
        GeometryProgramNv = ((int)0X8c26),
        GeometryVerticesOutExt = ((int)0X8dda),
        GeometryOutputTypeExt = ((int)0X8ddc),
        FramebufferAttachmentLayeredExt = ((int)0X8da7),
        LinesAdjacencyExt = ((int)0X000a),
        GeometryInputTypeExt = ((int)0X8ddb),
        MaxProgramOutputVerticesNv = ((int)0X8c27),
        MaxGeometryTextureImageUnitsExt = ((int)0X8c29),
        TrianglesAdjacencyExt = ((int)0X000c),
        ProgramPointSizeExt = ((int)0X8642),
        TriangleStripAdjacencyExt = ((int)0X000d),
        MaxProgramTotalOutputComponentsNv = ((int)0X8c28),
    }

    public enum ExtGeometryShader4
    {
        TriangleStripAdjacencyExt = ((int)0X000D),
        MaxGeometryUniformComponentsExt = ((int)0X8ddf),
        MaxGeometryTotalOutputComponentsExt = ((int)0X8de1),
        FramebufferAttachmentTextureLayerExt = ((int)0X8cd4),
        GeometryOutputTypeExt = ((int)0X8Ddc),
        FramebufferAttachmentLayeredExt = ((int)0X8Da7),
        TrianglesAdjacencyExt = ((int)0X000c),
        GeometryInputTypeExt = ((int)0X8Ddb),
        MaxGeometryOutputVerticesExt = ((int)0X8de0),
        GeometryShaderExt = ((int)0X8dd9),
        LineStripAdjacencyExt = ((int)0X000b),
        MaxVaryingComponentsExt = ((int)0X8b4b),
        FramebufferIncompleteLayerTargetsExt = ((int)0X8Da8),
        MaxVertexVaryingComponentsExt = ((int)0X8dde),
        MaxGeometryTextureImageUnitsExt = ((int)0X8c29),
        MaxGeometryVaryingComponentsExt = ((int)0X8ddd),
        ProgramPointSizeExt = ((int)0X8642),
        FramebufferIncompleteLayerCountExt = ((int)0X8Da9),
        LinesAdjacencyExt = ((int)0X000a),
        GeometryVerticesOutExt = ((int)0X8Dda),
    }

    public enum NvVertexProgram4
    {
        VertexAttribArrayIntegerNv = ((int)0X88fd),
    }

    public enum ExtGpuShader4
    {
        SamplerCubeShadowExt = ((int)0X8dc5),
        UnsignedIntSampler1DExt = ((int)0X8dd1),
        UnsignedIntVec2Ext = ((int)0X8dc6),
        UnsignedIntSamplerBufferExt = ((int)0X8dd8),
        UnsignedIntSampler2DRectExt = ((int)0X8dd5),
        IntSampler2DExt = ((int)0X8dca),
        UnsignedIntVec4Ext = ((int)0X8dc8),
        Sampler1DArrayExt = ((int)0X8dc0),
        IntSampler3DExt = ((int)0X8dcb),
        UnsignedIntVec3Ext = ((int)0X8dc7),
        IntSampler2DArrayExt = ((int)0X8dcf),
        SamplerBufferExt = ((int)0X8dc2),
        UnsignedIntSampler2DArrayExt = ((int)0X8dd7),
        Sampler2DArrayExt = ((int)0X8dc1),
        IntSampler1DExt = ((int)0X8dc9),
        IntSampler2DRectExt = ((int)0X8dcd),
        Sampler2DArrayShadowExt = ((int)0X8dc4),
        UnsignedIntSamplerCubeExt = ((int)0X8dd4),
        UnsignedIntSampler2DExt = ((int)0X8dd2),
        UnsignedIntSampler1DArrayExt = ((int)0X8dd6),
        Sampler1DArrayShadowExt = ((int)0X8dc3),
        UnsignedIntSampler3DExt = ((int)0X8dd3),
        IntSamplerBufferExt = ((int)0X8dd0),
        IntSampler1DArrayExt = ((int)0X8dce),
        IntSamplerCubeExt = ((int)0X8dcc),
    }

    public enum ExtDrawInstanced
    {
    }

    public enum ExtPackedFloat
    {
        RgbaSignedComponentsExt = ((int)0X8c3c),
        R11fG11fB10fExt = ((int)0X8c3a),
        UnsignedInt10F11F11FRevExt = ((int)0X8c3b),
    }

    public enum ExtTextureArray
    {
        FramebufferAttachmentTextureLayerExt = ((int)0X8cd4),
        ProxyTexture1DArrayExt = ((int)0X8c19),
        Texture2DArrayExt = ((int)0X8c1a),
        ProxyTexture2DArrayExt = ((int)0X8c1b),
        TextureBinding1DArrayExt = ((int)0X8c1c),
        MaxArrayTextureLayersExt = ((int)0X88ff),
        Texture1DArrayExt = ((int)0X8c18),
        CompareRefDepthToTextureExt = ((int)0X884e),
        TextureBinding2DArrayExt = ((int)0X8c1d),
    }

    public enum ExtTextureBufferObject
    {
        TextureBufferExt = ((int)0X8c2a),
        TextureBufferDataStoreBindingExt = ((int)0X8c2d),
        TextureBindingBufferExt = ((int)0X8c2c),
        TextureBufferFormatExt = ((int)0X8c2e),
        MaxTextureBufferSizeExt = ((int)0X8c2b),
    }

    public enum ExtTextureCompressionLatc
    {
        CompressedLuminanceLatc1Ext = ((int)0X8c70),
        CompressedSignedLuminanceLatc1Ext = ((int)0X8c71),
        CompressedSignedLuminanceAlphaLatc2Ext = ((int)0X8c73),
        CompressedLuminanceAlphaLatc2Ext = ((int)0X8c72),
    }

    public enum ExtTextureCompressionRgtc
    {
        CompressedSignedRedGreenRgtc2Ext = ((int)0X8dbe),
        CompressedRedRgtc1Ext = ((int)0X8dbb),
        CompressedRedGreenRgtc2Ext = ((int)0X8dbd),
        CompressedSignedRedRgtc1Ext = ((int)0X8dbc),
    }

    public enum ExtTextureSharedExponent
    {
        Rgb9E5Ext = ((int)0X8c3d),
        TextureSharedSizeExt = ((int)0X8c3f),
        UnsignedInt5999RevExt = ((int)0X8c3e),
    }

    public enum NvDepthBufferFloat
    {
        DepthComponent32fNv = ((int)0X8dab),
        DepthBufferFloatModeNv = ((int)0X8daf),
        Float32UnsignedInt248RevNv = ((int)0X8dad),
        Depth32fStencil8Nv = ((int)0X8dac),
    }

    public enum NvFragmentProgram4
    {
    }

    public enum NvFramebufferMultisampleCoverage
    {
        RenderbufferColorSamplesNv = ((int)0X8e10),
        MultisampleCoverageModesNv = ((int)0X8e12),
        MaxMultisampleCoverageModesNv = ((int)0X8e11),
        RenderbufferCoverageSamplesNv = ((int)0X8cab),
    }

    public enum ExtFramebufferSrgb
    {
        FramebufferSrgbExt = ((int)0X8db9),
        FramebufferSrgbCapableExt = ((int)0X8dba),
    }

    public enum NvGeometryShader4
    {
    }

    public enum NvParameterBufferObject
    {
        VertexProgramParameterBufferNv = ((int)0X8da2),
        FragmentProgramParameterBufferNv = ((int)0X8da4),
        MaxProgramParameterBufferSizeNv = ((int)0X8da1),
        GeometryProgramParameterBufferNv = ((int)0X8da3),
        MaxProgramParameterBufferBindingsNv = ((int)0X8da0),
    }

    public enum ExtDrawBuffers2
    {
    }

    public enum NvTransformFeedback
    {
        MaxTransformFeedbackSeparateAttribsNv = ((int)0X8c8b),
        ActiveVaryingMaxLengthNv = ((int)0X8c82),
        VertexIdNv = ((int)0X8c7b),
        SeparateAttribsNv = ((int)0X8c8d),
        MaxTransformFeedbackSeparateComponentsNv = ((int)0X8c80),
        TransformFeedbackBufferModeNv = ((int)0X8c7f),
        TransformFeedbackBufferNv = ((int)0X8c8e),
        BackSecondaryColorNv = ((int)0X8c78),
        TransformFeedbackBufferBindingNv = ((int)0X8c8f),
        TransformFeedbackVaryingsNv = ((int)0X8c83),
        RasterizerDiscardNv = ((int)0X8c89),
        TransformFeedbackBufferStartNv = ((int)0X8c84),
        InterleavedAttribsNv = ((int)0X8c8c),
        TransformFeedbackBufferSizeNv = ((int)0X8c85),
        TransformFeedbackRecordNv = ((int)0X8c86),
        PrimitiveIdNv = ((int)0X8c7c),
        PrimitivesGeneratedNv = ((int)0X8c87),
        TransformFeedbackAttribsNv = ((int)0X8c7e),
        ActiveVaryingsNv = ((int)0X8c81),
        TextureCoordNv = ((int)0X8c79),
        MaxTransformFeedbackInterleavedAttribsNv = ((int)0X8c8a),
        BackPrimaryColorNv = ((int)0X8c77),
        TransformFeedbackPrimitivesWrittenNv = ((int)0X8c88),
        GenericAttribNv = ((int)0X8c7d),
        ClipDistanceNv = ((int)0X8c7a),
    }

    public enum ExtBindableUniform
    {
        MaxGeometryBindableUniformsExt = ((int)0X8de4),
        UniformBufferExt = ((int)0X8dee),
        MaxFragmentBindableUniformsExt = ((int)0X8de3),
        MaxVertexBindableUniformsExt = ((int)0X8de2),
        UniformBufferBindingExt = ((int)0X8def),
        MaxBindableUniformSizeExt = ((int)0X8ded),
    }

    public enum ExtTextureInteger
    {
        Rgb8uiExt = ((int)0X8d7d),
        Rgba32iExt = ((int)0X8d82),
        Luminance16uiExt = ((int)0X8d7a),
        LuminanceAlpha32iExt = ((int)0X8d87),
        Intensity8iExt = ((int)0X8d91),
        Alpha32iExt = ((int)0X8d84),
        Intensity16uiExt = ((int)0X8d79),
        Rgba16uiExt = ((int)0X8d76),
        BgrIntegerExt = ((int)0X8d9a),
        BlueIntegerExt = ((int)0X8d96),
        Alpha32uiExt = ((int)0X8d72),
        Rgb32uiExt = ((int)0X8d71),
        BgraIntegerExt = ((int)0X8d9b),
        Rgba8iExt = ((int)0X8d8e),
        Rgb8iExt = ((int)0X8d8f),
        LuminanceAlpha8iExt = ((int)0X8d93),
        Luminance32iExt = ((int)0X8d86),
        RgbaIntegerExt = ((int)0X8d99),
        LuminanceAlpha32uiExt = ((int)0X8d75),
        Luminance8uiExt = ((int)0X8d80),
        Rgb16iExt = ((int)0X8d89),
        AlphaIntegerExt = ((int)0X8d97),
        Alpha8iExt = ((int)0X8d90),
        Luminance32uiExt = ((int)0X8d74),
        Luminance16iExt = ((int)0X8d8c),
        Alpha16uiExt = ((int)0X8d78),
        Rgba16iExt = ((int)0X8d88),
        Intensity32uiExt = ((int)0X8d73),
        LuminanceAlpha16iExt = ((int)0X8d8d),
        LuminanceAlpha16uiExt = ((int)0X8d7b),
        Rgb32iExt = ((int)0X8d83),
        RgbIntegerExt = ((int)0X8d98),
        Rgba8uiExt = ((int)0X8d7c),
        LuminanceAlphaIntegerExt = ((int)0X8d9d),
        GreenIntegerExt = ((int)0X8d95),
        Intensity8uiExt = ((int)0X8d7f),
        Intensity32iExt = ((int)0X8d85),
        LuminanceIntegerExt = ((int)0X8d9c),
        Luminance8iExt = ((int)0X8d92),
        Alpha8uiExt = ((int)0X8d7e),
        Rgba32uiExt = ((int)0X8d70),
        RedIntegerExt = ((int)0X8d94),
        RgbaIntegerModeExt = ((int)0X8d9e),
        LuminanceAlpha8uiExt = ((int)0X8d81),
        Alpha16iExt = ((int)0X8d8a),
        Intensity16iExt = ((int)0X8d8b),
        Rgb16uiExt = ((int)0X8d77),
    }

}
